LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
ENTITY sdmemory IS
PORT ( 	KEY : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
		pll_50MHz : IN STD_LOGIC;
		pll_50MHz_min3 : IN STD_LOGIC;
		VGA_INT : IN STD_LOGIC;
		NIOS_R : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		NIOS_G : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		NIOS_B : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		DRAM_CLK, DRAM_CKE : OUT STD_LOGIC;
		DRAM_ADDR : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);
		DRAM_BA_1, DRAM_BA_0 : BUFFER STD_LOGIC;
		DRAM_CS_N, DRAM_CAS_N, DRAM_RAS_N, DRAM_WE_N : OUT STD_LOGIC;
		DRAM_DQ : INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		DRAM_UDQM, DRAM_LDQM : BUFFER STD_LOGIC );
END sdmemory;

ARCHITECTURE Structure OF sdmemory IS
COMPONENT nios_system
PORT ( 	clk : IN STD_LOGIC;
		reset_n : IN STD_LOGIC;
		in_port_to_the_VGA_INT : IN STD_LOGIC;
		out_port_from_the_NIOS_B : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		out_port_from_the_NIOS_G : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		out_port_from_the_NIOS_R : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);
		zs_ba_from_the_sdram : BUFFER STD_LOGIC_VECTOR(1 DOWNTO 0);
		zs_cas_n_from_the_sdram : OUT STD_LOGIC;
		zs_cke_from_the_sdram : OUT STD_LOGIC;
		zs_cs_n_from_the_sdram : OUT STD_LOGIC;
		zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		zs_dqm_from_the_sdram : BUFFER STD_LOGIC_VECTOR(1 DOWNTO 0);
		zs_ras_n_from_the_sdram : OUT STD_LOGIC;
		zs_we_n_from_the_sdram : OUT STD_LOGIC );
END COMPONENT;

--				signal LCD_E_from_the_lcd_0 :  STD_LOGIC;
--                signal LCD_RS_from_the_lcd_0 :  STD_LOGIC;
--                signal LCD_RW_from_the_lcd_0 :  STD_LOGIC;
--                signal LCD_data_to_and_from_the_lcd_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                signal in_port_to_the_VGA_INT :  STD_LOGIC;
--                
                
SIGNAL BA : STD_LOGIC_VECTOR(1 DOWNTO 0);
SIGNAL DQM : STD_LOGIC_VECTOR(1 DOWNTO 0);

-- This signal is used to connect the unmodified clock signal c1 from the PLL to the NIOS II system
--SIGNAL pll_50MHz 		: STD_LOGIC;
--SIGNAL pll_50MHz_MIN3 	: STD_LOGIC;

BEGIN
DRAM_BA_1 <= BA(1); 
DRAM_BA_0 <= BA(0);
DRAM_UDQM <= DQM(1); 
DRAM_LDQM <= DQM(0);

-- Instantiate the Nios II system entity generated by the SOPC Builder.
NiosII: nios_system PORT MAP (	pll_50MHz, 
								KEY(0),
								VGA_INT, 
								NIOS_B,
								NIOS_G,
								NIOS_R,
								DRAM_ADDR, 
								BA, 
								DRAM_CAS_N, 
								DRAM_CKE, 
								DRAM_CS_N,
								DRAM_DQ, 
								DQM, 
								DRAM_RAS_N, 
								DRAM_WE_N );
					
					DRAM_CLK <= pll_50MHz_MIN3;




END Structure;
