--Legal Notice: (C)2010 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cf_0 is 
        port (
              -- inputs:
                 signal av_ctl_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal av_ctl_chipselect_n : IN STD_LOGIC;
                 signal av_ctl_read_n : IN STD_LOGIC;
                 signal av_ctl_write_n : IN STD_LOGIC;
                 signal av_ctl_writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal av_ide_address : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal av_ide_chipselect_n : IN STD_LOGIC;
                 signal av_ide_read_n : IN STD_LOGIC;
                 signal av_ide_write_n : IN STD_LOGIC;
                 signal av_ide_writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal av_reset_n : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal detect_n : IN STD_LOGIC;
                 signal intrq : IN STD_LOGIC;
                 signal iordy : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal addr : OUT STD_LOGIC_VECTOR (10 DOWNTO 0);
                 signal atasel_n : OUT STD_LOGIC;
                 signal av_ctl_irq : OUT STD_LOGIC;
                 signal av_ctl_readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal av_ide_irq : OUT STD_LOGIC;
                 signal av_ide_readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cs_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal data_cf : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal iord_n : OUT STD_LOGIC;
                 signal iowr_n : OUT STD_LOGIC;
                 signal power : OUT STD_LOGIC;
                 signal reset_n_cf : OUT STD_LOGIC;
                 signal rfu : OUT STD_LOGIC;
                 signal we_n : OUT STD_LOGIC
              );
end entity cf_0;


architecture europa of cf_0 is
                signal ctl_hi_write_strobe :  STD_LOGIC;
                signal ctl_irq_en_reg :  STD_LOGIC;
                signal ctl_lo_read_strobe :  STD_LOGIC;
                signal ctl_lo_write_strobe :  STD_LOGIC;
                signal ctl_read_mux :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal d1_present_reg :  STD_LOGIC;
                signal ide_irq_en_reg :  STD_LOGIC;
                signal power_reg :  STD_LOGIC;
                signal present_counter :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal present_reg :  STD_LOGIC;
                signal reset_reg :  STD_LOGIC;

begin

  atasel_n <= std_logic'('0');
  we_n <= std_logic'('1');
  rfu <= std_logic'('1');
  addr(10 DOWNTO 3) <= std_logic_vector'("00000000");
  addr(2 DOWNTO 0) <= av_ide_address(2 DOWNTO 0);
  iord_n <= av_ide_read_n;
  iowr_n <= av_ide_write_n;
  cs_n(0) <= A_WE_StdLogic((std_logic'(NOT av_ide_chipselect_n) = '1'), (A_WE_StdLogic((std_logic'(NOT av_ide_address(3)) = '1'), std_logic'('0'), std_logic'('1'))), std_logic'('1'));
  cs_n(1) <= A_WE_StdLogic((std_logic'(NOT av_ide_chipselect_n) = '1'), (A_WE_StdLogic((std_logic'(av_ide_address(3)) = '1'), std_logic'('0'), std_logic'('1'))), std_logic'('1'));
  av_ide_readdata <= A_WE_StdLogicVector((std_logic'(present_reg) = '1'), data_cf, std_logic_vector'("1111111111111111"));
  data_cf <= A_WE_StdLogicVector((std_logic'(((NOT av_ide_write_n AND present_reg))) = '1'), av_ide_writedata, std_logic_vector'("ZZZZZZZZZZZZZZZZ"));
  power <= A_WE_StdLogic((std_logic'(((power_reg AND present_reg))) = '1'), std_logic'('1'), std_logic'('0'));
  reset_n_cf <= A_WE_StdLogic((std_logic'((((reset_reg OR NOT av_reset_n) OR NOT present_reg))) = '1'), std_logic'('0'), std_logic'('1'));
  av_ide_irq <= A_WE_StdLogic((std_logic'(((ide_irq_en_reg AND present_reg))) = '1'), intrq, std_logic'('0'));
  ctl_lo_write_strobe <= (NOT av_ctl_chipselect_n AND NOT av_ctl_write_n) AND to_std_logic((((std_logic_vector'("00") & (av_ctl_address)) = std_logic_vector'("0000"))));
  ctl_hi_write_strobe <= (NOT av_ctl_chipselect_n AND NOT av_ctl_write_n) AND to_std_logic((((std_logic_vector'("00") & (av_ctl_address)) = std_logic_vector'("0001"))));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ctl_irq_en_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(ctl_lo_write_strobe) = '1' then 
        ctl_irq_en_reg <= av_ctl_writedata(3);
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      reset_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(ctl_lo_write_strobe) = '1' then 
        reset_reg <= av_ctl_writedata(2);
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      power_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(ctl_lo_write_strobe) = '1' then 
        power_reg <= av_ctl_writedata(1);
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ide_irq_en_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(ctl_hi_write_strobe) = '1' then 
        ide_irq_en_reg <= av_ctl_writedata(0);
      end if;
    end if;

  end process;

  ctl_read_mux <= A_WE_StdLogicVector(((av_ctl_address = std_logic_vector'("00"))), Std_Logic_Vector'(A_ToStdLogicVector(ctl_irq_en_reg) & A_ToStdLogicVector(reset_reg) & A_ToStdLogicVector(power_reg) & A_ToStdLogicVector(present_reg)), A_WE_StdLogicVector(((av_ctl_address = std_logic_vector'("01"))), Std_Logic_Vector'(std_logic_vector'("000") & A_ToStdLogicVector(ide_irq_en_reg)), A_WE_StdLogicVector(((av_ctl_address = std_logic_vector'("10"))), std_logic_vector'("0000"), std_logic_vector'("0000"))));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      av_ctl_readdata <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      av_ctl_readdata <= ctl_read_mux;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      present_counter <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'(detect_n) = '1' then 
        present_counter <= std_logic_vector'("0000000000000000");
      else
        present_counter <= A_EXT (((std_logic_vector'("00000000000000000") & (present_counter)) + std_logic_vector'("000000000000000000000000000000001")), 16);
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      present_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(detect_n) = '1' then 
        present_reg <= std_logic'('0');
      elsif (std_logic_vector'("0000000000000000") & (present_counter)) = std_logic_vector'("00000000000000001100001101010000") then 
        present_reg <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_present_reg <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_present_reg <= present_reg;
    end if;

  end process;

  ctl_lo_read_strobe <= (NOT av_ctl_chipselect_n AND NOT av_ctl_read_n) AND to_std_logic((((std_logic_vector'("00") & (av_ctl_address)) = std_logic_vector'("0000"))));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      av_ctl_irq <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(ctl_irq_en_reg) = '1' then 
        if std_logic'(ctl_lo_read_strobe) = '1' then 
          av_ctl_irq <= std_logic'('0');
        elsif std_logic'((d1_present_reg XOR present_reg)) = '1' then 
          av_ctl_irq <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        end if;
      end if;
    end if;

  end process;

  --ctl, which is an e_avalon_slave
  --ide, which is an e_avalon_slave

end europa;

