LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY const IS
PORT (	REQ_OUT			: OUT std_logic;
		WR2_MAX_ADDR	: OUT std_logic_vector(22 downto 0); 
		WR2_ADDR		: OUT std_logic_vector(22 downto 0); 
		WR_LENGTH	: OUT std_logic_vector(8 downto 0);
		WR1_MAX_ADDR	: OUT std_logic_vector(22 downto 0); 
		WR1_ADDR		: OUT std_logic_vector(22 downto 0);
		CLK_NIOS		: IN std_logic;
		REQ_IN			: IN std_logic;
		);
END const;


ARCHITECTURE const_sd OF const IS
	
	
	BEGIN
	WR2_MAX_ADDR	<=	"00101001011000000000000";
	WR2_ADDR		<=	"00100000000000000000000";
	WR_LENGTH		<=	"100000000";
	WR1_MAX_ADDR	<=	"00001001011000000000000";
	WR1_ADDR		<=	"00000000000000000000000";

	SIGNAL shift : std_logic_VECTOR(1 DOWNTO 0)

	PROCESS
		BEGIN
			WAIT UNTIL ((CLK_NIOS'EVENT) AND ( CLK_NIOS = '1' ));
			if (REQ_IN = '1' AND shift(0 DOWNTO 0) = '0' THEN
				shift(0 DOWNTO 0) <= '1';
			ELSE
				shift sll 1;
			END IF;
			REQ_OUT <= shift(0 DOWNTO 0)
			
	END PROCESS;
end const_sd;