LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY segment IS
PORT (	CLK		: IN std_logic;
		RESET	: IN std_logic;
		SET		: IN std_logic;
		ADDR	: IN std_logic_vector(2 downto 0);
		DATA	: IN std_logic_vector(3 downto 0);
		HEX0	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1'); 
		HEX1	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1'); 
		HEX2	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1');
		HEX3	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1');
		HEX4	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1');
		HEX5	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1'); 
		HEX6	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1');
		HEX7	: OUT std_logic_vector(6 downto 0) := (OTHERS => '1')
		);
END segment;


ARCHITECTURE x OF segment IS
	
	SIGNAL hex 	:std_logic_VECTOR(6 DOWNTO 0);
	
BEGIN
		
PROCESS
	BEGIN
	WAIT UNTIL ((CLK'EVENT) AND ( CLK = '1' ));
		IF RESET = '0' THEN
			HEX0	<=	"1111111";
			HEX1	<=	"1111111";
			HEX2	<=	"1111111";
			HEX3	<=	"1111111";
			HEX4	<=	"1111111";
			HEX5	<=	"1111111";
			HEX6	<=	"1111111";
			HEX7	<=	"1111111";
		ELSE
			IF (DATA = "0000") THEN
				hex <= "1000000";--0
			ELSIF (DATA = "0001") THEN
				hex <= "1111001";--1
			ELSIF (DATA = "0010") THEN
				hex <= "0100100";--2
			ELSIF (DATA = "0011") THEN
				hex <= "0110000";--3
			ELSIF (DATA = "0100") THEN
				hex <= "0011001";--4
			ELSIF (DATA = "0101") THEN
				hex <= "0010010";--5
			ELSIF (DATA = "0110") THEN
				hex <= "0000010";--6
			ELSIF (DATA = "0111") THEN
				hex <= "1111000";--7
			ELSIF (DATA = "1000") THEN
				hex <= "0000000";--8
			ELSIF (DATA = "1001") THEN
				hex <= "0011000";--9
			ELSIF (DATA = "1010") THEN
				hex <= "0001000";--A
			ELSIF (DATA = "1011") THEN
				hex <= "0000011";--b
			ELSIF (DATA = "1100") THEN
				hex <= "1000110";--C
			ELSIF (DATA = "1101") THEN
				hex <= "0100001";--d
			ELSIF (DATA = "1110") THEN
				hex <= "0000110";--E
			ELSIF (DATA = "1111") THEN
				hex <= "0001110";--F	
			END IF;
			
			IF (SET='1') THEN
				IF (ADDR = "000") THEN
					HEX0 <= hex;
				ELSIF (ADDR = "001") THEN
					HEX1 <= hex;
				ELSIF (ADDR = "010") THEN
					HEX2 <= hex;
				ELSIF (ADDR = "011") THEN
					HEX3 <= hex;
				ELSIF (ADDR = "100") THEN
					HEX4 <= hex;
				ELSIF (ADDR = "101") THEN
					HEX5 <= hex;
				ELSIF (ADDR = "110") THEN
					HEX6 <= hex;
				ELSIF (ADDR = "111") THEN
					HEX7 <= hex;
				END IF;
			END IF;
		END IF;
	END PROCESS;
end x;

