/*
 * LCD_init.c
 *
 *  Created on: 24.mar.2010
 *      Author: venjum
 */
#include "system.h"
#include "LCD.h"
#include <unistd.h>
#include <stdio.h>



void lcd_init( void ) {
	/* Set Function Code Four Times -- 8-bit, 2 line, 5x7 mode */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND(LCD_BASE, 0x38);
	//IOWR( LCD_BASE, LCD_WR_COMMAND_REG, 0x38 );
	usleep(4100); //* Wait 4.1 ms */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x38 );
	usleep(100); /* Wait 100 us */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x38 );
	usleep(5000); /* Wait 5.0 ms */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x38 );
	usleep(100);

	/* Set Display to OFF */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x08 );
	usleep(100);

	/* Set Display to ON */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x0C );
	usleep(100);

	/* Set Entry Mode -- Cursor increment, display doesn't shift */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x06 );
	usleep(100);

	/* Set the cursor to the home position */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x02 );
	usleep(2000);

	/* Clear the display */
	IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x01 );
	usleep(2000);
}


void lcd_string_write(char string[],char line)
{
   int i = 0;

   if(line == 0) //If 'line' is 0 it means line 1
   {
       /* Set the cursor to the home position */
       IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0x02 );
       usleep(2000);
       for(i=0;i<16;i++)
       {
           if(string[i] == '\0')
           {
               for(;i<16;i++)
               {
                   IOWR_ALTERA_AVALON_LCD_16207_DATA(LCD_BASE,' ');
                   usleep(100);
               }
               break;
           }
           IOWR_ALTERA_AVALON_LCD_16207_DATA(LCD_BASE,string[i]);
           usleep(100);
       }
   }
   else //If 'line' is other than 0 use line 2
   {
       /* Count along the bottom row */
       /* Set Address */
       IOWR_ALTERA_AVALON_LCD_16207_COMMAND( LCD_BASE, 0xC0 );
       usleep(1000);

       for(i=0;i<16;i++)
       {
           if(string[i] == '\0')
           {
               for(;i<16;i++)
               {
                   IOWR_ALTERA_AVALON_LCD_16207_DATA(LCD_BASE,' ');
                   usleep(100);
               }
               break;
           }
           IOWR_ALTERA_AVALON_LCD_16207_DATA(LCD_BASE,string[i]);
           usleep(100);
       }

   }

}
