/*
 * flash.c
 *
 *  Created on: 08.apr.2010
 *      Author: venjum
 */
#include "flash.h"
#include <stdio.h>
#include "sys/alt_stdio.h"
#include <string.h>
#include "sys/alt_flash.h"
#include "altera_avalon_pio_regs.h"
#include "system.h"
#include "sys/alt_irq.h"

//#define	BUF_SIZE 16
#define BUFSIZE 3
#define flash_base_addr 0x100027


void flash_to_frame(void){
	alt_irq_context context;
	alt_u32 flash_addr = flash_base_addr;
	alt_flash_fd* fd;

	int ret_code;
	int pix;

	unsigned char rgb[BUFSIZE];

	fd = alt_flash_open_dev("/dev/cfi_flash_0");
	if (fd!=NULL){
		context = alt_irq_disable_all();
//		alt_printf("flash open\n");

		for(pix=0; pix<640*480; pix++){
		ret_code = alt_read_flash(fd, flash_addr, rgb, BUFSIZE);

			if (ret_code==0){

				IOWR_ALTERA_AVALON_PIO_DATA(NIOS_R_BASE, rgb[0]);
				IOWR_ALTERA_AVALON_PIO_DATA(NIOS_G_BASE, rgb[1]);
				IOWR_ALTERA_AVALON_PIO_DATA(NIOS_B_BASE, rgb[2]);

				IOWR_ALTERA_AVALON_PIO_DATA(FIFO_REQ_BASE, 1);
				IOWR_ALTERA_AVALON_PIO_DATA(FIFO_REQ_BASE, 0);

				flash_addr+=BUFSIZE;
			}
		}
		alt_flash_close_dev(fd);
		alt_irq_enable_all(context);
	}
	else{
		alt_printf("Can not open flash device\n");
	}
}

