
#include <stdio.h>
#include "sys/alt_stdio.h"
#include <stdlib.h>
#include "system.h"
#include "alt_types.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_spi.h"
#include <unistd.h>
//tror ikke jeg behver  ha med denne
//#include <altera_ro_zipfs.h>
#include "altera_avalon_spi_regs.h"
#include "sys/alt_irq.h"

#include "set_bits.h"
#include "LCD.h"
#include "flash.h"
#include "scenario.h"



static void push_isr(void *,alt_u32);
void interrupt_init(void);
char spi_transmit(unsigned char);
void init_de2(void);


char state =0x01;
unsigned char temp;

char hex = 0x00;

int main(){

	init_de2();

	picture_on_screen();
	while(1){
		//alt_printf("state is %x\n",state);
		if(state == 0x01){
			lcd_string_write("HEX,BIN and DEC",0);
			picture_on_screen();

			hex = 0x00;
			//sethex(hex);
			state = 0x02;
		}
		else if(state == 0x02){
			hex = binhexdec(hex,spi_transmit(0x01));
		}
		else if(state == 0x03){
			lcd_string_write("Light Adjustment",0);
			flash_to_frame();

			state = 0x04;
		}
		else if(state == 0x04){
			temp = spi_transmit(0x03);
			turn_on_leds(temp);
			//alt_printf("from spi %x\n",temp);

		}
		else{
			state = 0x01;
		}

		usleep(400);
	}

 return 0;
}

void init_de2(){
	lcd_init();

	interrupt_init();

	//lcd_string_write("hei paa deg",0);
	lcd_string_write("",1);
	scenario_init();

}

//INIT of interrupts
void interrupt_init()
{
   //    This part activates interrupt on 8 switches SW[8..0] and links the
   //    interrupt on falling edge to the push_isr() interrupt service routine
   IOWR_ALTERA_AVALON_PIO_IRQ_MASK(SW_BASE,0xFF);
   alt_irq_register(SW_IRQ,(void *) 0, push_isr);
}

//Interrupt service routine
static void push_isr(void * context,alt_u32 id){
   int EDGE_CAP_VAL = 0;
   EDGE_CAP_VAL = IORD_ALTERA_AVALON_PIO_EDGE_CAP(SW_BASE);
   IOWR_ALTERA_AVALON_PIO_EDGE_CAP(SW_BASE,SW_BIT_CLEARING_EDGE_REGISTER);
   //One should not use printf inside a ISR, but it works OK as a test
  //alt_printf("EDGE_CAP_VALUE aka ''The Button switched'': %x \n", EDGE_CAP_VAL);

   IOWR_ALTERA_AVALON_PIO_DATA(LEDR_BASE,EDGE_CAP_VAL);

	switch(EDGE_CAP_VAL)
	{
		  case(0x01):
		  {
			  state =0x01;
			  break;
		  }

		  case(0x02):
		  {
			  state = 0x03;
			  break;
		  }
		  default:
			  break;


	}
}

char spi_transmit(unsigned char transmit){
		// force SS_N active
		IOWR_ALTERA_AVALON_SPI_CONTROL(SPI_0_BASE, ALTERA_AVALON_SPI_CONTROL_SSO_MSK);

		IOWR_ALTERA_AVALON_SPI_TXDATA(SPI_0_BASE,transmit);

		// transmit a byte
		while (!(IORD_ALTERA_AVALON_SPI_STATUS(SPI_0_BASE) & ALTERA_AVALON_SPI_STATUS_TRDY_MSK));

		// wait for all bytes to be send
		while(!(IORD_ALTERA_AVALON_SPI_STATUS(SPI_0_BASE) & ALTERA_AVALON_SPI_STATUS_TMT_MSK));
		//}
		//release SS_N
		IOWR_ALTERA_AVALON_SPI_CONTROL(SPI_0_BASE, ALTERA_AVALON_SPI_CONTROL_SSO_MSK);

		return (unsigned char)IORD_ALTERA_AVALON_SPI_RXDATA(SPI_0_BASE);
}


