/*
 * scenario.c
 *
 *  Created on: 16.mai.2010
 *      Author: venjum
 */
//#include "altera_avalon_spi_regs.h"
#include "system.h"
#include "sys/alt_stdio.h"

#include "set_bits.h"
#include "LCD.h"
#include "scenario.h"

#include "alt_types.h"
#include "altera_avalon_pio_regs.h"

#include <unistd.h>

#define max_led_v 129
int led[8];




void scenario_init(){
	led[0] = max_led_v/16;
	int i;
	for(i=1; i<8; i++){
	led[i] = i*max_led_v/8+ led[0];
	}
}
void picture_on_screen(){
	int i;
	IOWR_ALTERA_AVALON_PIO_DATA(NIOS_R_BASE, 0xff);
	IOWR_ALTERA_AVALON_PIO_DATA(NIOS_G_BASE, 0xff);
	IOWR_ALTERA_AVALON_PIO_DATA(NIOS_B_BASE, 0xff);
		for(i=0; i<640*480; i++){
			IOWR_ALTERA_AVALON_PIO_DATA(FIFO_REQ_BASE, 1);
			IOWR_ALTERA_AVALON_PIO_DATA(FIFO_REQ_BASE, 0);
		}
}

void turn_on_leds(unsigned char temp){
	//unsigned char temp = (unsigned char)spi_transmit(0x02);
	//alt_printf("fra spi %x\n",temp);
	if(temp >= led[7]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0xff);
	}
	else if(temp >= led[6]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x7f);
	}
	else if(temp >= led[5]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x3f);
	}
	else if(temp >= led[4]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x1f);
	}
	else if(temp >= led[3]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x0f);
	}
	else if(temp >= led[2]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x07);
	}
	else if(temp >= led[1]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x03);
	}
	else if(temp >= led[0]){
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x01);
	}
	else{
		IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, 0x00);
	}
	usleep(40000);

}

unsigned char binhexdec(unsigned char hex, unsigned char operation){
	//alt_printf("fra spi %x\n",operation);
	if(operation == 0x01){
		hex+=1;
	}
	else if(operation == 0x02){
		hex-=1;
	}
	else if(operation == 0x03){
		hex+=10;
	}
	else if(operation == 0x04){
		hex-=10;
	}

	sethex(hex);
	//lcd_string_write("Desimal"+(char)(hex),1);
	IOWR_ALTERA_AVALON_PIO_DATA(LEDG_BASE, (char)(hex));
	setdes((int)hex);
	usleep(400000);
	return hex;
}

void sethex(unsigned char segment){
		char lsb = (char)segment;
		char msb = (char)(segment>>4);
		//alt_printf("lsb %x\n",lsb);
		//alt_printf("msb %x\n",msb);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_DATA_BASE, lsb);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0xc);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x4);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_DATA_BASE, msb);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0xd);
		IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x5);
}

void setdes(int des){
	int hex0,hex1,hex2;
	hex0 = des%10;
	hex1 = (des%100-hex0)/10;
	hex2 = (des - des%100)/100;

	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_DATA_BASE, hex0);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x8);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x0);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_DATA_BASE, hex1);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x9);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x1);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_DATA_BASE, hex2);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0xa);
	IOWR_ALTERA_AVALON_PIO_DATA(SEG7_ADDR_BASE, 0x2);
}

