//Internal ADC in ATMega128


#include "ADC.h"
#include "sett_bits.h"

uint8_t counter = 0;
uint16_t inputs[4] = {0};

void ADC_init(){
	
	//Select AVCC as voltage reference and single conversion on ADC0
	clear_bit(DDRF, PF0);
	ADMUX = (1<<REFS0)|(1<<ADLAR) ;

	//Enable ADC
	set_bit(ADCSRA, ADEN);

}

void ADC_sample(){
	set_bit(ADCSRA, ADSC);

	while(!test_bit(ADCSRA, ADIF));
}


uint8_t ADC_readSample(){
	while(counter < 4){
		ADC_sample();
		inputs[counter] = ADCH;
		counter++;

	}
	counter = 0;
	return (inputs[0] + inputs[1] + inputs[2] + inputs[3])/4;
}


