//Servo functions

#include "sett_bits.h"
#include "uart.h"
#include "pwm.h"
#include <avr/io.h>

void pwm_init(){
	// configure PORTB:OC0A to be output
	
	
	set_bit(DDRB, PB7);
	
	//configure PWM to Clear OC0A on compare match (set output to high level) page 111. 
	set_bit(TCCR0A,COM0A1);
	set_bit(TCCR0A,COM0A0);
	

	/*
	Configure OC0A to use mode 3
	config found in datasheet page 113
	TCCR1B		TCCR1A
	WGM02 	WGM01 WGM00
	0		1		1
	*/

	clear_bit(TCCR0B,WGM02);
	set_bit(TCCR0A,WGM01);
	set_bit(TCCR0A,WGM00);
	

	//set clock prescaling clk/8 page 114
	set_bit(TCCR0B, CS02);
	clear_bit(TCCR0B,CS01);
	set_bit(TCCR0B, CS00);

	//set periode;
	//OCR0A = 256;

	//set servo to center
	OCR0A = 0;
	
}

void setLight(unsigned char pos){
	OCR0A = pos;
}

