#include <avr/io.h>
#include <avr/interrupt.h>
#include "spi.h"
#include "sett_bits.h"
#include "swint.h"
#include "pwm.h"
#include "adc.h"



uint8_t data;
unsigned char state = 0x00;


void spi_init(){
//spi config on page 176 at90usb1287
	// Set to slave
	//DDRB = (1<<DDB3);
	set_bit(DDRB,3);

	// Enable SPI and interrupt
	SPCR = (1<<SPE) | (1<<SPIE);		

}


unsigned char spi_receive()
{
	//SPDR = data;
	/* Wait for reception complete */
	while(!(SPSR & (1<<SPIF)));

	return SPDR;
}

unsigned char getstate(){
	return state;
}





ISR(SPI_STC_vect){
	cli();
	data = SPDR;
//	printf("senario is choosen %x",data);

	if (data == 0x03){
		state = 0x03;
		
		SPDR = ADC_readSample();
		//printf("from adc %x",test);
	
	}
	else if (data == 0x01){
		state = 0x01;
		SPDR = getoperation();
		resetoperation();
		_delay_ms(20); 
		resetoperation();
	}

	else {
		SPDR = 0xab;
	}

	sei();
	
}


