// UART driver

#include "uart.h"
#include <avr/io.h>

	void uart_init(void){

		//Set baud rate 
		UBRR1H = (unsigned char)(myubrr>>8);	
		UBRR1L = (unsigned char) myubrr;
		
		// Enable receiver and transmitter
		UCSR1B = (1<<RXEN1)|(1<<TXEN1);
	
		
		// Set frame format: 8data, 2stop bit
		UCSR1C = (1<<USBS1)|(3<<UCSZ10);

		fdevopen( ((void*)uart_transmit), ((void*)uart_receive) );
	}
	
	void uart_transmit(unsigned char data){
		// Wait for empty transmit buffer
		while ( !( UCSR1A & (1<<UDRE1)) );

		// Put data into buffer, sends the data
		UDR1 = data;
	}
	
	
	unsigned char uart_receive(){
		// Wait for data to be received
		while ( !(UCSR1A & (1<<RXC1)) );

		// Get and return received data from buffer
		return UDR1;
	}



