--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Legal Notice: (C)2010 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LCD_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal LCD_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LCD_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LCD_control_slave_begintransfer : OUT STD_LOGIC;
                 signal LCD_control_slave_read : OUT STD_LOGIC;
                 signal LCD_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LCD_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal LCD_control_slave_write : OUT STD_LOGIC;
                 signal LCD_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_LCD_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_LCD_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LCD_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_LCD_control_slave : OUT STD_LOGIC;
                 signal d1_LCD_control_slave_end_xfer : OUT STD_LOGIC
              );
end entity LCD_control_slave_arbitrator;


architecture europa of LCD_control_slave_arbitrator is
                signal LCD_control_slave_allgrants :  STD_LOGIC;
                signal LCD_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal LCD_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LCD_control_slave_any_continuerequest :  STD_LOGIC;
                signal LCD_control_slave_arb_counter_enable :  STD_LOGIC;
                signal LCD_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LCD_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LCD_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LCD_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal LCD_control_slave_begins_xfer :  STD_LOGIC;
                signal LCD_control_slave_counter_load_value :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal LCD_control_slave_end_xfer :  STD_LOGIC;
                signal LCD_control_slave_firsttransfer :  STD_LOGIC;
                signal LCD_control_slave_grant_vector :  STD_LOGIC;
                signal LCD_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal LCD_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal LCD_control_slave_master_qreq_vector :  STD_LOGIC;
                signal LCD_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal LCD_control_slave_pretend_byte_enable :  STD_LOGIC;
                signal LCD_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal LCD_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal LCD_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal LCD_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal LCD_control_slave_wait_counter :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal LCD_control_slave_waits_for_read :  STD_LOGIC;
                signal LCD_control_slave_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_LCD_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LCD_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_LCD_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_LCD_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_LCD_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_LCD_control_slave :  STD_LOGIC;
                signal shifted_address_to_LCD_control_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_LCD_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LCD_control_slave_end_xfer;
    end if;

  end process;

  LCD_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_LCD_control_slave);
  --assign LCD_control_slave_readdata_from_sa = LCD_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LCD_control_slave_readdata_from_sa <= LCD_control_slave_readdata;
  internal_cpu_data_master_requests_LCD_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000000100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --LCD_control_slave_arb_share_counter set values, which is an e_mux
  LCD_control_slave_arb_share_set_values <= std_logic_vector'("001");
  --LCD_control_slave_non_bursting_master_requests mux, which is an e_mux
  LCD_control_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_LCD_control_slave;
  --LCD_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  LCD_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --LCD_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  LCD_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(LCD_control_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LCD_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(LCD_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LCD_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --LCD_control_slave_allgrants all slave grants, which is an e_mux
  LCD_control_slave_allgrants <= LCD_control_slave_grant_vector;
  --LCD_control_slave_end_xfer assignment, which is an e_assign
  LCD_control_slave_end_xfer <= NOT ((LCD_control_slave_waits_for_read OR LCD_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_LCD_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LCD_control_slave <= LCD_control_slave_end_xfer AND (((NOT LCD_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LCD_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  LCD_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LCD_control_slave AND LCD_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_LCD_control_slave AND NOT LCD_control_slave_non_bursting_master_requests));
  --LCD_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_control_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(LCD_control_slave_arb_counter_enable) = '1' then 
        LCD_control_slave_arb_share_counter <= LCD_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LCD_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LCD_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_LCD_control_slave)) OR ((end_xfer_arb_share_counter_term_LCD_control_slave AND NOT LCD_control_slave_non_bursting_master_requests)))) = '1' then 
        LCD_control_slave_slavearbiterlockenable <= or_reduce(LCD_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master LCD/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= LCD_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --LCD_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LCD_control_slave_slavearbiterlockenable2 <= or_reduce(LCD_control_slave_arb_share_counter_next_value);
  --cpu/data_master LCD/control_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= LCD_control_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --LCD_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  LCD_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_LCD_control_slave <= internal_cpu_data_master_requests_LCD_control_slave AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_LCD_control_slave, which is an e_mux
  cpu_data_master_read_data_valid_LCD_control_slave <= (internal_cpu_data_master_granted_LCD_control_slave AND cpu_data_master_read) AND NOT LCD_control_slave_waits_for_read;
  --LCD_control_slave_writedata mux, which is an e_mux
  LCD_control_slave_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_LCD_control_slave <= internal_cpu_data_master_qualified_request_LCD_control_slave;
  --cpu/data_master saved-grant LCD/control_slave, which is an e_assign
  cpu_data_master_saved_grant_LCD_control_slave <= internal_cpu_data_master_requests_LCD_control_slave;
  --allow new arb cycle for LCD/control_slave, which is an e_assign
  LCD_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LCD_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LCD_control_slave_master_qreq_vector <= std_logic'('1');
  LCD_control_slave_begintransfer <= LCD_control_slave_begins_xfer;
  --LCD_control_slave_firsttransfer first transaction, which is an e_assign
  LCD_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(LCD_control_slave_begins_xfer) = '1'), LCD_control_slave_unreg_firsttransfer, LCD_control_slave_reg_firsttransfer);
  --LCD_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  LCD_control_slave_unreg_firsttransfer <= NOT ((LCD_control_slave_slavearbiterlockenable AND LCD_control_slave_any_continuerequest));
  --LCD_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LCD_control_slave_begins_xfer) = '1' then 
        LCD_control_slave_reg_firsttransfer <= LCD_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LCD_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LCD_control_slave_beginbursttransfer_internal <= LCD_control_slave_begins_xfer;
  --LCD_control_slave_read assignment, which is an e_mux
  LCD_control_slave_read <= (((internal_cpu_data_master_granted_LCD_control_slave AND cpu_data_master_read)) AND NOT LCD_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000000011001"))));
  --LCD_control_slave_write assignment, which is an e_mux
  LCD_control_slave_write <= (((((internal_cpu_data_master_granted_LCD_control_slave AND cpu_data_master_write)) AND NOT LCD_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_control_slave_wait_counter))>=std_logic_vector'("00000000000000000000000000011001"))))) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000000110010"))))) AND LCD_control_slave_pretend_byte_enable;
  shifted_address_to_LCD_control_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --LCD_control_slave_address mux, which is an e_mux
  LCD_control_slave_address <= A_EXT (A_SRL(shifted_address_to_LCD_control_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LCD_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LCD_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LCD_control_slave_end_xfer <= LCD_control_slave_end_xfer;
    end if;

  end process;

  --LCD_control_slave_waits_for_read in a cycle, which is an e_mux
  LCD_control_slave_waits_for_read <= LCD_control_slave_in_a_read_cycle AND wait_for_LCD_control_slave_counter;
  --LCD_control_slave_in_a_read_cycle assignment, which is an e_assign
  LCD_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_LCD_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LCD_control_slave_in_a_read_cycle;
  --LCD_control_slave_waits_for_write in a cycle, which is an e_mux
  LCD_control_slave_waits_for_write <= LCD_control_slave_in_a_write_cycle AND wait_for_LCD_control_slave_counter;
  --LCD_control_slave_in_a_write_cycle assignment, which is an e_assign
  LCD_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_LCD_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LCD_control_slave_in_a_write_cycle;
  internal_LCD_control_slave_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000") & (LCD_control_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_control_slave_wait_counter <= std_logic_vector'("0000000");
    elsif clk'event and clk = '1' then
      LCD_control_slave_wait_counter <= LCD_control_slave_counter_load_value;
    end if;

  end process;

  LCD_control_slave_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((LCD_control_slave_in_a_write_cycle AND LCD_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000001001001"), A_WE_StdLogicVector((std_logic'(((LCD_control_slave_in_a_read_cycle AND LCD_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000110000"), A_WE_StdLogicVector((std_logic'((NOT internal_LCD_control_slave_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000") & (LCD_control_slave_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 7);
  wait_for_LCD_control_slave_counter <= LCD_control_slave_begins_xfer OR NOT internal_LCD_control_slave_wait_counter_eq_0;
  --LCD_control_slave_pretend_byte_enable byte enable port mux, which is an e_mux
  LCD_control_slave_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_LCD_control_slave)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  LCD_control_slave_wait_counter_eq_0 <= internal_LCD_control_slave_wait_counter_eq_0;
  --vhdl renameroo for output signals
  cpu_data_master_granted_LCD_control_slave <= internal_cpu_data_master_granted_LCD_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_LCD_control_slave <= internal_cpu_data_master_qualified_request_LCD_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_LCD_control_slave <= internal_cpu_data_master_requests_LCD_control_slave;
--synthesis translate_off
    --LCD/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LEDG_s1_arbitrator is 
        port (
              -- inputs:
                 signal LEDG_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LEDG_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LEDG_s1_chipselect : OUT STD_LOGIC;
                 signal LEDG_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LEDG_s1_reset_n : OUT STD_LOGIC;
                 signal LEDG_s1_write_n : OUT STD_LOGIC;
                 signal LEDG_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_LEDG_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_LEDG_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LEDG_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_LEDG_s1 : OUT STD_LOGIC;
                 signal d1_LEDG_s1_end_xfer : OUT STD_LOGIC
              );
end entity LEDG_s1_arbitrator;


architecture europa of LEDG_s1_arbitrator is
                signal LEDG_s1_allgrants :  STD_LOGIC;
                signal LEDG_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal LEDG_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LEDG_s1_any_continuerequest :  STD_LOGIC;
                signal LEDG_s1_arb_counter_enable :  STD_LOGIC;
                signal LEDG_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDG_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDG_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDG_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal LEDG_s1_begins_xfer :  STD_LOGIC;
                signal LEDG_s1_end_xfer :  STD_LOGIC;
                signal LEDG_s1_firsttransfer :  STD_LOGIC;
                signal LEDG_s1_grant_vector :  STD_LOGIC;
                signal LEDG_s1_in_a_read_cycle :  STD_LOGIC;
                signal LEDG_s1_in_a_write_cycle :  STD_LOGIC;
                signal LEDG_s1_master_qreq_vector :  STD_LOGIC;
                signal LEDG_s1_non_bursting_master_requests :  STD_LOGIC;
                signal LEDG_s1_pretend_byte_enable :  STD_LOGIC;
                signal LEDG_s1_reg_firsttransfer :  STD_LOGIC;
                signal LEDG_s1_slavearbiterlockenable :  STD_LOGIC;
                signal LEDG_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal LEDG_s1_unreg_firsttransfer :  STD_LOGIC;
                signal LEDG_s1_waits_for_read :  STD_LOGIC;
                signal LEDG_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_LEDG_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LEDG_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_LEDG_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_LEDG_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_LEDG_s1 :  STD_LOGIC;
                signal shifted_address_to_LEDG_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_LEDG_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LEDG_s1_end_xfer;
    end if;

  end process;

  LEDG_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_LEDG_s1);
  --assign LEDG_s1_readdata_from_sa = LEDG_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LEDG_s1_readdata_from_sa <= LEDG_s1_readdata;
  internal_cpu_data_master_requests_LEDG_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000001010000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --LEDG_s1_arb_share_counter set values, which is an e_mux
  LEDG_s1_arb_share_set_values <= std_logic_vector'("001");
  --LEDG_s1_non_bursting_master_requests mux, which is an e_mux
  LEDG_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_LEDG_s1;
  --LEDG_s1_any_bursting_master_saved_grant mux, which is an e_mux
  LEDG_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --LEDG_s1_arb_share_counter_next_value assignment, which is an e_assign
  LEDG_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(LEDG_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LEDG_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(LEDG_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LEDG_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --LEDG_s1_allgrants all slave grants, which is an e_mux
  LEDG_s1_allgrants <= LEDG_s1_grant_vector;
  --LEDG_s1_end_xfer assignment, which is an e_assign
  LEDG_s1_end_xfer <= NOT ((LEDG_s1_waits_for_read OR LEDG_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_LEDG_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LEDG_s1 <= LEDG_s1_end_xfer AND (((NOT LEDG_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LEDG_s1_arb_share_counter arbitration counter enable, which is an e_assign
  LEDG_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LEDG_s1 AND LEDG_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_LEDG_s1 AND NOT LEDG_s1_non_bursting_master_requests));
  --LEDG_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDG_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(LEDG_s1_arb_counter_enable) = '1' then 
        LEDG_s1_arb_share_counter <= LEDG_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LEDG_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDG_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LEDG_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_LEDG_s1)) OR ((end_xfer_arb_share_counter_term_LEDG_s1 AND NOT LEDG_s1_non_bursting_master_requests)))) = '1' then 
        LEDG_s1_slavearbiterlockenable <= or_reduce(LEDG_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master LEDG/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= LEDG_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --LEDG_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LEDG_s1_slavearbiterlockenable2 <= or_reduce(LEDG_s1_arb_share_counter_next_value);
  --cpu/data_master LEDG/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= LEDG_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --LEDG_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  LEDG_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_LEDG_s1 <= internal_cpu_data_master_requests_LEDG_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_LEDG_s1, which is an e_mux
  cpu_data_master_read_data_valid_LEDG_s1 <= (internal_cpu_data_master_granted_LEDG_s1 AND cpu_data_master_read) AND NOT LEDG_s1_waits_for_read;
  --LEDG_s1_writedata mux, which is an e_mux
  LEDG_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_LEDG_s1 <= internal_cpu_data_master_qualified_request_LEDG_s1;
  --cpu/data_master saved-grant LEDG/s1, which is an e_assign
  cpu_data_master_saved_grant_LEDG_s1 <= internal_cpu_data_master_requests_LEDG_s1;
  --allow new arb cycle for LEDG/s1, which is an e_assign
  LEDG_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LEDG_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LEDG_s1_master_qreq_vector <= std_logic'('1');
  --LEDG_s1_reset_n assignment, which is an e_assign
  LEDG_s1_reset_n <= reset_n;
  LEDG_s1_chipselect <= internal_cpu_data_master_granted_LEDG_s1;
  --LEDG_s1_firsttransfer first transaction, which is an e_assign
  LEDG_s1_firsttransfer <= A_WE_StdLogic((std_logic'(LEDG_s1_begins_xfer) = '1'), LEDG_s1_unreg_firsttransfer, LEDG_s1_reg_firsttransfer);
  --LEDG_s1_unreg_firsttransfer first transaction, which is an e_assign
  LEDG_s1_unreg_firsttransfer <= NOT ((LEDG_s1_slavearbiterlockenable AND LEDG_s1_any_continuerequest));
  --LEDG_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDG_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LEDG_s1_begins_xfer) = '1' then 
        LEDG_s1_reg_firsttransfer <= LEDG_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LEDG_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LEDG_s1_beginbursttransfer_internal <= LEDG_s1_begins_xfer;
  --~LEDG_s1_write_n assignment, which is an e_mux
  LEDG_s1_write_n <= NOT ((((internal_cpu_data_master_granted_LEDG_s1 AND cpu_data_master_write)) AND LEDG_s1_pretend_byte_enable));
  shifted_address_to_LEDG_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --LEDG_s1_address mux, which is an e_mux
  LEDG_s1_address <= A_EXT (A_SRL(shifted_address_to_LEDG_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LEDG_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LEDG_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LEDG_s1_end_xfer <= LEDG_s1_end_xfer;
    end if;

  end process;

  --LEDG_s1_waits_for_read in a cycle, which is an e_mux
  LEDG_s1_waits_for_read <= LEDG_s1_in_a_read_cycle AND LEDG_s1_begins_xfer;
  --LEDG_s1_in_a_read_cycle assignment, which is an e_assign
  LEDG_s1_in_a_read_cycle <= internal_cpu_data_master_granted_LEDG_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LEDG_s1_in_a_read_cycle;
  --LEDG_s1_waits_for_write in a cycle, which is an e_mux
  LEDG_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LEDG_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --LEDG_s1_in_a_write_cycle assignment, which is an e_assign
  LEDG_s1_in_a_write_cycle <= internal_cpu_data_master_granted_LEDG_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LEDG_s1_in_a_write_cycle;
  wait_for_LEDG_s1_counter <= std_logic'('0');
  --LEDG_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  LEDG_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_LEDG_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_LEDG_s1 <= internal_cpu_data_master_granted_LEDG_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_LEDG_s1 <= internal_cpu_data_master_qualified_request_LEDG_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_LEDG_s1 <= internal_cpu_data_master_requests_LEDG_s1;
--synthesis translate_off
    --LEDG/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LEDR_s1_arbitrator is 
        port (
              -- inputs:
                 signal LEDR_s1_readdata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LEDR_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LEDR_s1_chipselect : OUT STD_LOGIC;
                 signal LEDR_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal LEDR_s1_reset_n : OUT STD_LOGIC;
                 signal LEDR_s1_write_n : OUT STD_LOGIC;
                 signal LEDR_s1_writedata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal cpu_data_master_granted_LEDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_LEDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LEDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_LEDR_s1 : OUT STD_LOGIC;
                 signal d1_LEDR_s1_end_xfer : OUT STD_LOGIC
              );
end entity LEDR_s1_arbitrator;


architecture europa of LEDR_s1_arbitrator is
                signal LEDR_s1_allgrants :  STD_LOGIC;
                signal LEDR_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal LEDR_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LEDR_s1_any_continuerequest :  STD_LOGIC;
                signal LEDR_s1_arb_counter_enable :  STD_LOGIC;
                signal LEDR_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDR_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDR_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal LEDR_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal LEDR_s1_begins_xfer :  STD_LOGIC;
                signal LEDR_s1_end_xfer :  STD_LOGIC;
                signal LEDR_s1_firsttransfer :  STD_LOGIC;
                signal LEDR_s1_grant_vector :  STD_LOGIC;
                signal LEDR_s1_in_a_read_cycle :  STD_LOGIC;
                signal LEDR_s1_in_a_write_cycle :  STD_LOGIC;
                signal LEDR_s1_master_qreq_vector :  STD_LOGIC;
                signal LEDR_s1_non_bursting_master_requests :  STD_LOGIC;
                signal LEDR_s1_reg_firsttransfer :  STD_LOGIC;
                signal LEDR_s1_slavearbiterlockenable :  STD_LOGIC;
                signal LEDR_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal LEDR_s1_unreg_firsttransfer :  STD_LOGIC;
                signal LEDR_s1_waits_for_read :  STD_LOGIC;
                signal LEDR_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_LEDR_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LEDR_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_LEDR_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_LEDR_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_LEDR_s1 :  STD_LOGIC;
                signal shifted_address_to_LEDR_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_LEDR_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LEDR_s1_end_xfer;
    end if;

  end process;

  LEDR_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_LEDR_s1);
  --assign LEDR_s1_readdata_from_sa = LEDR_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LEDR_s1_readdata_from_sa <= LEDR_s1_readdata;
  internal_cpu_data_master_requests_LEDR_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000010110000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --LEDR_s1_arb_share_counter set values, which is an e_mux
  LEDR_s1_arb_share_set_values <= std_logic_vector'("001");
  --LEDR_s1_non_bursting_master_requests mux, which is an e_mux
  LEDR_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_LEDR_s1;
  --LEDR_s1_any_bursting_master_saved_grant mux, which is an e_mux
  LEDR_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --LEDR_s1_arb_share_counter_next_value assignment, which is an e_assign
  LEDR_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(LEDR_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LEDR_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(LEDR_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (LEDR_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --LEDR_s1_allgrants all slave grants, which is an e_mux
  LEDR_s1_allgrants <= LEDR_s1_grant_vector;
  --LEDR_s1_end_xfer assignment, which is an e_assign
  LEDR_s1_end_xfer <= NOT ((LEDR_s1_waits_for_read OR LEDR_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_LEDR_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LEDR_s1 <= LEDR_s1_end_xfer AND (((NOT LEDR_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LEDR_s1_arb_share_counter arbitration counter enable, which is an e_assign
  LEDR_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LEDR_s1 AND LEDR_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_LEDR_s1 AND NOT LEDR_s1_non_bursting_master_requests));
  --LEDR_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDR_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(LEDR_s1_arb_counter_enable) = '1' then 
        LEDR_s1_arb_share_counter <= LEDR_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LEDR_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDR_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LEDR_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_LEDR_s1)) OR ((end_xfer_arb_share_counter_term_LEDR_s1 AND NOT LEDR_s1_non_bursting_master_requests)))) = '1' then 
        LEDR_s1_slavearbiterlockenable <= or_reduce(LEDR_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master LEDR/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= LEDR_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --LEDR_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LEDR_s1_slavearbiterlockenable2 <= or_reduce(LEDR_s1_arb_share_counter_next_value);
  --cpu/data_master LEDR/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= LEDR_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --LEDR_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  LEDR_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_LEDR_s1 <= internal_cpu_data_master_requests_LEDR_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_LEDR_s1, which is an e_mux
  cpu_data_master_read_data_valid_LEDR_s1 <= (internal_cpu_data_master_granted_LEDR_s1 AND cpu_data_master_read) AND NOT LEDR_s1_waits_for_read;
  --LEDR_s1_writedata mux, which is an e_mux
  LEDR_s1_writedata <= cpu_data_master_writedata (17 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_LEDR_s1 <= internal_cpu_data_master_qualified_request_LEDR_s1;
  --cpu/data_master saved-grant LEDR/s1, which is an e_assign
  cpu_data_master_saved_grant_LEDR_s1 <= internal_cpu_data_master_requests_LEDR_s1;
  --allow new arb cycle for LEDR/s1, which is an e_assign
  LEDR_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LEDR_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LEDR_s1_master_qreq_vector <= std_logic'('1');
  --LEDR_s1_reset_n assignment, which is an e_assign
  LEDR_s1_reset_n <= reset_n;
  LEDR_s1_chipselect <= internal_cpu_data_master_granted_LEDR_s1;
  --LEDR_s1_firsttransfer first transaction, which is an e_assign
  LEDR_s1_firsttransfer <= A_WE_StdLogic((std_logic'(LEDR_s1_begins_xfer) = '1'), LEDR_s1_unreg_firsttransfer, LEDR_s1_reg_firsttransfer);
  --LEDR_s1_unreg_firsttransfer first transaction, which is an e_assign
  LEDR_s1_unreg_firsttransfer <= NOT ((LEDR_s1_slavearbiterlockenable AND LEDR_s1_any_continuerequest));
  --LEDR_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDR_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LEDR_s1_begins_xfer) = '1' then 
        LEDR_s1_reg_firsttransfer <= LEDR_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LEDR_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LEDR_s1_beginbursttransfer_internal <= LEDR_s1_begins_xfer;
  --~LEDR_s1_write_n assignment, which is an e_mux
  LEDR_s1_write_n <= NOT ((internal_cpu_data_master_granted_LEDR_s1 AND cpu_data_master_write));
  shifted_address_to_LEDR_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --LEDR_s1_address mux, which is an e_mux
  LEDR_s1_address <= A_EXT (A_SRL(shifted_address_to_LEDR_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LEDR_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LEDR_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LEDR_s1_end_xfer <= LEDR_s1_end_xfer;
    end if;

  end process;

  --LEDR_s1_waits_for_read in a cycle, which is an e_mux
  LEDR_s1_waits_for_read <= LEDR_s1_in_a_read_cycle AND LEDR_s1_begins_xfer;
  --LEDR_s1_in_a_read_cycle assignment, which is an e_assign
  LEDR_s1_in_a_read_cycle <= internal_cpu_data_master_granted_LEDR_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LEDR_s1_in_a_read_cycle;
  --LEDR_s1_waits_for_write in a cycle, which is an e_mux
  LEDR_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LEDR_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --LEDR_s1_in_a_write_cycle assignment, which is an e_assign
  LEDR_s1_in_a_write_cycle <= internal_cpu_data_master_granted_LEDR_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LEDR_s1_in_a_write_cycle;
  wait_for_LEDR_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_LEDR_s1 <= internal_cpu_data_master_granted_LEDR_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_LEDR_s1 <= internal_cpu_data_master_qualified_request_LEDR_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_LEDR_s1 <= internal_cpu_data_master_requests_LEDR_s1;
--synthesis translate_off
    --LEDR/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity NIOS_B_s1_arbitrator is 
        port (
              -- inputs:
                 signal NIOS_B_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal NIOS_B_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal NIOS_B_s1_chipselect : OUT STD_LOGIC;
                 signal NIOS_B_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal NIOS_B_s1_reset_n : OUT STD_LOGIC;
                 signal NIOS_B_s1_write_n : OUT STD_LOGIC;
                 signal NIOS_B_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_NIOS_B_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_B_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_B_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_B_s1 : OUT STD_LOGIC;
                 signal d1_NIOS_B_s1_end_xfer : OUT STD_LOGIC
              );
end entity NIOS_B_s1_arbitrator;


architecture europa of NIOS_B_s1_arbitrator is
                signal NIOS_B_s1_allgrants :  STD_LOGIC;
                signal NIOS_B_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal NIOS_B_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal NIOS_B_s1_any_continuerequest :  STD_LOGIC;
                signal NIOS_B_s1_arb_counter_enable :  STD_LOGIC;
                signal NIOS_B_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_B_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_B_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_B_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal NIOS_B_s1_begins_xfer :  STD_LOGIC;
                signal NIOS_B_s1_end_xfer :  STD_LOGIC;
                signal NIOS_B_s1_firsttransfer :  STD_LOGIC;
                signal NIOS_B_s1_grant_vector :  STD_LOGIC;
                signal NIOS_B_s1_in_a_read_cycle :  STD_LOGIC;
                signal NIOS_B_s1_in_a_write_cycle :  STD_LOGIC;
                signal NIOS_B_s1_master_qreq_vector :  STD_LOGIC;
                signal NIOS_B_s1_non_bursting_master_requests :  STD_LOGIC;
                signal NIOS_B_s1_pretend_byte_enable :  STD_LOGIC;
                signal NIOS_B_s1_reg_firsttransfer :  STD_LOGIC;
                signal NIOS_B_s1_slavearbiterlockenable :  STD_LOGIC;
                signal NIOS_B_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal NIOS_B_s1_unreg_firsttransfer :  STD_LOGIC;
                signal NIOS_B_s1_waits_for_read :  STD_LOGIC;
                signal NIOS_B_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_NIOS_B_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_NIOS_B_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_NIOS_B_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_NIOS_B_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_NIOS_B_s1 :  STD_LOGIC;
                signal shifted_address_to_NIOS_B_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_NIOS_B_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT NIOS_B_s1_end_xfer;
    end if;

  end process;

  NIOS_B_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_NIOS_B_s1);
  --assign NIOS_B_s1_readdata_from_sa = NIOS_B_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  NIOS_B_s1_readdata_from_sa <= NIOS_B_s1_readdata;
  internal_cpu_data_master_requests_NIOS_B_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000001110000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --NIOS_B_s1_arb_share_counter set values, which is an e_mux
  NIOS_B_s1_arb_share_set_values <= std_logic_vector'("001");
  --NIOS_B_s1_non_bursting_master_requests mux, which is an e_mux
  NIOS_B_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_NIOS_B_s1;
  --NIOS_B_s1_any_bursting_master_saved_grant mux, which is an e_mux
  NIOS_B_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --NIOS_B_s1_arb_share_counter_next_value assignment, which is an e_assign
  NIOS_B_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(NIOS_B_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_B_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(NIOS_B_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_B_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --NIOS_B_s1_allgrants all slave grants, which is an e_mux
  NIOS_B_s1_allgrants <= NIOS_B_s1_grant_vector;
  --NIOS_B_s1_end_xfer assignment, which is an e_assign
  NIOS_B_s1_end_xfer <= NOT ((NIOS_B_s1_waits_for_read OR NIOS_B_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_NIOS_B_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_NIOS_B_s1 <= NIOS_B_s1_end_xfer AND (((NOT NIOS_B_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --NIOS_B_s1_arb_share_counter arbitration counter enable, which is an e_assign
  NIOS_B_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_NIOS_B_s1 AND NIOS_B_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_NIOS_B_s1 AND NOT NIOS_B_s1_non_bursting_master_requests));
  --NIOS_B_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_B_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_B_s1_arb_counter_enable) = '1' then 
        NIOS_B_s1_arb_share_counter <= NIOS_B_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --NIOS_B_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_B_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((NIOS_B_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_NIOS_B_s1)) OR ((end_xfer_arb_share_counter_term_NIOS_B_s1 AND NOT NIOS_B_s1_non_bursting_master_requests)))) = '1' then 
        NIOS_B_s1_slavearbiterlockenable <= or_reduce(NIOS_B_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master NIOS_B/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= NIOS_B_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --NIOS_B_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  NIOS_B_s1_slavearbiterlockenable2 <= or_reduce(NIOS_B_s1_arb_share_counter_next_value);
  --cpu/data_master NIOS_B/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= NIOS_B_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --NIOS_B_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  NIOS_B_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_NIOS_B_s1 <= internal_cpu_data_master_requests_NIOS_B_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_NIOS_B_s1, which is an e_mux
  cpu_data_master_read_data_valid_NIOS_B_s1 <= (internal_cpu_data_master_granted_NIOS_B_s1 AND cpu_data_master_read) AND NOT NIOS_B_s1_waits_for_read;
  --NIOS_B_s1_writedata mux, which is an e_mux
  NIOS_B_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_NIOS_B_s1 <= internal_cpu_data_master_qualified_request_NIOS_B_s1;
  --cpu/data_master saved-grant NIOS_B/s1, which is an e_assign
  cpu_data_master_saved_grant_NIOS_B_s1 <= internal_cpu_data_master_requests_NIOS_B_s1;
  --allow new arb cycle for NIOS_B/s1, which is an e_assign
  NIOS_B_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  NIOS_B_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  NIOS_B_s1_master_qreq_vector <= std_logic'('1');
  --NIOS_B_s1_reset_n assignment, which is an e_assign
  NIOS_B_s1_reset_n <= reset_n;
  NIOS_B_s1_chipselect <= internal_cpu_data_master_granted_NIOS_B_s1;
  --NIOS_B_s1_firsttransfer first transaction, which is an e_assign
  NIOS_B_s1_firsttransfer <= A_WE_StdLogic((std_logic'(NIOS_B_s1_begins_xfer) = '1'), NIOS_B_s1_unreg_firsttransfer, NIOS_B_s1_reg_firsttransfer);
  --NIOS_B_s1_unreg_firsttransfer first transaction, which is an e_assign
  NIOS_B_s1_unreg_firsttransfer <= NOT ((NIOS_B_s1_slavearbiterlockenable AND NIOS_B_s1_any_continuerequest));
  --NIOS_B_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_B_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_B_s1_begins_xfer) = '1' then 
        NIOS_B_s1_reg_firsttransfer <= NIOS_B_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --NIOS_B_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  NIOS_B_s1_beginbursttransfer_internal <= NIOS_B_s1_begins_xfer;
  --~NIOS_B_s1_write_n assignment, which is an e_mux
  NIOS_B_s1_write_n <= NOT ((((internal_cpu_data_master_granted_NIOS_B_s1 AND cpu_data_master_write)) AND NIOS_B_s1_pretend_byte_enable));
  shifted_address_to_NIOS_B_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --NIOS_B_s1_address mux, which is an e_mux
  NIOS_B_s1_address <= A_EXT (A_SRL(shifted_address_to_NIOS_B_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_NIOS_B_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_NIOS_B_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_NIOS_B_s1_end_xfer <= NIOS_B_s1_end_xfer;
    end if;

  end process;

  --NIOS_B_s1_waits_for_read in a cycle, which is an e_mux
  NIOS_B_s1_waits_for_read <= NIOS_B_s1_in_a_read_cycle AND NIOS_B_s1_begins_xfer;
  --NIOS_B_s1_in_a_read_cycle assignment, which is an e_assign
  NIOS_B_s1_in_a_read_cycle <= internal_cpu_data_master_granted_NIOS_B_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= NIOS_B_s1_in_a_read_cycle;
  --NIOS_B_s1_waits_for_write in a cycle, which is an e_mux
  NIOS_B_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NIOS_B_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --NIOS_B_s1_in_a_write_cycle assignment, which is an e_assign
  NIOS_B_s1_in_a_write_cycle <= internal_cpu_data_master_granted_NIOS_B_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= NIOS_B_s1_in_a_write_cycle;
  wait_for_NIOS_B_s1_counter <= std_logic'('0');
  --NIOS_B_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  NIOS_B_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_NIOS_B_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_NIOS_B_s1 <= internal_cpu_data_master_granted_NIOS_B_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_NIOS_B_s1 <= internal_cpu_data_master_qualified_request_NIOS_B_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_NIOS_B_s1 <= internal_cpu_data_master_requests_NIOS_B_s1;
--synthesis translate_off
    --NIOS_B/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity NIOS_G_s1_arbitrator is 
        port (
              -- inputs:
                 signal NIOS_G_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal NIOS_G_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal NIOS_G_s1_chipselect : OUT STD_LOGIC;
                 signal NIOS_G_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal NIOS_G_s1_reset_n : OUT STD_LOGIC;
                 signal NIOS_G_s1_write_n : OUT STD_LOGIC;
                 signal NIOS_G_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_NIOS_G_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_G_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_G_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_G_s1 : OUT STD_LOGIC;
                 signal d1_NIOS_G_s1_end_xfer : OUT STD_LOGIC
              );
end entity NIOS_G_s1_arbitrator;


architecture europa of NIOS_G_s1_arbitrator is
                signal NIOS_G_s1_allgrants :  STD_LOGIC;
                signal NIOS_G_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal NIOS_G_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal NIOS_G_s1_any_continuerequest :  STD_LOGIC;
                signal NIOS_G_s1_arb_counter_enable :  STD_LOGIC;
                signal NIOS_G_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_G_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_G_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_G_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal NIOS_G_s1_begins_xfer :  STD_LOGIC;
                signal NIOS_G_s1_end_xfer :  STD_LOGIC;
                signal NIOS_G_s1_firsttransfer :  STD_LOGIC;
                signal NIOS_G_s1_grant_vector :  STD_LOGIC;
                signal NIOS_G_s1_in_a_read_cycle :  STD_LOGIC;
                signal NIOS_G_s1_in_a_write_cycle :  STD_LOGIC;
                signal NIOS_G_s1_master_qreq_vector :  STD_LOGIC;
                signal NIOS_G_s1_non_bursting_master_requests :  STD_LOGIC;
                signal NIOS_G_s1_pretend_byte_enable :  STD_LOGIC;
                signal NIOS_G_s1_reg_firsttransfer :  STD_LOGIC;
                signal NIOS_G_s1_slavearbiterlockenable :  STD_LOGIC;
                signal NIOS_G_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal NIOS_G_s1_unreg_firsttransfer :  STD_LOGIC;
                signal NIOS_G_s1_waits_for_read :  STD_LOGIC;
                signal NIOS_G_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_NIOS_G_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_NIOS_G_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_NIOS_G_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_NIOS_G_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_NIOS_G_s1 :  STD_LOGIC;
                signal shifted_address_to_NIOS_G_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_NIOS_G_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT NIOS_G_s1_end_xfer;
    end if;

  end process;

  NIOS_G_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_NIOS_G_s1);
  --assign NIOS_G_s1_readdata_from_sa = NIOS_G_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  NIOS_G_s1_readdata_from_sa <= NIOS_G_s1_readdata;
  internal_cpu_data_master_requests_NIOS_G_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000000110000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --NIOS_G_s1_arb_share_counter set values, which is an e_mux
  NIOS_G_s1_arb_share_set_values <= std_logic_vector'("001");
  --NIOS_G_s1_non_bursting_master_requests mux, which is an e_mux
  NIOS_G_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_NIOS_G_s1;
  --NIOS_G_s1_any_bursting_master_saved_grant mux, which is an e_mux
  NIOS_G_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --NIOS_G_s1_arb_share_counter_next_value assignment, which is an e_assign
  NIOS_G_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(NIOS_G_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_G_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(NIOS_G_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_G_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --NIOS_G_s1_allgrants all slave grants, which is an e_mux
  NIOS_G_s1_allgrants <= NIOS_G_s1_grant_vector;
  --NIOS_G_s1_end_xfer assignment, which is an e_assign
  NIOS_G_s1_end_xfer <= NOT ((NIOS_G_s1_waits_for_read OR NIOS_G_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_NIOS_G_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_NIOS_G_s1 <= NIOS_G_s1_end_xfer AND (((NOT NIOS_G_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --NIOS_G_s1_arb_share_counter arbitration counter enable, which is an e_assign
  NIOS_G_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_NIOS_G_s1 AND NIOS_G_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_NIOS_G_s1 AND NOT NIOS_G_s1_non_bursting_master_requests));
  --NIOS_G_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_G_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_G_s1_arb_counter_enable) = '1' then 
        NIOS_G_s1_arb_share_counter <= NIOS_G_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --NIOS_G_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_G_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((NIOS_G_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_NIOS_G_s1)) OR ((end_xfer_arb_share_counter_term_NIOS_G_s1 AND NOT NIOS_G_s1_non_bursting_master_requests)))) = '1' then 
        NIOS_G_s1_slavearbiterlockenable <= or_reduce(NIOS_G_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master NIOS_G/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= NIOS_G_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --NIOS_G_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  NIOS_G_s1_slavearbiterlockenable2 <= or_reduce(NIOS_G_s1_arb_share_counter_next_value);
  --cpu/data_master NIOS_G/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= NIOS_G_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --NIOS_G_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  NIOS_G_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_NIOS_G_s1 <= internal_cpu_data_master_requests_NIOS_G_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_NIOS_G_s1, which is an e_mux
  cpu_data_master_read_data_valid_NIOS_G_s1 <= (internal_cpu_data_master_granted_NIOS_G_s1 AND cpu_data_master_read) AND NOT NIOS_G_s1_waits_for_read;
  --NIOS_G_s1_writedata mux, which is an e_mux
  NIOS_G_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_NIOS_G_s1 <= internal_cpu_data_master_qualified_request_NIOS_G_s1;
  --cpu/data_master saved-grant NIOS_G/s1, which is an e_assign
  cpu_data_master_saved_grant_NIOS_G_s1 <= internal_cpu_data_master_requests_NIOS_G_s1;
  --allow new arb cycle for NIOS_G/s1, which is an e_assign
  NIOS_G_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  NIOS_G_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  NIOS_G_s1_master_qreq_vector <= std_logic'('1');
  --NIOS_G_s1_reset_n assignment, which is an e_assign
  NIOS_G_s1_reset_n <= reset_n;
  NIOS_G_s1_chipselect <= internal_cpu_data_master_granted_NIOS_G_s1;
  --NIOS_G_s1_firsttransfer first transaction, which is an e_assign
  NIOS_G_s1_firsttransfer <= A_WE_StdLogic((std_logic'(NIOS_G_s1_begins_xfer) = '1'), NIOS_G_s1_unreg_firsttransfer, NIOS_G_s1_reg_firsttransfer);
  --NIOS_G_s1_unreg_firsttransfer first transaction, which is an e_assign
  NIOS_G_s1_unreg_firsttransfer <= NOT ((NIOS_G_s1_slavearbiterlockenable AND NIOS_G_s1_any_continuerequest));
  --NIOS_G_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_G_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_G_s1_begins_xfer) = '1' then 
        NIOS_G_s1_reg_firsttransfer <= NIOS_G_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --NIOS_G_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  NIOS_G_s1_beginbursttransfer_internal <= NIOS_G_s1_begins_xfer;
  --~NIOS_G_s1_write_n assignment, which is an e_mux
  NIOS_G_s1_write_n <= NOT ((((internal_cpu_data_master_granted_NIOS_G_s1 AND cpu_data_master_write)) AND NIOS_G_s1_pretend_byte_enable));
  shifted_address_to_NIOS_G_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --NIOS_G_s1_address mux, which is an e_mux
  NIOS_G_s1_address <= A_EXT (A_SRL(shifted_address_to_NIOS_G_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_NIOS_G_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_NIOS_G_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_NIOS_G_s1_end_xfer <= NIOS_G_s1_end_xfer;
    end if;

  end process;

  --NIOS_G_s1_waits_for_read in a cycle, which is an e_mux
  NIOS_G_s1_waits_for_read <= NIOS_G_s1_in_a_read_cycle AND NIOS_G_s1_begins_xfer;
  --NIOS_G_s1_in_a_read_cycle assignment, which is an e_assign
  NIOS_G_s1_in_a_read_cycle <= internal_cpu_data_master_granted_NIOS_G_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= NIOS_G_s1_in_a_read_cycle;
  --NIOS_G_s1_waits_for_write in a cycle, which is an e_mux
  NIOS_G_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NIOS_G_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --NIOS_G_s1_in_a_write_cycle assignment, which is an e_assign
  NIOS_G_s1_in_a_write_cycle <= internal_cpu_data_master_granted_NIOS_G_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= NIOS_G_s1_in_a_write_cycle;
  wait_for_NIOS_G_s1_counter <= std_logic'('0');
  --NIOS_G_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  NIOS_G_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_NIOS_G_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_NIOS_G_s1 <= internal_cpu_data_master_granted_NIOS_G_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_NIOS_G_s1 <= internal_cpu_data_master_qualified_request_NIOS_G_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_NIOS_G_s1 <= internal_cpu_data_master_requests_NIOS_G_s1;
--synthesis translate_off
    --NIOS_G/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity NIOS_R_s1_arbitrator is 
        port (
              -- inputs:
                 signal NIOS_R_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal NIOS_R_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal NIOS_R_s1_chipselect : OUT STD_LOGIC;
                 signal NIOS_R_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal NIOS_R_s1_reset_n : OUT STD_LOGIC;
                 signal NIOS_R_s1_write_n : OUT STD_LOGIC;
                 signal NIOS_R_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_NIOS_R_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_R_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_R_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_R_s1 : OUT STD_LOGIC;
                 signal d1_NIOS_R_s1_end_xfer : OUT STD_LOGIC
              );
end entity NIOS_R_s1_arbitrator;


architecture europa of NIOS_R_s1_arbitrator is
                signal NIOS_R_s1_allgrants :  STD_LOGIC;
                signal NIOS_R_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal NIOS_R_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal NIOS_R_s1_any_continuerequest :  STD_LOGIC;
                signal NIOS_R_s1_arb_counter_enable :  STD_LOGIC;
                signal NIOS_R_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_R_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_R_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal NIOS_R_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal NIOS_R_s1_begins_xfer :  STD_LOGIC;
                signal NIOS_R_s1_end_xfer :  STD_LOGIC;
                signal NIOS_R_s1_firsttransfer :  STD_LOGIC;
                signal NIOS_R_s1_grant_vector :  STD_LOGIC;
                signal NIOS_R_s1_in_a_read_cycle :  STD_LOGIC;
                signal NIOS_R_s1_in_a_write_cycle :  STD_LOGIC;
                signal NIOS_R_s1_master_qreq_vector :  STD_LOGIC;
                signal NIOS_R_s1_non_bursting_master_requests :  STD_LOGIC;
                signal NIOS_R_s1_pretend_byte_enable :  STD_LOGIC;
                signal NIOS_R_s1_reg_firsttransfer :  STD_LOGIC;
                signal NIOS_R_s1_slavearbiterlockenable :  STD_LOGIC;
                signal NIOS_R_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal NIOS_R_s1_unreg_firsttransfer :  STD_LOGIC;
                signal NIOS_R_s1_waits_for_read :  STD_LOGIC;
                signal NIOS_R_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_NIOS_R_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_NIOS_R_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_NIOS_R_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_NIOS_R_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_NIOS_R_s1 :  STD_LOGIC;
                signal shifted_address_to_NIOS_R_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_NIOS_R_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT NIOS_R_s1_end_xfer;
    end if;

  end process;

  NIOS_R_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_NIOS_R_s1);
  --assign NIOS_R_s1_readdata_from_sa = NIOS_R_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  NIOS_R_s1_readdata_from_sa <= NIOS_R_s1_readdata;
  internal_cpu_data_master_requests_NIOS_R_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000001100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --NIOS_R_s1_arb_share_counter set values, which is an e_mux
  NIOS_R_s1_arb_share_set_values <= std_logic_vector'("001");
  --NIOS_R_s1_non_bursting_master_requests mux, which is an e_mux
  NIOS_R_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_NIOS_R_s1;
  --NIOS_R_s1_any_bursting_master_saved_grant mux, which is an e_mux
  NIOS_R_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --NIOS_R_s1_arb_share_counter_next_value assignment, which is an e_assign
  NIOS_R_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(NIOS_R_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_R_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(NIOS_R_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (NIOS_R_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --NIOS_R_s1_allgrants all slave grants, which is an e_mux
  NIOS_R_s1_allgrants <= NIOS_R_s1_grant_vector;
  --NIOS_R_s1_end_xfer assignment, which is an e_assign
  NIOS_R_s1_end_xfer <= NOT ((NIOS_R_s1_waits_for_read OR NIOS_R_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_NIOS_R_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_NIOS_R_s1 <= NIOS_R_s1_end_xfer AND (((NOT NIOS_R_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --NIOS_R_s1_arb_share_counter arbitration counter enable, which is an e_assign
  NIOS_R_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_NIOS_R_s1 AND NIOS_R_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_NIOS_R_s1 AND NOT NIOS_R_s1_non_bursting_master_requests));
  --NIOS_R_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_R_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_R_s1_arb_counter_enable) = '1' then 
        NIOS_R_s1_arb_share_counter <= NIOS_R_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --NIOS_R_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_R_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((NIOS_R_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_NIOS_R_s1)) OR ((end_xfer_arb_share_counter_term_NIOS_R_s1 AND NOT NIOS_R_s1_non_bursting_master_requests)))) = '1' then 
        NIOS_R_s1_slavearbiterlockenable <= or_reduce(NIOS_R_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master NIOS_R/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= NIOS_R_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --NIOS_R_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  NIOS_R_s1_slavearbiterlockenable2 <= or_reduce(NIOS_R_s1_arb_share_counter_next_value);
  --cpu/data_master NIOS_R/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= NIOS_R_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --NIOS_R_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  NIOS_R_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_NIOS_R_s1 <= internal_cpu_data_master_requests_NIOS_R_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_NIOS_R_s1, which is an e_mux
  cpu_data_master_read_data_valid_NIOS_R_s1 <= (internal_cpu_data_master_granted_NIOS_R_s1 AND cpu_data_master_read) AND NOT NIOS_R_s1_waits_for_read;
  --NIOS_R_s1_writedata mux, which is an e_mux
  NIOS_R_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_NIOS_R_s1 <= internal_cpu_data_master_qualified_request_NIOS_R_s1;
  --cpu/data_master saved-grant NIOS_R/s1, which is an e_assign
  cpu_data_master_saved_grant_NIOS_R_s1 <= internal_cpu_data_master_requests_NIOS_R_s1;
  --allow new arb cycle for NIOS_R/s1, which is an e_assign
  NIOS_R_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  NIOS_R_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  NIOS_R_s1_master_qreq_vector <= std_logic'('1');
  --NIOS_R_s1_reset_n assignment, which is an e_assign
  NIOS_R_s1_reset_n <= reset_n;
  NIOS_R_s1_chipselect <= internal_cpu_data_master_granted_NIOS_R_s1;
  --NIOS_R_s1_firsttransfer first transaction, which is an e_assign
  NIOS_R_s1_firsttransfer <= A_WE_StdLogic((std_logic'(NIOS_R_s1_begins_xfer) = '1'), NIOS_R_s1_unreg_firsttransfer, NIOS_R_s1_reg_firsttransfer);
  --NIOS_R_s1_unreg_firsttransfer first transaction, which is an e_assign
  NIOS_R_s1_unreg_firsttransfer <= NOT ((NIOS_R_s1_slavearbiterlockenable AND NIOS_R_s1_any_continuerequest));
  --NIOS_R_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      NIOS_R_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(NIOS_R_s1_begins_xfer) = '1' then 
        NIOS_R_s1_reg_firsttransfer <= NIOS_R_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --NIOS_R_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  NIOS_R_s1_beginbursttransfer_internal <= NIOS_R_s1_begins_xfer;
  --~NIOS_R_s1_write_n assignment, which is an e_mux
  NIOS_R_s1_write_n <= NOT ((((internal_cpu_data_master_granted_NIOS_R_s1 AND cpu_data_master_write)) AND NIOS_R_s1_pretend_byte_enable));
  shifted_address_to_NIOS_R_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --NIOS_R_s1_address mux, which is an e_mux
  NIOS_R_s1_address <= A_EXT (A_SRL(shifted_address_to_NIOS_R_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_NIOS_R_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_NIOS_R_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_NIOS_R_s1_end_xfer <= NIOS_R_s1_end_xfer;
    end if;

  end process;

  --NIOS_R_s1_waits_for_read in a cycle, which is an e_mux
  NIOS_R_s1_waits_for_read <= NIOS_R_s1_in_a_read_cycle AND NIOS_R_s1_begins_xfer;
  --NIOS_R_s1_in_a_read_cycle assignment, which is an e_assign
  NIOS_R_s1_in_a_read_cycle <= internal_cpu_data_master_granted_NIOS_R_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= NIOS_R_s1_in_a_read_cycle;
  --NIOS_R_s1_waits_for_write in a cycle, which is an e_mux
  NIOS_R_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NIOS_R_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --NIOS_R_s1_in_a_write_cycle assignment, which is an e_assign
  NIOS_R_s1_in_a_write_cycle <= internal_cpu_data_master_granted_NIOS_R_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= NIOS_R_s1_in_a_write_cycle;
  wait_for_NIOS_R_s1_counter <= std_logic'('0');
  --NIOS_R_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  NIOS_R_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_NIOS_R_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_NIOS_R_s1 <= internal_cpu_data_master_granted_NIOS_R_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_NIOS_R_s1 <= internal_cpu_data_master_qualified_request_NIOS_R_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_NIOS_R_s1 <= internal_cpu_data_master_requests_NIOS_R_s1;
--synthesis translate_off
    --NIOS_R/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SEG7_ADDR_s1_arbitrator is 
        port (
              -- inputs:
                 signal SEG7_ADDR_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SEG7_ADDR_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal SEG7_ADDR_s1_chipselect : OUT STD_LOGIC;
                 signal SEG7_ADDR_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal SEG7_ADDR_s1_reset_n : OUT STD_LOGIC;
                 signal SEG7_ADDR_s1_write_n : OUT STD_LOGIC;
                 signal SEG7_ADDR_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_granted_SEG7_ADDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_SEG7_ADDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SEG7_ADDR_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_SEG7_ADDR_s1 : OUT STD_LOGIC;
                 signal d1_SEG7_ADDR_s1_end_xfer : OUT STD_LOGIC
              );
end entity SEG7_ADDR_s1_arbitrator;


architecture europa of SEG7_ADDR_s1_arbitrator is
                signal SEG7_ADDR_s1_allgrants :  STD_LOGIC;
                signal SEG7_ADDR_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal SEG7_ADDR_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal SEG7_ADDR_s1_any_continuerequest :  STD_LOGIC;
                signal SEG7_ADDR_s1_arb_counter_enable :  STD_LOGIC;
                signal SEG7_ADDR_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_ADDR_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_ADDR_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_ADDR_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal SEG7_ADDR_s1_begins_xfer :  STD_LOGIC;
                signal SEG7_ADDR_s1_end_xfer :  STD_LOGIC;
                signal SEG7_ADDR_s1_firsttransfer :  STD_LOGIC;
                signal SEG7_ADDR_s1_grant_vector :  STD_LOGIC;
                signal SEG7_ADDR_s1_in_a_read_cycle :  STD_LOGIC;
                signal SEG7_ADDR_s1_in_a_write_cycle :  STD_LOGIC;
                signal SEG7_ADDR_s1_master_qreq_vector :  STD_LOGIC;
                signal SEG7_ADDR_s1_non_bursting_master_requests :  STD_LOGIC;
                signal SEG7_ADDR_s1_reg_firsttransfer :  STD_LOGIC;
                signal SEG7_ADDR_s1_slavearbiterlockenable :  STD_LOGIC;
                signal SEG7_ADDR_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal SEG7_ADDR_s1_unreg_firsttransfer :  STD_LOGIC;
                signal SEG7_ADDR_s1_waits_for_read :  STD_LOGIC;
                signal SEG7_ADDR_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_SEG7_ADDR_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_SEG7_ADDR_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_SEG7_ADDR_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_SEG7_ADDR_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_SEG7_ADDR_s1 :  STD_LOGIC;
                signal shifted_address_to_SEG7_ADDR_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_SEG7_ADDR_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT SEG7_ADDR_s1_end_xfer;
    end if;

  end process;

  SEG7_ADDR_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_SEG7_ADDR_s1);
  --assign SEG7_ADDR_s1_readdata_from_sa = SEG7_ADDR_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  SEG7_ADDR_s1_readdata_from_sa <= SEG7_ADDR_s1_readdata;
  internal_cpu_data_master_requests_SEG7_ADDR_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000010010000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --SEG7_ADDR_s1_arb_share_counter set values, which is an e_mux
  SEG7_ADDR_s1_arb_share_set_values <= std_logic_vector'("001");
  --SEG7_ADDR_s1_non_bursting_master_requests mux, which is an e_mux
  SEG7_ADDR_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_SEG7_ADDR_s1;
  --SEG7_ADDR_s1_any_bursting_master_saved_grant mux, which is an e_mux
  SEG7_ADDR_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --SEG7_ADDR_s1_arb_share_counter_next_value assignment, which is an e_assign
  SEG7_ADDR_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(SEG7_ADDR_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SEG7_ADDR_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(SEG7_ADDR_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SEG7_ADDR_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --SEG7_ADDR_s1_allgrants all slave grants, which is an e_mux
  SEG7_ADDR_s1_allgrants <= SEG7_ADDR_s1_grant_vector;
  --SEG7_ADDR_s1_end_xfer assignment, which is an e_assign
  SEG7_ADDR_s1_end_xfer <= NOT ((SEG7_ADDR_s1_waits_for_read OR SEG7_ADDR_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_SEG7_ADDR_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_SEG7_ADDR_s1 <= SEG7_ADDR_s1_end_xfer AND (((NOT SEG7_ADDR_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --SEG7_ADDR_s1_arb_share_counter arbitration counter enable, which is an e_assign
  SEG7_ADDR_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_SEG7_ADDR_s1 AND SEG7_ADDR_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_SEG7_ADDR_s1 AND NOT SEG7_ADDR_s1_non_bursting_master_requests));
  --SEG7_ADDR_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_ADDR_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(SEG7_ADDR_s1_arb_counter_enable) = '1' then 
        SEG7_ADDR_s1_arb_share_counter <= SEG7_ADDR_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --SEG7_ADDR_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_ADDR_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((SEG7_ADDR_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_SEG7_ADDR_s1)) OR ((end_xfer_arb_share_counter_term_SEG7_ADDR_s1 AND NOT SEG7_ADDR_s1_non_bursting_master_requests)))) = '1' then 
        SEG7_ADDR_s1_slavearbiterlockenable <= or_reduce(SEG7_ADDR_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master SEG7_ADDR/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= SEG7_ADDR_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --SEG7_ADDR_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  SEG7_ADDR_s1_slavearbiterlockenable2 <= or_reduce(SEG7_ADDR_s1_arb_share_counter_next_value);
  --cpu/data_master SEG7_ADDR/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= SEG7_ADDR_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --SEG7_ADDR_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  SEG7_ADDR_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_SEG7_ADDR_s1 <= internal_cpu_data_master_requests_SEG7_ADDR_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_SEG7_ADDR_s1, which is an e_mux
  cpu_data_master_read_data_valid_SEG7_ADDR_s1 <= (internal_cpu_data_master_granted_SEG7_ADDR_s1 AND cpu_data_master_read) AND NOT SEG7_ADDR_s1_waits_for_read;
  --SEG7_ADDR_s1_writedata mux, which is an e_mux
  SEG7_ADDR_s1_writedata <= cpu_data_master_writedata (3 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_SEG7_ADDR_s1 <= internal_cpu_data_master_qualified_request_SEG7_ADDR_s1;
  --cpu/data_master saved-grant SEG7_ADDR/s1, which is an e_assign
  cpu_data_master_saved_grant_SEG7_ADDR_s1 <= internal_cpu_data_master_requests_SEG7_ADDR_s1;
  --allow new arb cycle for SEG7_ADDR/s1, which is an e_assign
  SEG7_ADDR_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  SEG7_ADDR_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  SEG7_ADDR_s1_master_qreq_vector <= std_logic'('1');
  --SEG7_ADDR_s1_reset_n assignment, which is an e_assign
  SEG7_ADDR_s1_reset_n <= reset_n;
  SEG7_ADDR_s1_chipselect <= internal_cpu_data_master_granted_SEG7_ADDR_s1;
  --SEG7_ADDR_s1_firsttransfer first transaction, which is an e_assign
  SEG7_ADDR_s1_firsttransfer <= A_WE_StdLogic((std_logic'(SEG7_ADDR_s1_begins_xfer) = '1'), SEG7_ADDR_s1_unreg_firsttransfer, SEG7_ADDR_s1_reg_firsttransfer);
  --SEG7_ADDR_s1_unreg_firsttransfer first transaction, which is an e_assign
  SEG7_ADDR_s1_unreg_firsttransfer <= NOT ((SEG7_ADDR_s1_slavearbiterlockenable AND SEG7_ADDR_s1_any_continuerequest));
  --SEG7_ADDR_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_ADDR_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(SEG7_ADDR_s1_begins_xfer) = '1' then 
        SEG7_ADDR_s1_reg_firsttransfer <= SEG7_ADDR_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --SEG7_ADDR_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  SEG7_ADDR_s1_beginbursttransfer_internal <= SEG7_ADDR_s1_begins_xfer;
  --~SEG7_ADDR_s1_write_n assignment, which is an e_mux
  SEG7_ADDR_s1_write_n <= NOT ((internal_cpu_data_master_granted_SEG7_ADDR_s1 AND cpu_data_master_write));
  shifted_address_to_SEG7_ADDR_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --SEG7_ADDR_s1_address mux, which is an e_mux
  SEG7_ADDR_s1_address <= A_EXT (A_SRL(shifted_address_to_SEG7_ADDR_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_SEG7_ADDR_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_SEG7_ADDR_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_SEG7_ADDR_s1_end_xfer <= SEG7_ADDR_s1_end_xfer;
    end if;

  end process;

  --SEG7_ADDR_s1_waits_for_read in a cycle, which is an e_mux
  SEG7_ADDR_s1_waits_for_read <= SEG7_ADDR_s1_in_a_read_cycle AND SEG7_ADDR_s1_begins_xfer;
  --SEG7_ADDR_s1_in_a_read_cycle assignment, which is an e_assign
  SEG7_ADDR_s1_in_a_read_cycle <= internal_cpu_data_master_granted_SEG7_ADDR_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SEG7_ADDR_s1_in_a_read_cycle;
  --SEG7_ADDR_s1_waits_for_write in a cycle, which is an e_mux
  SEG7_ADDR_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SEG7_ADDR_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --SEG7_ADDR_s1_in_a_write_cycle assignment, which is an e_assign
  SEG7_ADDR_s1_in_a_write_cycle <= internal_cpu_data_master_granted_SEG7_ADDR_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SEG7_ADDR_s1_in_a_write_cycle;
  wait_for_SEG7_ADDR_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_SEG7_ADDR_s1 <= internal_cpu_data_master_granted_SEG7_ADDR_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_SEG7_ADDR_s1 <= internal_cpu_data_master_qualified_request_SEG7_ADDR_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_SEG7_ADDR_s1 <= internal_cpu_data_master_requests_SEG7_ADDR_s1;
--synthesis translate_off
    --SEG7_ADDR/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SEG7_DATA_s1_arbitrator is 
        port (
              -- inputs:
                 signal SEG7_DATA_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SEG7_DATA_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal SEG7_DATA_s1_chipselect : OUT STD_LOGIC;
                 signal SEG7_DATA_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal SEG7_DATA_s1_reset_n : OUT STD_LOGIC;
                 signal SEG7_DATA_s1_write_n : OUT STD_LOGIC;
                 signal SEG7_DATA_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_granted_SEG7_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_SEG7_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SEG7_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_SEG7_DATA_s1 : OUT STD_LOGIC;
                 signal d1_SEG7_DATA_s1_end_xfer : OUT STD_LOGIC
              );
end entity SEG7_DATA_s1_arbitrator;


architecture europa of SEG7_DATA_s1_arbitrator is
                signal SEG7_DATA_s1_allgrants :  STD_LOGIC;
                signal SEG7_DATA_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal SEG7_DATA_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal SEG7_DATA_s1_any_continuerequest :  STD_LOGIC;
                signal SEG7_DATA_s1_arb_counter_enable :  STD_LOGIC;
                signal SEG7_DATA_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_DATA_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_DATA_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SEG7_DATA_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal SEG7_DATA_s1_begins_xfer :  STD_LOGIC;
                signal SEG7_DATA_s1_end_xfer :  STD_LOGIC;
                signal SEG7_DATA_s1_firsttransfer :  STD_LOGIC;
                signal SEG7_DATA_s1_grant_vector :  STD_LOGIC;
                signal SEG7_DATA_s1_in_a_read_cycle :  STD_LOGIC;
                signal SEG7_DATA_s1_in_a_write_cycle :  STD_LOGIC;
                signal SEG7_DATA_s1_master_qreq_vector :  STD_LOGIC;
                signal SEG7_DATA_s1_non_bursting_master_requests :  STD_LOGIC;
                signal SEG7_DATA_s1_reg_firsttransfer :  STD_LOGIC;
                signal SEG7_DATA_s1_slavearbiterlockenable :  STD_LOGIC;
                signal SEG7_DATA_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal SEG7_DATA_s1_unreg_firsttransfer :  STD_LOGIC;
                signal SEG7_DATA_s1_waits_for_read :  STD_LOGIC;
                signal SEG7_DATA_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_SEG7_DATA_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_SEG7_DATA_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_SEG7_DATA_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_SEG7_DATA_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_SEG7_DATA_s1 :  STD_LOGIC;
                signal shifted_address_to_SEG7_DATA_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_SEG7_DATA_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT SEG7_DATA_s1_end_xfer;
    end if;

  end process;

  SEG7_DATA_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_SEG7_DATA_s1);
  --assign SEG7_DATA_s1_readdata_from_sa = SEG7_DATA_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  SEG7_DATA_s1_readdata_from_sa <= SEG7_DATA_s1_readdata;
  internal_cpu_data_master_requests_SEG7_DATA_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000010100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --SEG7_DATA_s1_arb_share_counter set values, which is an e_mux
  SEG7_DATA_s1_arb_share_set_values <= std_logic_vector'("001");
  --SEG7_DATA_s1_non_bursting_master_requests mux, which is an e_mux
  SEG7_DATA_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_SEG7_DATA_s1;
  --SEG7_DATA_s1_any_bursting_master_saved_grant mux, which is an e_mux
  SEG7_DATA_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --SEG7_DATA_s1_arb_share_counter_next_value assignment, which is an e_assign
  SEG7_DATA_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(SEG7_DATA_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SEG7_DATA_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(SEG7_DATA_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SEG7_DATA_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --SEG7_DATA_s1_allgrants all slave grants, which is an e_mux
  SEG7_DATA_s1_allgrants <= SEG7_DATA_s1_grant_vector;
  --SEG7_DATA_s1_end_xfer assignment, which is an e_assign
  SEG7_DATA_s1_end_xfer <= NOT ((SEG7_DATA_s1_waits_for_read OR SEG7_DATA_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_SEG7_DATA_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_SEG7_DATA_s1 <= SEG7_DATA_s1_end_xfer AND (((NOT SEG7_DATA_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --SEG7_DATA_s1_arb_share_counter arbitration counter enable, which is an e_assign
  SEG7_DATA_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_SEG7_DATA_s1 AND SEG7_DATA_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_SEG7_DATA_s1 AND NOT SEG7_DATA_s1_non_bursting_master_requests));
  --SEG7_DATA_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_DATA_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(SEG7_DATA_s1_arb_counter_enable) = '1' then 
        SEG7_DATA_s1_arb_share_counter <= SEG7_DATA_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --SEG7_DATA_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_DATA_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((SEG7_DATA_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_SEG7_DATA_s1)) OR ((end_xfer_arb_share_counter_term_SEG7_DATA_s1 AND NOT SEG7_DATA_s1_non_bursting_master_requests)))) = '1' then 
        SEG7_DATA_s1_slavearbiterlockenable <= or_reduce(SEG7_DATA_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master SEG7_DATA/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= SEG7_DATA_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --SEG7_DATA_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  SEG7_DATA_s1_slavearbiterlockenable2 <= or_reduce(SEG7_DATA_s1_arb_share_counter_next_value);
  --cpu/data_master SEG7_DATA/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= SEG7_DATA_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --SEG7_DATA_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  SEG7_DATA_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_SEG7_DATA_s1 <= internal_cpu_data_master_requests_SEG7_DATA_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_SEG7_DATA_s1, which is an e_mux
  cpu_data_master_read_data_valid_SEG7_DATA_s1 <= (internal_cpu_data_master_granted_SEG7_DATA_s1 AND cpu_data_master_read) AND NOT SEG7_DATA_s1_waits_for_read;
  --SEG7_DATA_s1_writedata mux, which is an e_mux
  SEG7_DATA_s1_writedata <= cpu_data_master_writedata (3 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_SEG7_DATA_s1 <= internal_cpu_data_master_qualified_request_SEG7_DATA_s1;
  --cpu/data_master saved-grant SEG7_DATA/s1, which is an e_assign
  cpu_data_master_saved_grant_SEG7_DATA_s1 <= internal_cpu_data_master_requests_SEG7_DATA_s1;
  --allow new arb cycle for SEG7_DATA/s1, which is an e_assign
  SEG7_DATA_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  SEG7_DATA_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  SEG7_DATA_s1_master_qreq_vector <= std_logic'('1');
  --SEG7_DATA_s1_reset_n assignment, which is an e_assign
  SEG7_DATA_s1_reset_n <= reset_n;
  SEG7_DATA_s1_chipselect <= internal_cpu_data_master_granted_SEG7_DATA_s1;
  --SEG7_DATA_s1_firsttransfer first transaction, which is an e_assign
  SEG7_DATA_s1_firsttransfer <= A_WE_StdLogic((std_logic'(SEG7_DATA_s1_begins_xfer) = '1'), SEG7_DATA_s1_unreg_firsttransfer, SEG7_DATA_s1_reg_firsttransfer);
  --SEG7_DATA_s1_unreg_firsttransfer first transaction, which is an e_assign
  SEG7_DATA_s1_unreg_firsttransfer <= NOT ((SEG7_DATA_s1_slavearbiterlockenable AND SEG7_DATA_s1_any_continuerequest));
  --SEG7_DATA_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SEG7_DATA_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(SEG7_DATA_s1_begins_xfer) = '1' then 
        SEG7_DATA_s1_reg_firsttransfer <= SEG7_DATA_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --SEG7_DATA_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  SEG7_DATA_s1_beginbursttransfer_internal <= SEG7_DATA_s1_begins_xfer;
  --~SEG7_DATA_s1_write_n assignment, which is an e_mux
  SEG7_DATA_s1_write_n <= NOT ((internal_cpu_data_master_granted_SEG7_DATA_s1 AND cpu_data_master_write));
  shifted_address_to_SEG7_DATA_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --SEG7_DATA_s1_address mux, which is an e_mux
  SEG7_DATA_s1_address <= A_EXT (A_SRL(shifted_address_to_SEG7_DATA_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_SEG7_DATA_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_SEG7_DATA_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_SEG7_DATA_s1_end_xfer <= SEG7_DATA_s1_end_xfer;
    end if;

  end process;

  --SEG7_DATA_s1_waits_for_read in a cycle, which is an e_mux
  SEG7_DATA_s1_waits_for_read <= SEG7_DATA_s1_in_a_read_cycle AND SEG7_DATA_s1_begins_xfer;
  --SEG7_DATA_s1_in_a_read_cycle assignment, which is an e_assign
  SEG7_DATA_s1_in_a_read_cycle <= internal_cpu_data_master_granted_SEG7_DATA_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SEG7_DATA_s1_in_a_read_cycle;
  --SEG7_DATA_s1_waits_for_write in a cycle, which is an e_mux
  SEG7_DATA_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SEG7_DATA_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --SEG7_DATA_s1_in_a_write_cycle assignment, which is an e_assign
  SEG7_DATA_s1_in_a_write_cycle <= internal_cpu_data_master_granted_SEG7_DATA_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SEG7_DATA_s1_in_a_write_cycle;
  wait_for_SEG7_DATA_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_SEG7_DATA_s1 <= internal_cpu_data_master_granted_SEG7_DATA_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_SEG7_DATA_s1 <= internal_cpu_data_master_qualified_request_SEG7_DATA_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_SEG7_DATA_s1 <= internal_cpu_data_master_requests_SEG7_DATA_s1;
--synthesis translate_off
    --SEG7_DATA/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SW_s1_arbitrator is 
        port (
              -- inputs:
                 signal SW_s1_irq : IN STD_LOGIC;
                 signal SW_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SW_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal SW_s1_chipselect : OUT STD_LOGIC;
                 signal SW_s1_irq_from_sa : OUT STD_LOGIC;
                 signal SW_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal SW_s1_reset_n : OUT STD_LOGIC;
                 signal SW_s1_write_n : OUT STD_LOGIC;
                 signal SW_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_granted_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SW_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_SW_s1 : OUT STD_LOGIC;
                 signal d1_SW_s1_end_xfer : OUT STD_LOGIC
              );
end entity SW_s1_arbitrator;


architecture europa of SW_s1_arbitrator is
                signal SW_s1_allgrants :  STD_LOGIC;
                signal SW_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal SW_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal SW_s1_any_continuerequest :  STD_LOGIC;
                signal SW_s1_arb_counter_enable :  STD_LOGIC;
                signal SW_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SW_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SW_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal SW_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal SW_s1_begins_xfer :  STD_LOGIC;
                signal SW_s1_end_xfer :  STD_LOGIC;
                signal SW_s1_firsttransfer :  STD_LOGIC;
                signal SW_s1_grant_vector :  STD_LOGIC;
                signal SW_s1_in_a_read_cycle :  STD_LOGIC;
                signal SW_s1_in_a_write_cycle :  STD_LOGIC;
                signal SW_s1_master_qreq_vector :  STD_LOGIC;
                signal SW_s1_non_bursting_master_requests :  STD_LOGIC;
                signal SW_s1_pretend_byte_enable :  STD_LOGIC;
                signal SW_s1_reg_firsttransfer :  STD_LOGIC;
                signal SW_s1_slavearbiterlockenable :  STD_LOGIC;
                signal SW_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal SW_s1_unreg_firsttransfer :  STD_LOGIC;
                signal SW_s1_waits_for_read :  STD_LOGIC;
                signal SW_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_SW_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_SW_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_SW_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_SW_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_SW_s1 :  STD_LOGIC;
                signal shifted_address_to_SW_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_SW_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT SW_s1_end_xfer;
    end if;

  end process;

  SW_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_SW_s1);
  --assign SW_s1_readdata_from_sa = SW_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  SW_s1_readdata_from_sa <= SW_s1_readdata;
  internal_cpu_data_master_requests_SW_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000010000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --SW_s1_arb_share_counter set values, which is an e_mux
  SW_s1_arb_share_set_values <= std_logic_vector'("001");
  --SW_s1_non_bursting_master_requests mux, which is an e_mux
  SW_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_SW_s1;
  --SW_s1_any_bursting_master_saved_grant mux, which is an e_mux
  SW_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --SW_s1_arb_share_counter_next_value assignment, which is an e_assign
  SW_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(SW_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SW_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(SW_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (SW_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --SW_s1_allgrants all slave grants, which is an e_mux
  SW_s1_allgrants <= SW_s1_grant_vector;
  --SW_s1_end_xfer assignment, which is an e_assign
  SW_s1_end_xfer <= NOT ((SW_s1_waits_for_read OR SW_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_SW_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_SW_s1 <= SW_s1_end_xfer AND (((NOT SW_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --SW_s1_arb_share_counter arbitration counter enable, which is an e_assign
  SW_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_SW_s1 AND SW_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_SW_s1 AND NOT SW_s1_non_bursting_master_requests));
  --SW_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SW_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(SW_s1_arb_counter_enable) = '1' then 
        SW_s1_arb_share_counter <= SW_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --SW_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SW_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((SW_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_SW_s1)) OR ((end_xfer_arb_share_counter_term_SW_s1 AND NOT SW_s1_non_bursting_master_requests)))) = '1' then 
        SW_s1_slavearbiterlockenable <= or_reduce(SW_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master SW/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= SW_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --SW_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  SW_s1_slavearbiterlockenable2 <= or_reduce(SW_s1_arb_share_counter_next_value);
  --cpu/data_master SW/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= SW_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --SW_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  SW_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_SW_s1 <= internal_cpu_data_master_requests_SW_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_SW_s1, which is an e_mux
  cpu_data_master_read_data_valid_SW_s1 <= (internal_cpu_data_master_granted_SW_s1 AND cpu_data_master_read) AND NOT SW_s1_waits_for_read;
  --SW_s1_writedata mux, which is an e_mux
  SW_s1_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_SW_s1 <= internal_cpu_data_master_qualified_request_SW_s1;
  --cpu/data_master saved-grant SW/s1, which is an e_assign
  cpu_data_master_saved_grant_SW_s1 <= internal_cpu_data_master_requests_SW_s1;
  --allow new arb cycle for SW/s1, which is an e_assign
  SW_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  SW_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  SW_s1_master_qreq_vector <= std_logic'('1');
  --SW_s1_reset_n assignment, which is an e_assign
  SW_s1_reset_n <= reset_n;
  SW_s1_chipselect <= internal_cpu_data_master_granted_SW_s1;
  --SW_s1_firsttransfer first transaction, which is an e_assign
  SW_s1_firsttransfer <= A_WE_StdLogic((std_logic'(SW_s1_begins_xfer) = '1'), SW_s1_unreg_firsttransfer, SW_s1_reg_firsttransfer);
  --SW_s1_unreg_firsttransfer first transaction, which is an e_assign
  SW_s1_unreg_firsttransfer <= NOT ((SW_s1_slavearbiterlockenable AND SW_s1_any_continuerequest));
  --SW_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SW_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(SW_s1_begins_xfer) = '1' then 
        SW_s1_reg_firsttransfer <= SW_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --SW_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  SW_s1_beginbursttransfer_internal <= SW_s1_begins_xfer;
  --~SW_s1_write_n assignment, which is an e_mux
  SW_s1_write_n <= NOT ((((internal_cpu_data_master_granted_SW_s1 AND cpu_data_master_write)) AND SW_s1_pretend_byte_enable));
  shifted_address_to_SW_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --SW_s1_address mux, which is an e_mux
  SW_s1_address <= A_EXT (A_SRL(shifted_address_to_SW_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_SW_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_SW_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_SW_s1_end_xfer <= SW_s1_end_xfer;
    end if;

  end process;

  --SW_s1_waits_for_read in a cycle, which is an e_mux
  SW_s1_waits_for_read <= SW_s1_in_a_read_cycle AND SW_s1_begins_xfer;
  --SW_s1_in_a_read_cycle assignment, which is an e_assign
  SW_s1_in_a_read_cycle <= internal_cpu_data_master_granted_SW_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SW_s1_in_a_read_cycle;
  --SW_s1_waits_for_write in a cycle, which is an e_mux
  SW_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SW_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --SW_s1_in_a_write_cycle assignment, which is an e_assign
  SW_s1_in_a_write_cycle <= internal_cpu_data_master_granted_SW_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SW_s1_in_a_write_cycle;
  wait_for_SW_s1_counter <= std_logic'('0');
  --SW_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  SW_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_SW_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --assign SW_s1_irq_from_sa = SW_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  SW_s1_irq_from_sa <= SW_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_SW_s1 <= internal_cpu_data_master_granted_SW_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_SW_s1 <= internal_cpu_data_master_qualified_request_SW_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_SW_s1 <= internal_cpu_data_master_requests_SW_s1;
--synthesis translate_off
    --SW/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
end entity cpu_jtag_debug_module_arbitrator;


architecture europa of cpu_jtag_debug_module_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_bursting_master_saved_grant :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_non_bursting_master_requests :  STD_LOGIC;
                signal cpu_jtag_debug_module_reg_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_jtag_debug_module_slavearbiterlockenable2 :  STD_LOGIC;
                signal cpu_jtag_debug_module_unreg_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_cpu_jtag_debug_module :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_cpu_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT cpu_jtag_debug_module_end_xfer;
    end if;

  end process;

  cpu_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cpu_jtag_debug_module OR internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  --assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_readdata_from_sa <= cpu_jtag_debug_module_readdata;
  internal_cpu_data_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("100000100000100000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_jtag_debug_module_arb_share_set_values <= std_logic_vector'("001");
  --cpu_jtag_debug_module_non_bursting_master_requests mux, which is an e_mux
  cpu_jtag_debug_module_non_bursting_master_requests <= ((internal_cpu_data_master_requests_cpu_jtag_debug_module OR internal_cpu_instruction_master_requests_cpu_jtag_debug_module) OR internal_cpu_data_master_requests_cpu_jtag_debug_module) OR internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_bursting_master_saved_grant mux, which is an e_mux
  cpu_jtag_debug_module_any_bursting_master_saved_grant <= std_logic'('0');
  --cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_jtag_debug_module_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_jtag_debug_module_allgrants <= (((or_reduce(cpu_jtag_debug_module_grant_vector)) OR (or_reduce(cpu_jtag_debug_module_grant_vector))) OR (or_reduce(cpu_jtag_debug_module_grant_vector))) OR (or_reduce(cpu_jtag_debug_module_grant_vector));
  --cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_jtag_debug_module_end_xfer <= NOT ((cpu_jtag_debug_module_waits_for_read OR cpu_jtag_debug_module_waits_for_write));
  --end_xfer_arb_share_counter_term_cpu_jtag_debug_module arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_cpu_jtag_debug_module <= cpu_jtag_debug_module_end_xfer AND (((NOT cpu_jtag_debug_module_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_jtag_debug_module_arb_counter_enable <= ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND cpu_jtag_debug_module_allgrants)) OR ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND NOT cpu_jtag_debug_module_non_bursting_master_requests));
  --cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(cpu_jtag_debug_module_master_qreq_vector) AND end_xfer_arb_share_counter_term_cpu_jtag_debug_module)) OR ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND NOT cpu_jtag_debug_module_non_bursting_master_requests)))) = '1' then 
        cpu_jtag_debug_module_slavearbiterlockenable <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu_jtag_debug_module_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  cpu_jtag_debug_module_slavearbiterlockenable2 <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
  --cpu/data_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= cpu_jtag_debug_module_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_instruction_master_arbiterlock2 <= cpu_jtag_debug_module_slavearbiterlockenable2 AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module))))));
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_jtag_debug_module_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module AND NOT ((((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000")))))) OR cpu_instruction_master_arbiterlock));
  --local readdatavalid cpu_data_master_read_data_valid_cpu_jtag_debug_module, which is an e_mux
  cpu_data_master_read_data_valid_cpu_jtag_debug_module <= (internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read) AND NOT cpu_jtag_debug_module_waits_for_read;
  --cpu_jtag_debug_module_writedata mux, which is an e_mux
  cpu_jtag_debug_module_writedata <= cpu_data_master_writedata;
  internal_cpu_instruction_master_requests_cpu_jtag_debug_module <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("100000100000100000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module))))));
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module AND NOT ((((cpu_instruction_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000")))))) OR cpu_data_master_arbiterlock));
  --local readdatavalid cpu_instruction_master_read_data_valid_cpu_jtag_debug_module, which is an e_mux
  cpu_instruction_master_read_data_valid_cpu_jtag_debug_module <= (internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read) AND NOT cpu_jtag_debug_module_waits_for_read;
  --allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_instruction_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(0);
  --cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_instruction_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(0) AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_data_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(1);
  --cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_data_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(1) AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_jtag_debug_module_master_qreq_vector & cpu_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_jtag_debug_module_master_qreq_vector & NOT cpu_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_jtag_debug_module_grant_vector)))) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(1) OR cpu_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(0) OR cpu_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1' then 
        cpu_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_end_xfer) = '1'), cpu_jtag_debug_module_chosen_master_rot_left, cpu_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begintransfer <= cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  cpu_jtag_debug_module_reset_n <= reset_n;
  --assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_resetrequest_from_sa <= cpu_jtag_debug_module_resetrequest;
  cpu_jtag_debug_module_chipselect <= internal_cpu_data_master_granted_cpu_jtag_debug_module OR internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_firsttransfer <= A_WE_StdLogic((std_logic'(cpu_jtag_debug_module_begins_xfer) = '1'), cpu_jtag_debug_module_unreg_firsttransfer, cpu_jtag_debug_module_reg_firsttransfer);
  --cpu_jtag_debug_module_unreg_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_unreg_firsttransfer <= NOT ((cpu_jtag_debug_module_slavearbiterlockenable AND cpu_jtag_debug_module_any_continuerequest));
  --cpu_jtag_debug_module_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_begins_xfer) = '1' then 
        cpu_jtag_debug_module_reg_firsttransfer <= cpu_jtag_debug_module_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_jtag_debug_module_beginbursttransfer_internal <= cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_jtag_debug_module_arbitration_holdoff_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_write assignment, which is an e_mux
  cpu_jtag_debug_module_write <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --cpu_jtag_debug_module_address mux, which is an e_mux
  cpu_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (A_SRL(shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master,std_logic_vector'("00000000000000000000000000000010")))), 9);
  shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master <= cpu_instruction_master_address_to_slave;
  --d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
    end if;

  end process;

  --cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_read <= cpu_jtag_debug_module_in_a_read_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_jtag_debug_module_in_a_read_cycle;
  --cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_write_cycle <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_jtag_debug_module_counter <= std_logic'('0');
  --cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --debugaccess mux, which is an e_mux
  cpu_jtag_debug_module_debugaccess <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_debugaccess))), std_logic_vector'("00000000000000000000000000000000")));
  --vhdl renameroo for output signals
  cpu_data_master_granted_cpu_jtag_debug_module <= internal_cpu_data_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cpu_jtag_debug_module <= internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
--synthesis translate_off
    --cpu/jtag_debug_module enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal LCD_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LCD_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                 signal LEDG_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LEDR_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal NIOS_B_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal NIOS_G_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal NIOS_R_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal SEG7_ADDR_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal SEG7_DATA_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal SW_s1_irq_from_sa : IN STD_LOGIC;
                 signal SW_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cfi_flash_0_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_byteenable_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_LCD_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_LEDG_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_LEDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_NIOS_B_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_NIOS_G_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_NIOS_R_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_SEG7_ADDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_SEG7_DATA_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_granted_fifo_req_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_spi_0_spi_control_port : IN STD_LOGIC;
                 signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_LCD_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_LEDG_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_LEDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_B_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_G_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_NIOS_R_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_SEG7_ADDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_SEG7_DATA_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_fifo_req_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_spi_0_spi_control_port : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LCD_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LEDG_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_LEDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_B_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_G_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_NIOS_R_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SEG7_ADDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SEG7_DATA_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_fifo_req_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_spi_0_spi_control_port : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_LCD_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_LEDG_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_LEDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_B_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_G_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_NIOS_R_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_SEG7_ADDR_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_SEG7_DATA_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_SW_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_requests_fifo_req_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_spi_0_spi_control_port : IN STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_LCD_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_LEDG_s1_end_xfer : IN STD_LOGIC;
                 signal d1_LEDR_s1_end_xfer : IN STD_LOGIC;
                 signal d1_NIOS_B_s1_end_xfer : IN STD_LOGIC;
                 signal d1_NIOS_G_s1_end_xfer : IN STD_LOGIC;
                 signal d1_NIOS_R_s1_end_xfer : IN STD_LOGIC;
                 signal d1_SEG7_ADDR_s1_end_xfer : IN STD_LOGIC;
                 signal d1_SEG7_DATA_s1_end_xfer : IN STD_LOGIC;
                 signal d1_SW_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_fifo_req_s1_end_xfer : IN STD_LOGIC;
                 signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_spi_0_spi_control_port_end_xfer : IN STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_0_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal fifo_req_s1_readdata_from_sa : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal spi_0_spi_control_port_irq_from_sa : IN STD_LOGIC;
                 signal spi_0_spi_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_data_master_address_last_time :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_byteenable_last_time :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_rdv_counter_inc :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_data_master_next_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_data_master_read_last_time :  STD_LOGIC;
                signal cpu_data_master_run :  STD_LOGIC;
                signal cpu_data_master_write_last_time :  STD_LOGIC;
                signal cpu_data_master_writedata_last_time :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_rdv_count_enable :  STD_LOGIC;
                signal dbs_rdv_counter_overflow :  STD_LOGIC;
                signal internal_cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_data_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal pre_flush_cpu_data_master_readdatavalid :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal r_3 :  STD_LOGIC;

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_LCD_control_slave OR NOT cpu_data_master_requests_LCD_control_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LCD_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((LCD_control_slave_wait_counter_eq_0 AND NOT d1_LCD_control_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LCD_control_slave OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((LCD_control_slave_wait_counter_eq_0 AND NOT d1_LCD_control_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_LEDG_s1 OR NOT cpu_data_master_requests_LEDG_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LEDG_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_LEDG_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LEDG_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_LEDR_s1 OR NOT cpu_data_master_requests_LEDR_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LEDR_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_LEDR_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_LEDR_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_NIOS_B_s1 OR NOT cpu_data_master_requests_NIOS_B_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_B_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_NIOS_B_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_B_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_NIOS_G_s1 OR NOT cpu_data_master_requests_NIOS_G_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_G_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_NIOS_G_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_G_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_data_master_run <= ((r_0 AND r_1) AND r_2) AND r_3;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_NIOS_R_s1 OR NOT cpu_data_master_requests_NIOS_R_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_R_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_NIOS_R_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_NIOS_R_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_SEG7_ADDR_s1 OR NOT cpu_data_master_requests_SEG7_ADDR_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SEG7_ADDR_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_SEG7_ADDR_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SEG7_ADDR_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_SEG7_DATA_s1 OR NOT cpu_data_master_requests_SEG7_DATA_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SEG7_DATA_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_SEG7_DATA_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SEG7_DATA_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_SW_s1 OR NOT cpu_data_master_requests_SW_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SW_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_SW_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_SW_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cpu_jtag_debug_module OR NOT cpu_data_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic(((((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_fifo_req_s1 OR NOT cpu_data_master_requests_fifo_req_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_fifo_req_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_fifo_req_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_fifo_req_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_onchip_memory2_0_s1 OR NOT cpu_data_master_requests_onchip_memory2_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_onchip_memory2_0_s1 OR NOT cpu_data_master_qualified_request_onchip_memory2_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_memory2_0_s1 OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_memory2_0_s1 OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_spi_0_spi_control_port OR NOT cpu_data_master_requests_spi_0_spi_control_port)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_spi_0_spi_control_port OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_spi_0_spi_control_port_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_spi_0_spi_control_port OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_spi_0_spi_control_port_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_requests_sysid_control_slave)))))));
  --r_3 master_run cascaded wait assignment, which is an e_assign
  r_3 <= Vector_To_Std_Logic((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sysid_control_slave_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_cfi_flash_0_s1 OR ((((cpu_data_master_write AND NOT(cpu_data_master_byteenable_cfi_flash_0_s1)) AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR NOT cpu_data_master_requests_cfi_flash_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cfi_flash_0_s1 OR NOT cpu_data_master_qualified_request_cfi_flash_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cfi_flash_0_s1 OR NOT cpu_data_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cfi_flash_0_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_data_master_address_to_slave <= cpu_data_master_address(23 DOWNTO 0);
  --cpu_data_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_data_master_read_but_no_slave_selected <= (cpu_data_master_read AND cpu_data_master_run) AND NOT cpu_data_master_is_granted_some_slave;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_data_master_is_granted_some_slave <= ((((((((((((((cpu_data_master_granted_LCD_control_slave OR cpu_data_master_granted_LEDG_s1) OR cpu_data_master_granted_LEDR_s1) OR cpu_data_master_granted_NIOS_B_s1) OR cpu_data_master_granted_NIOS_G_s1) OR cpu_data_master_granted_NIOS_R_s1) OR cpu_data_master_granted_SEG7_ADDR_s1) OR cpu_data_master_granted_SEG7_DATA_s1) OR cpu_data_master_granted_SW_s1) OR cpu_data_master_granted_cpu_jtag_debug_module) OR cpu_data_master_granted_fifo_req_s1) OR cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave) OR cpu_data_master_granted_onchip_memory2_0_s1) OR cpu_data_master_granted_spi_0_spi_control_port) OR cpu_data_master_granted_sysid_control_slave) OR cpu_data_master_granted_cfi_flash_0_s1;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_data_master_readdatavalid <= cpu_data_master_read_data_valid_onchip_memory2_0_s1 OR ((cpu_data_master_read_data_valid_cfi_flash_0_s1 AND dbs_rdv_counter_overflow));
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_data_master_readdatavalid <= ((((((((((((((((((((((((((((((((((((((((((((cpu_data_master_read_but_no_slave_selected OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_LCD_control_slave) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_LEDG_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_LEDR_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_NIOS_B_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_NIOS_G_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_NIOS_R_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_SEG7_ADDR_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_SEG7_DATA_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_SW_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_cpu_jtag_debug_module) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_fifo_req_s1) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_spi_0_spi_control_port) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid) OR cpu_data_master_read_data_valid_sysid_control_slave) OR cpu_data_master_read_but_no_slave_selected) OR pre_flush_cpu_data_master_readdatavalid;
  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= ((((((((((((((((A_REP(NOT ((cpu_data_master_qualified_request_LCD_control_slave AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (LCD_control_slave_readdata_from_sa)))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_LEDG_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (LEDG_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_LEDR_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("00000000000000") & (LEDR_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_NIOS_B_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (NIOS_B_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_NIOS_G_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (NIOS_G_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_NIOS_R_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (NIOS_R_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_SEG7_ADDR_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000") & (SEG7_ADDR_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_SEG7_DATA_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000") & (SEG7_DATA_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_SW_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (SW_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_cpu_jtag_debug_module AND cpu_data_master_read)) , 32) OR cpu_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_fifo_req_s1 AND cpu_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(fifo_req_s1_readdata_from_sa)))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_read)) , 32) OR jtag_uart_0_avalon_jtag_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_read_data_valid_onchip_memory2_0_s1, 32) OR onchip_memory2_0_s1_readdata_from_sa))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_spi_0_spi_control_port AND cpu_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000") & (spi_0_spi_control_port_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_data_master_qualified_request_sysid_control_slave AND cpu_data_master_read)) , 32) OR sysid_control_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_read_data_valid_cfi_flash_0_s1, 32) OR Std_Logic_Vector'(incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(7 DOWNTO 0) & dbs_latent_8_reg_segment_2 & dbs_latent_8_reg_segment_1 & dbs_latent_8_reg_segment_0)));
  --actual waitrequest port, which is an e_assign
  internal_cpu_data_master_waitrequest <= NOT cpu_data_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_latency_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      internal_cpu_data_master_latency_counter <= p1_cpu_data_master_latency_counter;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_data_master_latency_counter <= A_EXT (A_WE_StdLogicVector((std_logic'(((cpu_data_master_run AND cpu_data_master_read))) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (latency_load_value)), A_WE_StdLogicVector((((internal_cpu_data_master_latency_counter)) /= std_logic_vector'("00")), ((std_logic_vector'("0000000000000000000000000000000") & (internal_cpu_data_master_latency_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --read latency load values, which is an e_mux
  latency_load_value <= A_EXT (((((std_logic_vector'("000000000000000000000000000000") & (A_REP(cpu_data_master_requests_onchip_memory2_0_s1, 2))) AND std_logic_vector'("00000000000000000000000000000001"))) OR (((std_logic_vector'("000000000000000000000000000000") & (A_REP(cpu_data_master_requests_cfi_flash_0_s1, 2))) AND std_logic_vector'("00000000000000000000000000000010")))), 2);
  --irq assign, which is an e_assign
  cpu_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(SW_s1_irq_from_sa) & A_ToStdLogicVector(spi_0_spi_control_port_irq_from_sa) & A_ToStdLogicVector(jtag_uart_0_avalon_jtag_slave_irq_from_sa));
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic((((((((NOT std_logic_vector'("00000000000000000000000000000000")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_requests_cfi_flash_0_s1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT(cpu_data_master_byteenable_cfi_flash_0_s1)))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))))));
  --input to latent dbs-8 stored 0, which is an e_mux
  p1_dbs_latent_8_reg_segment_0 <= incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  --dbs register for latent dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_data_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_latent_8_reg_segment_0 <= p1_dbs_latent_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 1, which is an e_mux
  p1_dbs_latent_8_reg_segment_1 <= incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  --dbs register for latent dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_data_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_latent_8_reg_segment_1 <= p1_dbs_latent_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 2, which is an e_mux
  p1_dbs_latent_8_reg_segment_2 <= incoming_tri_state_bridge_0_data_with_Xs_converted_to_0;
  --dbs register for latent dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_data_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_latent_8_reg_segment_2 <= p1_dbs_latent_8_reg_segment_2;
      end if;
    end if;

  end process;

  --mux write dbs 2, which is an e_mux
  cpu_data_master_dbs_write_8 <= A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_writedata(7 DOWNTO 0), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_writedata(15 DOWNTO 8), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_writedata(23 DOWNTO 16), cpu_data_master_writedata(31 DOWNTO 24))));
  --dbs count increment, which is an e_mux
  cpu_data_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_data_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_data_master_dbs_address)) + (std_logic_vector'("0") & (cpu_data_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_data_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --p1 dbs rdv counter, which is an e_assign
  cpu_data_master_next_dbs_rdv_counter <= A_EXT (((std_logic_vector'("0") & (cpu_data_master_dbs_rdv_counter)) + (std_logic_vector'("0") & (cpu_data_master_dbs_rdv_counter_inc))), 2);
  --cpu_data_master_rdv_inc_mux, which is an e_mux
  cpu_data_master_dbs_rdv_counter_inc <= std_logic_vector'("01");
  --master any slave rdv, which is an e_mux
  dbs_rdv_count_enable <= cpu_data_master_read_data_valid_cfi_flash_0_s1;
  --dbs rdv counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_dbs_rdv_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_rdv_count_enable) = '1' then 
        cpu_data_master_dbs_rdv_counter <= cpu_data_master_next_dbs_rdv_counter;
      end if;
    end if;

  end process;

  --dbs rdv counter overflow, which is an e_assign
  dbs_rdv_counter_overflow <= cpu_data_master_dbs_rdv_counter(1) AND NOT cpu_data_master_next_dbs_rdv_counter(1);
  --vhdl renameroo for output signals
  cpu_data_master_address_to_slave <= internal_cpu_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_data_master_dbs_address <= internal_cpu_data_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_data_master_latency_counter <= internal_cpu_data_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;
--synthesis translate_off
    --cpu_data_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_data_master_address_last_time <= std_logic_vector'("000000000000000000000000");
      elsif clk'event and clk = '1' then
        cpu_data_master_address_last_time <= cpu_data_master_address;
      end if;

    end process;

    --cpu/data_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        active_and_waiting_last_time <= internal_cpu_data_master_waitrequest AND ((cpu_data_master_read OR cpu_data_master_write));
      end if;

    end process;

    --cpu_data_master_address matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line2 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_data_master_address /= cpu_data_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_data_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_data_master_byteenable check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_data_master_byteenable_last_time <= std_logic_vector'("0000");
      elsif clk'event and clk = '1' then
        cpu_data_master_byteenable_last_time <= cpu_data_master_byteenable;
      end if;

    end process;

    --cpu_data_master_byteenable matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line3 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_data_master_byteenable /= cpu_data_master_byteenable_last_time))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_data_master_byteenable did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_data_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_data_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_data_master_read_last_time <= cpu_data_master_read;
      end if;

    end process;

    --cpu_data_master_read matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line4 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_data_master_read) /= std_logic'(cpu_data_master_read_last_time)))))) = '1' then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("cpu_data_master_read did not heed wait!!!"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_data_master_write check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_data_master_write_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_data_master_write_last_time <= cpu_data_master_write;
      end if;

    end process;

    --cpu_data_master_write matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line5 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_data_master_write) /= std_logic'(cpu_data_master_write_last_time)))))) = '1' then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("cpu_data_master_write did not heed wait!!!"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_data_master_writedata check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_data_master_writedata_last_time <= std_logic_vector'("00000000000000000000000000000000");
      elsif clk'event and clk = '1' then
        cpu_data_master_writedata_last_time <= cpu_data_master_writedata;
      end if;

    end process;

    --cpu_data_master_writedata matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line6 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'(((active_and_waiting_last_time AND to_std_logic(((cpu_data_master_writedata /= cpu_data_master_writedata_last_time)))) AND cpu_data_master_write)) = '1' then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("cpu_data_master_writedata did not heed wait!!!"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal cfi_flash_0_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_granted_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_cfi_flash_0_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_0_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_0_data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_instruction_master_address_last_time :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_dbs_rdv_counter_inc :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_instruction_master_next_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_instruction_master_read_last_time :  STD_LOGIC;
                signal cpu_instruction_master_run :  STD_LOGIC;
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_rdv_count_enable :  STD_LOGIC;
                signal dbs_rdv_counter_overflow :  STD_LOGIC;
                signal internal_cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal pre_flush_cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal r_3 :  STD_LOGIC;

begin

  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic(((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_cpu_jtag_debug_module OR NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))))));
  --cascaded wait assignment, which is an e_assign
  cpu_instruction_master_run <= (r_1 AND r_2) AND r_3;
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_onchip_memory2_0_s1 OR NOT cpu_instruction_master_requests_onchip_memory2_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_onchip_memory2_0_s1 OR NOT cpu_instruction_master_qualified_request_onchip_memory2_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_onchip_memory2_0_s1 OR NOT (cpu_instruction_master_read))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_read))))))))));
  --r_3 master_run cascaded wait assignment, which is an e_assign
  r_3 <= Vector_To_Std_Logic((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_cfi_flash_0_s1 OR NOT cpu_instruction_master_requests_cfi_flash_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_cfi_flash_0_s1 OR NOT cpu_instruction_master_qualified_request_cfi_flash_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cfi_flash_0_s1 OR NOT cpu_instruction_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_instruction_master_dbs_address(1) AND internal_cpu_instruction_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_instruction_master_address_to_slave <= cpu_instruction_master_address(23 DOWNTO 0);
  --cpu_instruction_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_instruction_master_read_but_no_slave_selected <= (cpu_instruction_master_read AND cpu_instruction_master_run) AND NOT cpu_instruction_master_is_granted_some_slave;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_instruction_master_is_granted_some_slave <= (cpu_instruction_master_granted_cpu_jtag_debug_module OR cpu_instruction_master_granted_onchip_memory2_0_s1) OR cpu_instruction_master_granted_cfi_flash_0_s1;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_instruction_master_readdatavalid <= cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 OR ((cpu_instruction_master_read_data_valid_cfi_flash_0_s1 AND dbs_rdv_counter_overflow));
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_instruction_master_readdatavalid <= (((((cpu_instruction_master_read_but_no_slave_selected OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_data_valid_cpu_jtag_debug_module) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid;
  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= (((A_REP(NOT ((cpu_instruction_master_qualified_request_cpu_jtag_debug_module AND cpu_instruction_master_read)) , 32) OR cpu_jtag_debug_module_readdata_from_sa)) AND ((A_REP(NOT cpu_instruction_master_read_data_valid_onchip_memory2_0_s1, 32) OR onchip_memory2_0_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_instruction_master_read_data_valid_cfi_flash_0_s1, 32) OR Std_Logic_Vector'(incoming_tri_state_bridge_0_data(7 DOWNTO 0) & dbs_latent_8_reg_segment_2 & dbs_latent_8_reg_segment_1 & dbs_latent_8_reg_segment_0)));
  --actual waitrequest port, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT cpu_instruction_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_latency_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      internal_cpu_instruction_master_latency_counter <= p1_cpu_instruction_master_latency_counter;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_instruction_master_latency_counter <= A_EXT (A_WE_StdLogicVector((std_logic'(((cpu_instruction_master_run AND cpu_instruction_master_read))) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (latency_load_value)), A_WE_StdLogicVector((((internal_cpu_instruction_master_latency_counter)) /= std_logic_vector'("00")), ((std_logic_vector'("0000000000000000000000000000000") & (internal_cpu_instruction_master_latency_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --read latency load values, which is an e_mux
  latency_load_value <= A_EXT (((((std_logic_vector'("000000000000000000000000000000") & (A_REP(cpu_instruction_master_requests_onchip_memory2_0_s1, 2))) AND std_logic_vector'("00000000000000000000000000000001"))) OR (((std_logic_vector'("000000000000000000000000000000") & (A_REP(cpu_instruction_master_requests_cfi_flash_0_s1, 2))) AND std_logic_vector'("00000000000000000000000000000010")))), 2);
  --input to latent dbs-8 stored 0, which is an e_mux
  p1_dbs_latent_8_reg_segment_0 <= incoming_tri_state_bridge_0_data;
  --dbs register for latent dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_latent_8_reg_segment_0 <= p1_dbs_latent_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 1, which is an e_mux
  p1_dbs_latent_8_reg_segment_1 <= incoming_tri_state_bridge_0_data;
  --dbs register for latent dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_latent_8_reg_segment_1 <= p1_dbs_latent_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 2, which is an e_mux
  p1_dbs_latent_8_reg_segment_2 <= incoming_tri_state_bridge_0_data;
  --dbs register for latent dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_latent_8_reg_segment_2 <= p1_dbs_latent_8_reg_segment_2;
      end if;
    end if;

  end process;

  --dbs count increment, which is an e_mux
  cpu_instruction_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_instruction_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_instruction_master_dbs_address)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_instruction_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --p1 dbs rdv counter, which is an e_assign
  cpu_instruction_master_next_dbs_rdv_counter <= A_EXT (((std_logic_vector'("0") & (cpu_instruction_master_dbs_rdv_counter)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_rdv_counter_inc))), 2);
  --cpu_instruction_master_rdv_inc_mux, which is an e_mux
  cpu_instruction_master_dbs_rdv_counter_inc <= std_logic_vector'("01");
  --master any slave rdv, which is an e_mux
  dbs_rdv_count_enable <= cpu_instruction_master_read_data_valid_cfi_flash_0_s1;
  --dbs rdv counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_dbs_rdv_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_rdv_count_enable) = '1' then 
        cpu_instruction_master_dbs_rdv_counter <= cpu_instruction_master_next_dbs_rdv_counter;
      end if;
    end if;

  end process;

  --dbs rdv counter overflow, which is an e_assign
  dbs_rdv_counter_overflow <= cpu_instruction_master_dbs_rdv_counter(1) AND NOT cpu_instruction_master_next_dbs_rdv_counter(1);
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic(((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_granted_cfi_flash_0_s1 AND cpu_instruction_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cfi_flash_0_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_0_avalon_slave_end_xfer)))))));
  --vhdl renameroo for output signals
  cpu_instruction_master_address_to_slave <= internal_cpu_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_instruction_master_dbs_address <= internal_cpu_instruction_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_instruction_master_latency_counter <= internal_cpu_instruction_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_address_last_time <= std_logic_vector'("000000000000000000000000");
      elsif clk'event and clk = '1' then
        cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
      end if;

    end process;

    --cpu/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        active_and_waiting_last_time <= internal_cpu_instruction_master_waitrequest AND (cpu_instruction_master_read);
      end if;

    end process;

    --cpu_instruction_master_address matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line7 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_instruction_master_address /= cpu_instruction_master_address_last_time))))) = '1' then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("cpu_instruction_master_address did not heed wait!!!"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
      end if;

    end process;

    --cpu_instruction_master_read matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line8 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_instruction_master_read) /= std_logic'(cpu_instruction_master_read_last_time)))))) = '1' then 
          write(write_line8, now);
          write(write_line8, string'(": "));
          write(write_line8, string'("cpu_instruction_master_read did not heed wait!!!"));
          write(output, write_line8.all);
          deallocate (write_line8);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity fifo_req_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal fifo_req_s1_readdata : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_fifo_req_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_fifo_req_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_fifo_req_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_fifo_req_s1 : OUT STD_LOGIC;
                 signal d1_fifo_req_s1_end_xfer : OUT STD_LOGIC;
                 signal fifo_req_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal fifo_req_s1_chipselect : OUT STD_LOGIC;
                 signal fifo_req_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal fifo_req_s1_reset_n : OUT STD_LOGIC;
                 signal fifo_req_s1_write_n : OUT STD_LOGIC;
                 signal fifo_req_s1_writedata : OUT STD_LOGIC
              );
end entity fifo_req_s1_arbitrator;


architecture europa of fifo_req_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_fifo_req_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_fifo_req_s1 :  STD_LOGIC;
                signal fifo_req_s1_allgrants :  STD_LOGIC;
                signal fifo_req_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal fifo_req_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal fifo_req_s1_any_continuerequest :  STD_LOGIC;
                signal fifo_req_s1_arb_counter_enable :  STD_LOGIC;
                signal fifo_req_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal fifo_req_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal fifo_req_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal fifo_req_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal fifo_req_s1_begins_xfer :  STD_LOGIC;
                signal fifo_req_s1_end_xfer :  STD_LOGIC;
                signal fifo_req_s1_firsttransfer :  STD_LOGIC;
                signal fifo_req_s1_grant_vector :  STD_LOGIC;
                signal fifo_req_s1_in_a_read_cycle :  STD_LOGIC;
                signal fifo_req_s1_in_a_write_cycle :  STD_LOGIC;
                signal fifo_req_s1_master_qreq_vector :  STD_LOGIC;
                signal fifo_req_s1_non_bursting_master_requests :  STD_LOGIC;
                signal fifo_req_s1_reg_firsttransfer :  STD_LOGIC;
                signal fifo_req_s1_slavearbiterlockenable :  STD_LOGIC;
                signal fifo_req_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal fifo_req_s1_unreg_firsttransfer :  STD_LOGIC;
                signal fifo_req_s1_waits_for_read :  STD_LOGIC;
                signal fifo_req_s1_waits_for_write :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_fifo_req_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_fifo_req_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_fifo_req_s1 :  STD_LOGIC;
                signal shifted_address_to_fifo_req_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_fifo_req_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT fifo_req_s1_end_xfer;
    end if;

  end process;

  fifo_req_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_fifo_req_s1);
  --assign fifo_req_s1_readdata_from_sa = fifo_req_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  fifo_req_s1_readdata_from_sa <= fifo_req_s1_readdata;
  internal_cpu_data_master_requests_fifo_req_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("100000100001000001000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --fifo_req_s1_arb_share_counter set values, which is an e_mux
  fifo_req_s1_arb_share_set_values <= std_logic_vector'("001");
  --fifo_req_s1_non_bursting_master_requests mux, which is an e_mux
  fifo_req_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_fifo_req_s1;
  --fifo_req_s1_any_bursting_master_saved_grant mux, which is an e_mux
  fifo_req_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --fifo_req_s1_arb_share_counter_next_value assignment, which is an e_assign
  fifo_req_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(fifo_req_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (fifo_req_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(fifo_req_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (fifo_req_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --fifo_req_s1_allgrants all slave grants, which is an e_mux
  fifo_req_s1_allgrants <= fifo_req_s1_grant_vector;
  --fifo_req_s1_end_xfer assignment, which is an e_assign
  fifo_req_s1_end_xfer <= NOT ((fifo_req_s1_waits_for_read OR fifo_req_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_fifo_req_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_fifo_req_s1 <= fifo_req_s1_end_xfer AND (((NOT fifo_req_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --fifo_req_s1_arb_share_counter arbitration counter enable, which is an e_assign
  fifo_req_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_fifo_req_s1 AND fifo_req_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_fifo_req_s1 AND NOT fifo_req_s1_non_bursting_master_requests));
  --fifo_req_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      fifo_req_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(fifo_req_s1_arb_counter_enable) = '1' then 
        fifo_req_s1_arb_share_counter <= fifo_req_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --fifo_req_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      fifo_req_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((fifo_req_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_fifo_req_s1)) OR ((end_xfer_arb_share_counter_term_fifo_req_s1 AND NOT fifo_req_s1_non_bursting_master_requests)))) = '1' then 
        fifo_req_s1_slavearbiterlockenable <= or_reduce(fifo_req_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master fifo_req/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= fifo_req_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --fifo_req_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  fifo_req_s1_slavearbiterlockenable2 <= or_reduce(fifo_req_s1_arb_share_counter_next_value);
  --cpu/data_master fifo_req/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= fifo_req_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --fifo_req_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  fifo_req_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_fifo_req_s1 <= internal_cpu_data_master_requests_fifo_req_s1 AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_fifo_req_s1, which is an e_mux
  cpu_data_master_read_data_valid_fifo_req_s1 <= (internal_cpu_data_master_granted_fifo_req_s1 AND cpu_data_master_read) AND NOT fifo_req_s1_waits_for_read;
  --fifo_req_s1_writedata mux, which is an e_mux
  fifo_req_s1_writedata <= cpu_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_data_master_granted_fifo_req_s1 <= internal_cpu_data_master_qualified_request_fifo_req_s1;
  --cpu/data_master saved-grant fifo_req/s1, which is an e_assign
  cpu_data_master_saved_grant_fifo_req_s1 <= internal_cpu_data_master_requests_fifo_req_s1;
  --allow new arb cycle for fifo_req/s1, which is an e_assign
  fifo_req_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  fifo_req_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  fifo_req_s1_master_qreq_vector <= std_logic'('1');
  --fifo_req_s1_reset_n assignment, which is an e_assign
  fifo_req_s1_reset_n <= reset_n;
  fifo_req_s1_chipselect <= internal_cpu_data_master_granted_fifo_req_s1;
  --fifo_req_s1_firsttransfer first transaction, which is an e_assign
  fifo_req_s1_firsttransfer <= A_WE_StdLogic((std_logic'(fifo_req_s1_begins_xfer) = '1'), fifo_req_s1_unreg_firsttransfer, fifo_req_s1_reg_firsttransfer);
  --fifo_req_s1_unreg_firsttransfer first transaction, which is an e_assign
  fifo_req_s1_unreg_firsttransfer <= NOT ((fifo_req_s1_slavearbiterlockenable AND fifo_req_s1_any_continuerequest));
  --fifo_req_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      fifo_req_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(fifo_req_s1_begins_xfer) = '1' then 
        fifo_req_s1_reg_firsttransfer <= fifo_req_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --fifo_req_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  fifo_req_s1_beginbursttransfer_internal <= fifo_req_s1_begins_xfer;
  --~fifo_req_s1_write_n assignment, which is an e_mux
  fifo_req_s1_write_n <= NOT ((internal_cpu_data_master_granted_fifo_req_s1 AND cpu_data_master_write));
  shifted_address_to_fifo_req_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --fifo_req_s1_address mux, which is an e_mux
  fifo_req_s1_address <= A_EXT (A_SRL(shifted_address_to_fifo_req_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_fifo_req_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_fifo_req_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_fifo_req_s1_end_xfer <= fifo_req_s1_end_xfer;
    end if;

  end process;

  --fifo_req_s1_waits_for_read in a cycle, which is an e_mux
  fifo_req_s1_waits_for_read <= fifo_req_s1_in_a_read_cycle AND fifo_req_s1_begins_xfer;
  --fifo_req_s1_in_a_read_cycle assignment, which is an e_assign
  fifo_req_s1_in_a_read_cycle <= internal_cpu_data_master_granted_fifo_req_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= fifo_req_s1_in_a_read_cycle;
  --fifo_req_s1_waits_for_write in a cycle, which is an e_mux
  fifo_req_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(fifo_req_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --fifo_req_s1_in_a_write_cycle assignment, which is an e_assign
  fifo_req_s1_in_a_write_cycle <= internal_cpu_data_master_granted_fifo_req_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= fifo_req_s1_in_a_write_cycle;
  wait_for_fifo_req_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_fifo_req_s1 <= internal_cpu_data_master_granted_fifo_req_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_fifo_req_s1 <= internal_cpu_data_master_qualified_request_fifo_req_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_fifo_req_s1 <= internal_cpu_data_master_requests_fifo_req_s1;
--synthesis translate_off
    --fifo_req/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtag_uart_0_avalon_jtag_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_irq : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_address : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity jtag_uart_0_avalon_jtag_slave_arbitrator;


architecture europa of jtag_uart_0_avalon_jtag_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_allgrants :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_any_continuerequest :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_counter_enable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_begins_xfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_grant_vector :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_in_a_read_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_in_a_write_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_master_qreq_vector :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_reg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waits_for_read :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_jtag_uart_0_avalon_jtag_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT jtag_uart_0_avalon_jtag_slave_end_xfer;
    end if;

  end process;

  jtag_uart_0_avalon_jtag_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave);
  --assign jtag_uart_0_avalon_jtag_slave_readdata_from_sa = jtag_uart_0_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_readdata_from_sa <= jtag_uart_0_avalon_jtag_slave_readdata;
  internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("100000100001000011000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_0_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa <= jtag_uart_0_avalon_jtag_slave_dataavailable;
  --assign jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_0_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa <= jtag_uart_0_avalon_jtag_slave_readyfordata;
  --assign jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_0_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa <= jtag_uart_0_avalon_jtag_slave_waitrequest;
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_arb_share_set_values <= std_logic_vector'("001");
  --jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(jtag_uart_0_avalon_jtag_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_0_avalon_jtag_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(jtag_uart_0_avalon_jtag_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_0_avalon_jtag_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --jtag_uart_0_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_allgrants <= jtag_uart_0_avalon_jtag_slave_grant_vector;
  --jtag_uart_0_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_end_xfer <= NOT ((jtag_uart_0_avalon_jtag_slave_waits_for_read OR jtag_uart_0_avalon_jtag_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave <= jtag_uart_0_avalon_jtag_slave_end_xfer AND (((NOT jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND jtag_uart_0_avalon_jtag_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND NOT jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests));
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_0_avalon_jtag_slave_arb_counter_enable) = '1' then 
        jtag_uart_0_avalon_jtag_slave_arb_share_counter <= jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((jtag_uart_0_avalon_jtag_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave)) OR ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND NOT jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests)))) = '1' then 
        jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable <= or_reduce(jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master jtag_uart_0/avalon_jtag_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 <= or_reduce(jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value);
  --cpu/data_master jtag_uart_0/avalon_jtag_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --jtag_uart_0_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave, which is an e_mux
  cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave <= (internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_read) AND NOT jtag_uart_0_avalon_jtag_slave_waits_for_read;
  --jtag_uart_0_avalon_jtag_slave_writedata mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave;
  --cpu/data_master saved-grant jtag_uart_0/avalon_jtag_slave, which is an e_assign
  cpu_data_master_saved_grant_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --allow new arb cycle for jtag_uart_0/avalon_jtag_slave, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtag_uart_0_avalon_jtag_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtag_uart_0_avalon_jtag_slave_master_qreq_vector <= std_logic'('1');
  --jtag_uart_0_avalon_jtag_slave_reset_n assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_reset_n <= reset_n;
  jtag_uart_0_avalon_jtag_slave_chipselect <= internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave;
  --jtag_uart_0_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_firsttransfer <= A_WE_StdLogic((std_logic'(jtag_uart_0_avalon_jtag_slave_begins_xfer) = '1'), jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer, jtag_uart_0_avalon_jtag_slave_reg_firsttransfer);
  --jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer <= NOT ((jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable AND jtag_uart_0_avalon_jtag_slave_any_continuerequest));
  --jtag_uart_0_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_0_avalon_jtag_slave_begins_xfer) = '1' then 
        jtag_uart_0_avalon_jtag_slave_reg_firsttransfer <= jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal <= jtag_uart_0_avalon_jtag_slave_begins_xfer;
  --~jtag_uart_0_avalon_jtag_slave_read_n assignment, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_read_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_read));
  --~jtag_uart_0_avalon_jtag_slave_write_n assignment, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_write_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_write));
  shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --jtag_uart_0_avalon_jtag_slave_address mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_jtag_uart_0_avalon_jtag_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer <= jtag_uart_0_avalon_jtag_slave_end_xfer;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_waits_for_read <= jtag_uart_0_avalon_jtag_slave_in_a_read_cycle AND internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_0_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_in_a_read_cycle <= internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtag_uart_0_avalon_jtag_slave_in_a_read_cycle;
  --jtag_uart_0_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_waits_for_write <= jtag_uart_0_avalon_jtag_slave_in_a_write_cycle AND internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_0_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_in_a_write_cycle <= internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtag_uart_0_avalon_jtag_slave_in_a_write_cycle;
  wait_for_jtag_uart_0_avalon_jtag_slave_counter <= std_logic'('0');
  --assign jtag_uart_0_avalon_jtag_slave_irq_from_sa = jtag_uart_0_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_irq_from_sa <= jtag_uart_0_avalon_jtag_slave_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa <= internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
--synthesis translate_off
    --jtag_uart_0/avalon_jtag_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity onchip_memory2_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                 signal onchip_memory2_0_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_memory2_0_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_clken : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_memory2_0_s1_write : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity onchip_memory2_0_s1_arbitrator;


architecture europa of onchip_memory2_0_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_onchip_memory2_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_onchip_memory2_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_onchip_memory2_0_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_onchip_memory2_0_s1 :  STD_LOGIC;
                signal onchip_memory2_0_s1_allgrants :  STD_LOGIC;
                signal onchip_memory2_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal onchip_memory2_0_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory2_0_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory2_0_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory2_0_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal onchip_memory2_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_memory2_0_s1_begins_xfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_memory2_0_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_end_xfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal onchip_memory2_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_memory2_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal onchip_memory2_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_waits_for_read :  STD_LOGIC;
                signal onchip_memory2_0_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal p1_cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal shifted_address_to_onchip_memory2_0_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal shifted_address_to_onchip_memory2_0_s1_from_cpu_instruction_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal wait_for_onchip_memory2_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT onchip_memory2_0_s1_end_xfer;
    end if;

  end process;

  onchip_memory2_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_onchip_memory2_0_s1 OR internal_cpu_instruction_master_qualified_request_onchip_memory2_0_s1));
  --assign onchip_memory2_0_s1_readdata_from_sa = onchip_memory2_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_memory2_0_s1_readdata_from_sa <= onchip_memory2_0_s1_readdata;
  internal_cpu_data_master_requests_onchip_memory2_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("100000010000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --onchip_memory2_0_s1_arb_share_counter set values, which is an e_mux
  onchip_memory2_0_s1_arb_share_set_values <= std_logic_vector'("001");
  --onchip_memory2_0_s1_non_bursting_master_requests mux, which is an e_mux
  onchip_memory2_0_s1_non_bursting_master_requests <= ((internal_cpu_data_master_requests_onchip_memory2_0_s1 OR internal_cpu_instruction_master_requests_onchip_memory2_0_s1) OR internal_cpu_data_master_requests_onchip_memory2_0_s1) OR internal_cpu_instruction_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  onchip_memory2_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --onchip_memory2_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_memory2_0_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(onchip_memory2_0_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_memory2_0_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(onchip_memory2_0_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_memory2_0_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --onchip_memory2_0_s1_allgrants all slave grants, which is an e_mux
  onchip_memory2_0_s1_allgrants <= (((or_reduce(onchip_memory2_0_s1_grant_vector)) OR (or_reduce(onchip_memory2_0_s1_grant_vector))) OR (or_reduce(onchip_memory2_0_s1_grant_vector))) OR (or_reduce(onchip_memory2_0_s1_grant_vector));
  --onchip_memory2_0_s1_end_xfer assignment, which is an e_assign
  onchip_memory2_0_s1_end_xfer <= NOT ((onchip_memory2_0_s1_waits_for_read OR onchip_memory2_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_onchip_memory2_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_onchip_memory2_0_s1 <= onchip_memory2_0_s1_end_xfer AND (((NOT onchip_memory2_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --onchip_memory2_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_memory2_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND onchip_memory2_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND NOT onchip_memory2_0_s1_non_bursting_master_requests));
  --onchip_memory2_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_arb_counter_enable) = '1' then 
        onchip_memory2_0_s1_arb_share_counter <= onchip_memory2_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_memory2_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(onchip_memory2_0_s1_master_qreq_vector) AND end_xfer_arb_share_counter_term_onchip_memory2_0_s1)) OR ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND NOT onchip_memory2_0_s1_non_bursting_master_requests)))) = '1' then 
        onchip_memory2_0_s1_slavearbiterlockenable <= or_reduce(onchip_memory2_0_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master onchip_memory2_0/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= onchip_memory2_0_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --onchip_memory2_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  onchip_memory2_0_s1_slavearbiterlockenable2 <= or_reduce(onchip_memory2_0_s1_arb_share_counter_next_value);
  --cpu/data_master onchip_memory2_0/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= onchip_memory2_0_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --cpu/instruction_master onchip_memory2_0/s1 arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= onchip_memory2_0_s1_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master onchip_memory2_0/s1 arbiterlock2, which is an e_assign
  cpu_instruction_master_arbiterlock2 <= onchip_memory2_0_s1_slavearbiterlockenable2 AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted onchip_memory2_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_onchip_memory2_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_instruction_master_granted_slave_onchip_memory2_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_onchip_memory2_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_onchip_memory2_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_onchip_memory2_0_s1))))));
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_onchip_memory2_0_s1 AND internal_cpu_instruction_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  onchip_memory2_0_s1_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_data_master_requests_onchip_memory2_0_s1 AND NOT ((((cpu_data_master_read AND to_std_logic(((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter))))))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in <= (internal_cpu_data_master_granted_onchip_memory2_0_s1 AND cpu_data_master_read) AND NOT onchip_memory2_0_s1_waits_for_read;
  --shift register p1 cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in)));
  --cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_onchip_memory2_0_s1, which is an e_mux
  cpu_data_master_read_data_valid_onchip_memory2_0_s1 <= cpu_data_master_read_data_valid_onchip_memory2_0_s1_shift_register;
  --onchip_memory2_0_s1_writedata mux, which is an e_mux
  onchip_memory2_0_s1_writedata <= cpu_data_master_writedata;
  --mux onchip_memory2_0_s1_clken, which is an e_mux
  onchip_memory2_0_s1_clken <= std_logic'('1');
  internal_cpu_instruction_master_requests_onchip_memory2_0_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 16) & std_logic_vector'("0000000000000000")) = std_logic_vector'("100000010000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted onchip_memory2_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_onchip_memory2_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_data_master_granted_slave_onchip_memory2_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_onchip_memory2_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_onchip_memory2_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_onchip_memory2_0_s1))))));
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_onchip_memory2_0_s1 AND internal_cpu_data_master_requests_onchip_memory2_0_s1;
  internal_cpu_instruction_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_instruction_master_requests_onchip_memory2_0_s1 AND NOT ((((cpu_instruction_master_read AND to_std_logic(((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter))))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in <= (internal_cpu_instruction_master_granted_onchip_memory2_0_s1 AND cpu_instruction_master_read) AND NOT onchip_memory2_0_s1_waits_for_read;
  --shift register p1 cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register) & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in)));
  --cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_onchip_memory2_0_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 <= cpu_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register;
  --allow new arb cycle for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_onchip_memory2_0_s1;
  --cpu/instruction_master grant onchip_memory2_0/s1, which is an e_assign
  internal_cpu_instruction_master_granted_onchip_memory2_0_s1 <= onchip_memory2_0_s1_grant_vector(0);
  --cpu/instruction_master saved-grant onchip_memory2_0/s1, which is an e_assign
  cpu_instruction_master_saved_grant_onchip_memory2_0_s1 <= onchip_memory2_0_s1_arb_winner(0) AND internal_cpu_instruction_master_requests_onchip_memory2_0_s1;
  --cpu/data_master assignment into master qualified-requests vector for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_onchip_memory2_0_s1;
  --cpu/data_master grant onchip_memory2_0/s1, which is an e_assign
  internal_cpu_data_master_granted_onchip_memory2_0_s1 <= onchip_memory2_0_s1_grant_vector(1);
  --cpu/data_master saved-grant onchip_memory2_0/s1, which is an e_assign
  cpu_data_master_saved_grant_onchip_memory2_0_s1 <= onchip_memory2_0_s1_arb_winner(1) AND internal_cpu_data_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0/s1 chosen-master double-vector, which is an e_assign
  onchip_memory2_0_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((onchip_memory2_0_s1_master_qreq_vector & onchip_memory2_0_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT onchip_memory2_0_s1_master_qreq_vector & NOT onchip_memory2_0_s1_master_qreq_vector))) + (std_logic_vector'("000") & (onchip_memory2_0_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  onchip_memory2_0_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_allow_new_arb_cycle AND or_reduce(onchip_memory2_0_s1_grant_vector)))) = '1'), onchip_memory2_0_s1_grant_vector, onchip_memory2_0_s1_saved_chosen_master_vector);
  --saved onchip_memory2_0_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_allow_new_arb_cycle) = '1' then 
        onchip_memory2_0_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(onchip_memory2_0_s1_grant_vector)) = '1'), onchip_memory2_0_s1_grant_vector, onchip_memory2_0_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  onchip_memory2_0_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((onchip_memory2_0_s1_chosen_master_double_vector(1) OR onchip_memory2_0_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((onchip_memory2_0_s1_chosen_master_double_vector(0) OR onchip_memory2_0_s1_chosen_master_double_vector(2)))));
  --onchip_memory2_0/s1 chosen master rotated left, which is an e_assign
  onchip_memory2_0_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(onchip_memory2_0_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(onchip_memory2_0_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --onchip_memory2_0/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(onchip_memory2_0_s1_grant_vector)) = '1' then 
        onchip_memory2_0_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(onchip_memory2_0_s1_end_xfer) = '1'), onchip_memory2_0_s1_chosen_master_rot_left, onchip_memory2_0_s1_grant_vector);
      end if;
    end if;

  end process;

  onchip_memory2_0_s1_chipselect <= internal_cpu_data_master_granted_onchip_memory2_0_s1 OR internal_cpu_instruction_master_granted_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_firsttransfer first transaction, which is an e_assign
  onchip_memory2_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(onchip_memory2_0_s1_begins_xfer) = '1'), onchip_memory2_0_s1_unreg_firsttransfer, onchip_memory2_0_s1_reg_firsttransfer);
  --onchip_memory2_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  onchip_memory2_0_s1_unreg_firsttransfer <= NOT ((onchip_memory2_0_s1_slavearbiterlockenable AND onchip_memory2_0_s1_any_continuerequest));
  --onchip_memory2_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_begins_xfer) = '1' then 
        onchip_memory2_0_s1_reg_firsttransfer <= onchip_memory2_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --onchip_memory2_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_memory2_0_s1_beginbursttransfer_internal <= onchip_memory2_0_s1_begins_xfer;
  --onchip_memory2_0_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  onchip_memory2_0_s1_arbitration_holdoff_internal <= onchip_memory2_0_s1_begins_xfer AND onchip_memory2_0_s1_firsttransfer;
  --onchip_memory2_0_s1_write assignment, which is an e_mux
  onchip_memory2_0_s1_write <= internal_cpu_data_master_granted_onchip_memory2_0_s1 AND cpu_data_master_write;
  shifted_address_to_onchip_memory2_0_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --onchip_memory2_0_s1_address mux, which is an e_mux
  onchip_memory2_0_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_memory2_0_s1)) = '1'), (A_SRL(shifted_address_to_onchip_memory2_0_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(shifted_address_to_onchip_memory2_0_s1_from_cpu_instruction_master,std_logic_vector'("00000000000000000000000000000010")))), 14);
  shifted_address_to_onchip_memory2_0_s1_from_cpu_instruction_master <= cpu_instruction_master_address_to_slave;
  --d1_onchip_memory2_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_memory2_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_onchip_memory2_0_s1_end_xfer <= onchip_memory2_0_s1_end_xfer;
    end if;

  end process;

  --onchip_memory2_0_s1_waits_for_read in a cycle, which is an e_mux
  onchip_memory2_0_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory2_0_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_memory2_0_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_onchip_memory2_0_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_onchip_memory2_0_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_memory2_0_s1_in_a_read_cycle;
  --onchip_memory2_0_s1_waits_for_write in a cycle, which is an e_mux
  onchip_memory2_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory2_0_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_memory2_0_s1_in_a_write_cycle <= internal_cpu_data_master_granted_onchip_memory2_0_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_memory2_0_s1_in_a_write_cycle;
  wait_for_onchip_memory2_0_s1_counter <= std_logic'('0');
  --onchip_memory2_0_s1_byteenable byte enable port mux, which is an e_mux
  onchip_memory2_0_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_memory2_0_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_onchip_memory2_0_s1 <= internal_cpu_data_master_granted_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_data_master_qualified_request_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_onchip_memory2_0_s1 <= internal_cpu_data_master_requests_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_onchip_memory2_0_s1 <= internal_cpu_instruction_master_granted_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_instruction_master_qualified_request_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_onchip_memory2_0_s1 <= internal_cpu_instruction_master_requests_onchip_memory2_0_s1;
--synthesis translate_off
    --onchip_memory2_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line9 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_onchip_memory2_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_onchip_memory2_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line9, now);
          write(write_line9, string'(": "));
          write(write_line9, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line9.all);
          deallocate (write_line9);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line10 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_onchip_memory2_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_onchip_memory2_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line10, now);
          write(write_line10, string'(": "));
          write(write_line10, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line10.all);
          deallocate (write_line10);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity spi_0_spi_control_port_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal spi_0_spi_control_port_dataavailable : IN STD_LOGIC;
                 signal spi_0_spi_control_port_endofpacket : IN STD_LOGIC;
                 signal spi_0_spi_control_port_irq : IN STD_LOGIC;
                 signal spi_0_spi_control_port_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal spi_0_spi_control_port_readyfordata : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_spi_0_spi_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_spi_0_spi_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_spi_0_spi_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_requests_spi_0_spi_control_port : OUT STD_LOGIC;
                 signal d1_spi_0_spi_control_port_end_xfer : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal spi_0_spi_control_port_chipselect : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_dataavailable_from_sa : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_endofpacket_from_sa : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_irq_from_sa : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_read_n : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal spi_0_spi_control_port_readyfordata_from_sa : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_reset_n : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_write_n : OUT STD_LOGIC;
                 signal spi_0_spi_control_port_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity spi_0_spi_control_port_arbitrator;


architecture europa of spi_0_spi_control_port_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_spi_0_spi_control_port :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_spi_0_spi_control_port :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_spi_0_spi_control_port :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_spi_0_spi_control_port :  STD_LOGIC;
                signal internal_cpu_data_master_requests_spi_0_spi_control_port :  STD_LOGIC;
                signal shifted_address_to_spi_0_spi_control_port_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal spi_0_spi_control_port_allgrants :  STD_LOGIC;
                signal spi_0_spi_control_port_allow_new_arb_cycle :  STD_LOGIC;
                signal spi_0_spi_control_port_any_bursting_master_saved_grant :  STD_LOGIC;
                signal spi_0_spi_control_port_any_continuerequest :  STD_LOGIC;
                signal spi_0_spi_control_port_arb_counter_enable :  STD_LOGIC;
                signal spi_0_spi_control_port_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal spi_0_spi_control_port_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal spi_0_spi_control_port_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal spi_0_spi_control_port_beginbursttransfer_internal :  STD_LOGIC;
                signal spi_0_spi_control_port_begins_xfer :  STD_LOGIC;
                signal spi_0_spi_control_port_end_xfer :  STD_LOGIC;
                signal spi_0_spi_control_port_firsttransfer :  STD_LOGIC;
                signal spi_0_spi_control_port_grant_vector :  STD_LOGIC;
                signal spi_0_spi_control_port_in_a_read_cycle :  STD_LOGIC;
                signal spi_0_spi_control_port_in_a_write_cycle :  STD_LOGIC;
                signal spi_0_spi_control_port_master_qreq_vector :  STD_LOGIC;
                signal spi_0_spi_control_port_non_bursting_master_requests :  STD_LOGIC;
                signal spi_0_spi_control_port_reg_firsttransfer :  STD_LOGIC;
                signal spi_0_spi_control_port_slavearbiterlockenable :  STD_LOGIC;
                signal spi_0_spi_control_port_slavearbiterlockenable2 :  STD_LOGIC;
                signal spi_0_spi_control_port_unreg_firsttransfer :  STD_LOGIC;
                signal spi_0_spi_control_port_waits_for_read :  STD_LOGIC;
                signal spi_0_spi_control_port_waits_for_write :  STD_LOGIC;
                signal wait_for_spi_0_spi_control_port_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT spi_0_spi_control_port_end_xfer;
    end if;

  end process;

  spi_0_spi_control_port_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_spi_0_spi_control_port);
  --assign spi_0_spi_control_port_readdata_from_sa = spi_0_spi_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  spi_0_spi_control_port_readdata_from_sa <= spi_0_spi_control_port_readdata;
  internal_cpu_data_master_requests_spi_0_spi_control_port <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("100000100001000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign spi_0_spi_control_port_dataavailable_from_sa = spi_0_spi_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  spi_0_spi_control_port_dataavailable_from_sa <= spi_0_spi_control_port_dataavailable;
  --assign spi_0_spi_control_port_readyfordata_from_sa = spi_0_spi_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  spi_0_spi_control_port_readyfordata_from_sa <= spi_0_spi_control_port_readyfordata;
  --spi_0_spi_control_port_arb_share_counter set values, which is an e_mux
  spi_0_spi_control_port_arb_share_set_values <= std_logic_vector'("001");
  --spi_0_spi_control_port_non_bursting_master_requests mux, which is an e_mux
  spi_0_spi_control_port_non_bursting_master_requests <= internal_cpu_data_master_requests_spi_0_spi_control_port;
  --spi_0_spi_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  spi_0_spi_control_port_any_bursting_master_saved_grant <= std_logic'('0');
  --spi_0_spi_control_port_arb_share_counter_next_value assignment, which is an e_assign
  spi_0_spi_control_port_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(spi_0_spi_control_port_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (spi_0_spi_control_port_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(spi_0_spi_control_port_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (spi_0_spi_control_port_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --spi_0_spi_control_port_allgrants all slave grants, which is an e_mux
  spi_0_spi_control_port_allgrants <= spi_0_spi_control_port_grant_vector;
  --spi_0_spi_control_port_end_xfer assignment, which is an e_assign
  spi_0_spi_control_port_end_xfer <= NOT ((spi_0_spi_control_port_waits_for_read OR spi_0_spi_control_port_waits_for_write));
  --end_xfer_arb_share_counter_term_spi_0_spi_control_port arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_spi_0_spi_control_port <= spi_0_spi_control_port_end_xfer AND (((NOT spi_0_spi_control_port_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --spi_0_spi_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  spi_0_spi_control_port_arb_counter_enable <= ((end_xfer_arb_share_counter_term_spi_0_spi_control_port AND spi_0_spi_control_port_allgrants)) OR ((end_xfer_arb_share_counter_term_spi_0_spi_control_port AND NOT spi_0_spi_control_port_non_bursting_master_requests));
  --spi_0_spi_control_port_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      spi_0_spi_control_port_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(spi_0_spi_control_port_arb_counter_enable) = '1' then 
        spi_0_spi_control_port_arb_share_counter <= spi_0_spi_control_port_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --spi_0_spi_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      spi_0_spi_control_port_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((spi_0_spi_control_port_master_qreq_vector AND end_xfer_arb_share_counter_term_spi_0_spi_control_port)) OR ((end_xfer_arb_share_counter_term_spi_0_spi_control_port AND NOT spi_0_spi_control_port_non_bursting_master_requests)))) = '1' then 
        spi_0_spi_control_port_slavearbiterlockenable <= or_reduce(spi_0_spi_control_port_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master spi_0/spi_control_port arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= spi_0_spi_control_port_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --spi_0_spi_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  spi_0_spi_control_port_slavearbiterlockenable2 <= or_reduce(spi_0_spi_control_port_arb_share_counter_next_value);
  --cpu/data_master spi_0/spi_control_port arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= spi_0_spi_control_port_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --spi_0_spi_control_port_any_continuerequest at least one master continues requesting, which is an e_assign
  spi_0_spi_control_port_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_spi_0_spi_control_port <= internal_cpu_data_master_requests_spi_0_spi_control_port AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_spi_0_spi_control_port, which is an e_mux
  cpu_data_master_read_data_valid_spi_0_spi_control_port <= (internal_cpu_data_master_granted_spi_0_spi_control_port AND cpu_data_master_read) AND NOT spi_0_spi_control_port_waits_for_read;
  --spi_0_spi_control_port_writedata mux, which is an e_mux
  spi_0_spi_control_port_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --assign spi_0_spi_control_port_endofpacket_from_sa = spi_0_spi_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  spi_0_spi_control_port_endofpacket_from_sa <= spi_0_spi_control_port_endofpacket;
  --master is always granted when requested
  internal_cpu_data_master_granted_spi_0_spi_control_port <= internal_cpu_data_master_qualified_request_spi_0_spi_control_port;
  --cpu/data_master saved-grant spi_0/spi_control_port, which is an e_assign
  cpu_data_master_saved_grant_spi_0_spi_control_port <= internal_cpu_data_master_requests_spi_0_spi_control_port;
  --allow new arb cycle for spi_0/spi_control_port, which is an e_assign
  spi_0_spi_control_port_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  spi_0_spi_control_port_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  spi_0_spi_control_port_master_qreq_vector <= std_logic'('1');
  --spi_0_spi_control_port_reset_n assignment, which is an e_assign
  spi_0_spi_control_port_reset_n <= reset_n;
  spi_0_spi_control_port_chipselect <= internal_cpu_data_master_granted_spi_0_spi_control_port;
  --spi_0_spi_control_port_firsttransfer first transaction, which is an e_assign
  spi_0_spi_control_port_firsttransfer <= A_WE_StdLogic((std_logic'(spi_0_spi_control_port_begins_xfer) = '1'), spi_0_spi_control_port_unreg_firsttransfer, spi_0_spi_control_port_reg_firsttransfer);
  --spi_0_spi_control_port_unreg_firsttransfer first transaction, which is an e_assign
  spi_0_spi_control_port_unreg_firsttransfer <= NOT ((spi_0_spi_control_port_slavearbiterlockenable AND spi_0_spi_control_port_any_continuerequest));
  --spi_0_spi_control_port_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      spi_0_spi_control_port_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(spi_0_spi_control_port_begins_xfer) = '1' then 
        spi_0_spi_control_port_reg_firsttransfer <= spi_0_spi_control_port_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --spi_0_spi_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  spi_0_spi_control_port_beginbursttransfer_internal <= spi_0_spi_control_port_begins_xfer;
  --~spi_0_spi_control_port_read_n assignment, which is an e_mux
  spi_0_spi_control_port_read_n <= NOT ((internal_cpu_data_master_granted_spi_0_spi_control_port AND cpu_data_master_read));
  --~spi_0_spi_control_port_write_n assignment, which is an e_mux
  spi_0_spi_control_port_write_n <= NOT ((internal_cpu_data_master_granted_spi_0_spi_control_port AND cpu_data_master_write));
  shifted_address_to_spi_0_spi_control_port_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --spi_0_spi_control_port_address mux, which is an e_mux
  spi_0_spi_control_port_address <= A_EXT (A_SRL(shifted_address_to_spi_0_spi_control_port_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_spi_0_spi_control_port_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_spi_0_spi_control_port_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_spi_0_spi_control_port_end_xfer <= spi_0_spi_control_port_end_xfer;
    end if;

  end process;

  --spi_0_spi_control_port_waits_for_read in a cycle, which is an e_mux
  spi_0_spi_control_port_waits_for_read <= spi_0_spi_control_port_in_a_read_cycle AND spi_0_spi_control_port_begins_xfer;
  --spi_0_spi_control_port_in_a_read_cycle assignment, which is an e_assign
  spi_0_spi_control_port_in_a_read_cycle <= internal_cpu_data_master_granted_spi_0_spi_control_port AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= spi_0_spi_control_port_in_a_read_cycle;
  --spi_0_spi_control_port_waits_for_write in a cycle, which is an e_mux
  spi_0_spi_control_port_waits_for_write <= spi_0_spi_control_port_in_a_write_cycle AND spi_0_spi_control_port_begins_xfer;
  --spi_0_spi_control_port_in_a_write_cycle assignment, which is an e_assign
  spi_0_spi_control_port_in_a_write_cycle <= internal_cpu_data_master_granted_spi_0_spi_control_port AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= spi_0_spi_control_port_in_a_write_cycle;
  wait_for_spi_0_spi_control_port_counter <= std_logic'('0');
  --assign spi_0_spi_control_port_irq_from_sa = spi_0_spi_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  spi_0_spi_control_port_irq_from_sa <= spi_0_spi_control_port_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_spi_0_spi_control_port <= internal_cpu_data_master_granted_spi_0_spi_control_port;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_spi_0_spi_control_port <= internal_cpu_data_master_qualified_request_spi_0_spi_control_port;
  --vhdl renameroo for output signals
  cpu_data_master_requests_spi_0_spi_control_port <= internal_cpu_data_master_requests_spi_0_spi_control_port;
--synthesis translate_off
    --spi_0/spi_control_port enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sysid_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                 signal sysid_control_slave_address : OUT STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity sysid_control_slave_arbitrator;


architecture europa of sysid_control_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sysid_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_sysid_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal shifted_address_to_sysid_control_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal sysid_control_slave_allgrants :  STD_LOGIC;
                signal sysid_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal sysid_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal sysid_control_slave_any_continuerequest :  STD_LOGIC;
                signal sysid_control_slave_arb_counter_enable :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal sysid_control_slave_begins_xfer :  STD_LOGIC;
                signal sysid_control_slave_end_xfer :  STD_LOGIC;
                signal sysid_control_slave_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_grant_vector :  STD_LOGIC;
                signal sysid_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal sysid_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal sysid_control_slave_master_qreq_vector :  STD_LOGIC;
                signal sysid_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal sysid_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal sysid_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_waits_for_read :  STD_LOGIC;
                signal sysid_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_sysid_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT sysid_control_slave_end_xfer;
    end if;

  end process;

  sysid_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sysid_control_slave);
  --assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sysid_control_slave_readdata_from_sa <= sysid_control_slave_readdata;
  internal_cpu_data_master_requests_sysid_control_slave <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("100000100001000011001000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_read;
  --sysid_control_slave_arb_share_counter set values, which is an e_mux
  sysid_control_slave_arb_share_set_values <= std_logic_vector'("001");
  --sysid_control_slave_non_bursting_master_requests mux, which is an e_mux
  sysid_control_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_sysid_control_slave;
  --sysid_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  sysid_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  sysid_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sysid_control_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sysid_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sysid_control_slave_allgrants all slave grants, which is an e_mux
  sysid_control_slave_allgrants <= sysid_control_slave_grant_vector;
  --sysid_control_slave_end_xfer assignment, which is an e_assign
  sysid_control_slave_end_xfer <= NOT ((sysid_control_slave_waits_for_read OR sysid_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_sysid_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_sysid_control_slave <= sysid_control_slave_end_xfer AND (((NOT sysid_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  sysid_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_sysid_control_slave AND sysid_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests));
  --sysid_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_arb_counter_enable) = '1' then 
        sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((sysid_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_sysid_control_slave)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests)))) = '1' then 
        sysid_control_slave_slavearbiterlockenable <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sysid/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sysid_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sysid_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  sysid_control_slave_slavearbiterlockenable2 <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
  --cpu/data_master sysid/control_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= sysid_control_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  sysid_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave AND NOT ((cpu_data_master_read AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_data_master_read_data_valid_sysid_control_slave, which is an e_mux
  cpu_data_master_read_data_valid_sysid_control_slave <= (internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_read) AND NOT sysid_control_slave_waits_for_read;
  --master is always granted when requested
  internal_cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --cpu/data_master saved-grant sysid/control_slave, which is an e_assign
  cpu_data_master_saved_grant_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --allow new arb cycle for sysid/control_slave, which is an e_assign
  sysid_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sysid_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sysid_control_slave_master_qreq_vector <= std_logic'('1');
  --sysid_control_slave_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(sysid_control_slave_begins_xfer) = '1'), sysid_control_slave_unreg_firsttransfer, sysid_control_slave_reg_firsttransfer);
  --sysid_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_unreg_firsttransfer <= NOT ((sysid_control_slave_slavearbiterlockenable AND sysid_control_slave_any_continuerequest));
  --sysid_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_begins_xfer) = '1' then 
        sysid_control_slave_reg_firsttransfer <= sysid_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sysid_control_slave_beginbursttransfer_internal <= sysid_control_slave_begins_xfer;
  shifted_address_to_sysid_control_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --sysid_control_slave_address mux, which is an e_mux
  sysid_control_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_sysid_control_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_sysid_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sysid_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
    end if;

  end process;

  --sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  sysid_control_slave_waits_for_read <= sysid_control_slave_in_a_read_cycle AND sysid_control_slave_begins_xfer;
  --sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sysid_control_slave_in_a_read_cycle;
  --sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  sysid_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sysid_control_slave_in_a_write_cycle;
  wait_for_sysid_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_granted_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
--synthesis translate_off
    --sysid/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity tri_state_bridge_0_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal address_to_the_cfi_flash_0 : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal cfi_flash_0_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal cpu_data_master_byteenable_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cfi_flash_0_s1 : OUT STD_LOGIC;
                 signal d1_tri_state_bridge_0_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal incoming_tri_state_bridge_0_data : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal read_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                 signal select_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                 signal tri_state_bridge_0_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal write_n_to_the_cfi_flash_0 : OUT STD_LOGIC
              );
end entity tri_state_bridge_0_avalon_slave_arbitrator;


architecture europa of tri_state_bridge_0_avalon_slave_arbitrator is
                signal cfi_flash_0_s1_counter_load_value :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cfi_flash_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal cfi_flash_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal cfi_flash_0_s1_pretend_byte_enable :  STD_LOGIC;
                signal cfi_flash_0_s1_wait_counter :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cfi_flash_0_s1_waits_for_read :  STD_LOGIC;
                signal cfi_flash_0_s1_waits_for_write :  STD_LOGIC;
                signal cfi_flash_0_s1_with_write_latency :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_cfi_flash_0_s1_segment_0 :  STD_LOGIC;
                signal cpu_data_master_byteenable_cfi_flash_0_s1_segment_1 :  STD_LOGIC;
                signal cpu_data_master_byteenable_cfi_flash_0_s1_segment_2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_cfi_flash_0_s1_segment_3 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cfi_flash_0_s1 :  STD_LOGIC;
                signal d1_in_a_write_cycle :  STD_LOGIC;
                signal d1_outgoing_tri_state_bridge_0_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_0_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_1_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_2_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_3_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_4_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_5_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_6_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data_bit_7_is_x :  STD_LOGIC;
                signal internal_cfi_flash_0_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cfi_flash_0_s1 :  STD_LOGIC;
                signal internal_incoming_tri_state_bridge_0_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal last_cycle_cpu_data_master_granted_slave_cfi_flash_0_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cfi_flash_0_s1 :  STD_LOGIC;
                signal outgoing_tri_state_bridge_0_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_address_to_the_cfi_flash_0 :  STD_LOGIC_VECTOR (21 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_read_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal p1_select_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal p1_write_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal time_to_write :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_allgrants :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_begins_xfer :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_end_xfer :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_non_bursting_master_requests :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_read_pending :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_reg_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal tri_state_bridge_0_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_unreg_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_0_avalon_slave_write_pending :  STD_LOGIC;
                signal wait_for_cfi_flash_0_s1_counter :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of address_to_the_cfi_flash_0 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_in_a_write_cycle : signal is "FAST_OUTPUT_ENABLE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_outgoing_tri_state_bridge_0_data : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of internal_incoming_tri_state_bridge_0_data : signal is "FAST_INPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of read_n_to_the_cfi_flash_0 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_cfi_flash_0 : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_cfi_flash_0 : signal is "FAST_OUTPUT_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT tri_state_bridge_0_avalon_slave_end_xfer;
    end if;

  end process;

  tri_state_bridge_0_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cfi_flash_0_s1 OR internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1));
  internal_cpu_data_master_requests_cfi_flash_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 22) & std_logic_vector'("0000000000000000000000")) = std_logic_vector'("010000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --~select_n_to_the_cfi_flash_0 of type chipselect to ~p1_select_n_to_the_cfi_flash_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_cfi_flash_0 <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      select_n_to_the_cfi_flash_0 <= p1_select_n_to_the_cfi_flash_0;
    end if;

  end process;

  tri_state_bridge_0_avalon_slave_write_pending <= std_logic'('0');
  --tri_state_bridge_0/avalon_slave read pending calc, which is an e_assign
  tri_state_bridge_0_avalon_slave_read_pending <= std_logic'('0');
  --tri_state_bridge_0_avalon_slave_arb_share_counter set values, which is an e_mux
  tri_state_bridge_0_avalon_slave_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_cfi_flash_0_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), std_logic_vector'("00000000000000000000000000000001"))))), 3);
  --tri_state_bridge_0_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  tri_state_bridge_0_avalon_slave_non_bursting_master_requests <= ((internal_cpu_data_master_requests_cfi_flash_0_s1 OR internal_cpu_instruction_master_requests_cfi_flash_0_s1) OR internal_cpu_data_master_requests_cfi_flash_0_s1) OR internal_cpu_instruction_master_requests_cfi_flash_0_s1;
  --tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --tri_state_bridge_0_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  tri_state_bridge_0_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(tri_state_bridge_0_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tri_state_bridge_0_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(tri_state_bridge_0_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tri_state_bridge_0_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --tri_state_bridge_0_avalon_slave_allgrants all slave grants, which is an e_mux
  tri_state_bridge_0_avalon_slave_allgrants <= (((or_reduce(tri_state_bridge_0_avalon_slave_grant_vector)) OR (or_reduce(tri_state_bridge_0_avalon_slave_grant_vector))) OR (or_reduce(tri_state_bridge_0_avalon_slave_grant_vector))) OR (or_reduce(tri_state_bridge_0_avalon_slave_grant_vector));
  --tri_state_bridge_0_avalon_slave_end_xfer assignment, which is an e_assign
  tri_state_bridge_0_avalon_slave_end_xfer <= NOT ((cfi_flash_0_s1_waits_for_read OR cfi_flash_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave <= tri_state_bridge_0_avalon_slave_end_xfer AND (((NOT tri_state_bridge_0_avalon_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --tri_state_bridge_0_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  tri_state_bridge_0_avalon_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave AND tri_state_bridge_0_avalon_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave AND NOT tri_state_bridge_0_avalon_slave_non_bursting_master_requests));
  --tri_state_bridge_0_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_0_avalon_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_0_avalon_slave_arb_counter_enable) = '1' then 
        tri_state_bridge_0_avalon_slave_arb_share_counter <= tri_state_bridge_0_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tri_state_bridge_0_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_0_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(tri_state_bridge_0_avalon_slave_master_qreq_vector) AND end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave)) OR ((end_xfer_arb_share_counter_term_tri_state_bridge_0_avalon_slave AND NOT tri_state_bridge_0_avalon_slave_non_bursting_master_requests)))) = '1' then 
        tri_state_bridge_0_avalon_slave_slavearbiterlockenable <= or_reduce(tri_state_bridge_0_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master tri_state_bridge_0/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= tri_state_bridge_0_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 <= or_reduce(tri_state_bridge_0_avalon_slave_arb_share_counter_next_value);
  --cpu/data_master tri_state_bridge_0/avalon_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --cpu/instruction_master tri_state_bridge_0/avalon_slave arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= tri_state_bridge_0_avalon_slave_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master tri_state_bridge_0/avalon_slave arbiterlock2, which is an e_assign
  cpu_instruction_master_arbiterlock2 <= tri_state_bridge_0_avalon_slave_slavearbiterlockenable2 AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cfi_flash_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cfi_flash_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_instruction_master_granted_slave_cfi_flash_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cfi_flash_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cfi_flash_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cfi_flash_0_s1))))));
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cfi_flash_0_s1 AND internal_cpu_instruction_master_requests_cfi_flash_0_s1;
  --tri_state_bridge_0_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_mux
  tri_state_bridge_0_avalon_slave_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cfi_flash_0_s1 <= internal_cpu_data_master_requests_cfi_flash_0_s1 AND NOT (((((cpu_data_master_read AND (((tri_state_bridge_0_avalon_slave_write_pending OR (tri_state_bridge_0_avalon_slave_read_pending)) OR to_std_logic(((std_logic_vector'("00000000000000000000000000000010")<(std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_latency_counter))))))))) OR ((((tri_state_bridge_0_avalon_slave_read_pending OR NOT(internal_cpu_data_master_byteenable_cfi_flash_0_s1))) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register_in <= (internal_cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_read) AND NOT cfi_flash_0_s1_waits_for_read;
  --shift register p1 cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register <= p1_cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_cfi_flash_0_s1, which is an e_mux
  cpu_data_master_read_data_valid_cfi_flash_0_s1 <= cpu_data_master_read_data_valid_cfi_flash_0_s1_shift_register(1);
  --tri_state_bridge_0_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_incoming_tri_state_bridge_0_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      internal_incoming_tri_state_bridge_0_data <= tri_state_bridge_0_data;
    end if;

  end process;

  --cfi_flash_0_s1_with_write_latency assignment, which is an e_assign
  cfi_flash_0_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_cfi_flash_0_s1 OR internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1));
  --time to write the data, which is an e_mux
  time_to_write <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((cfi_flash_0_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")));
  --d1_outgoing_tri_state_bridge_0_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_outgoing_tri_state_bridge_0_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      d1_outgoing_tri_state_bridge_0_data <= outgoing_tri_state_bridge_0_data;
    end if;

  end process;

  --write cycle delayed by 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_in_a_write_cycle <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_in_a_write_cycle <= time_to_write;
    end if;

  end process;

  --d1_outgoing_tri_state_bridge_0_data tristate driver, which is an e_assign
  tri_state_bridge_0_data <= A_WE_StdLogicVector((std_logic'((d1_in_a_write_cycle)) = '1'), d1_outgoing_tri_state_bridge_0_data, A_REP(std_logic'('Z'), 8));
  --outgoing_tri_state_bridge_0_data mux, which is an e_mux
  outgoing_tri_state_bridge_0_data <= cpu_data_master_dbs_write_8;
  internal_cpu_instruction_master_requests_cfi_flash_0_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 22) & std_logic_vector'("0000000000000000000000")) = std_logic_vector'("010000000000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted cfi_flash_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cfi_flash_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_data_master_granted_slave_cfi_flash_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cfi_flash_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cfi_flash_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cfi_flash_0_s1))))));
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cfi_flash_0_s1 AND internal_cpu_data_master_requests_cfi_flash_0_s1;
  internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1 <= internal_cpu_instruction_master_requests_cfi_flash_0_s1 AND NOT ((((cpu_instruction_master_read AND (((tri_state_bridge_0_avalon_slave_write_pending OR (tri_state_bridge_0_avalon_slave_read_pending)) OR to_std_logic(((std_logic_vector'("00000000000000000000000000000010")<(std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter))))))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register_in <= (internal_cpu_instruction_master_granted_cfi_flash_0_s1 AND cpu_instruction_master_read) AND NOT cfi_flash_0_s1_waits_for_read;
  --shift register p1 cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_cfi_flash_0_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_cfi_flash_0_s1 <= cpu_instruction_master_read_data_valid_cfi_flash_0_s1_shift_register(1);
  --allow new arb cycle for tri_state_bridge_0/avalon_slave, which is an e_assign
  tri_state_bridge_0_avalon_slave_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cfi_flash_0/s1, which is an e_assign
  tri_state_bridge_0_avalon_slave_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1;
  --cpu/instruction_master grant cfi_flash_0/s1, which is an e_assign
  internal_cpu_instruction_master_granted_cfi_flash_0_s1 <= tri_state_bridge_0_avalon_slave_grant_vector(0);
  --cpu/instruction_master saved-grant cfi_flash_0/s1, which is an e_assign
  cpu_instruction_master_saved_grant_cfi_flash_0_s1 <= tri_state_bridge_0_avalon_slave_arb_winner(0) AND internal_cpu_instruction_master_requests_cfi_flash_0_s1;
  --cpu/data_master assignment into master qualified-requests vector for cfi_flash_0/s1, which is an e_assign
  tri_state_bridge_0_avalon_slave_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cfi_flash_0_s1;
  --cpu/data_master grant cfi_flash_0/s1, which is an e_assign
  internal_cpu_data_master_granted_cfi_flash_0_s1 <= tri_state_bridge_0_avalon_slave_grant_vector(1);
  --cpu/data_master saved-grant cfi_flash_0/s1, which is an e_assign
  cpu_data_master_saved_grant_cfi_flash_0_s1 <= tri_state_bridge_0_avalon_slave_arb_winner(1) AND internal_cpu_data_master_requests_cfi_flash_0_s1;
  --tri_state_bridge_0/avalon_slave chosen-master double-vector, which is an e_assign
  tri_state_bridge_0_avalon_slave_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((tri_state_bridge_0_avalon_slave_master_qreq_vector & tri_state_bridge_0_avalon_slave_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT tri_state_bridge_0_avalon_slave_master_qreq_vector & NOT tri_state_bridge_0_avalon_slave_master_qreq_vector))) + (std_logic_vector'("000") & (tri_state_bridge_0_avalon_slave_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  tri_state_bridge_0_avalon_slave_arb_winner <= A_WE_StdLogicVector((std_logic'(((tri_state_bridge_0_avalon_slave_allow_new_arb_cycle AND or_reduce(tri_state_bridge_0_avalon_slave_grant_vector)))) = '1'), tri_state_bridge_0_avalon_slave_grant_vector, tri_state_bridge_0_avalon_slave_saved_chosen_master_vector);
  --saved tri_state_bridge_0_avalon_slave_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_0_avalon_slave_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_0_avalon_slave_allow_new_arb_cycle) = '1' then 
        tri_state_bridge_0_avalon_slave_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(tri_state_bridge_0_avalon_slave_grant_vector)) = '1'), tri_state_bridge_0_avalon_slave_grant_vector, tri_state_bridge_0_avalon_slave_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  tri_state_bridge_0_avalon_slave_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((tri_state_bridge_0_avalon_slave_chosen_master_double_vector(1) OR tri_state_bridge_0_avalon_slave_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((tri_state_bridge_0_avalon_slave_chosen_master_double_vector(0) OR tri_state_bridge_0_avalon_slave_chosen_master_double_vector(2)))));
  --tri_state_bridge_0/avalon_slave chosen master rotated left, which is an e_assign
  tri_state_bridge_0_avalon_slave_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(tri_state_bridge_0_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(tri_state_bridge_0_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --tri_state_bridge_0/avalon_slave's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_0_avalon_slave_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(tri_state_bridge_0_avalon_slave_grant_vector)) = '1' then 
        tri_state_bridge_0_avalon_slave_arb_addend <= A_WE_StdLogicVector((std_logic'(tri_state_bridge_0_avalon_slave_end_xfer) = '1'), tri_state_bridge_0_avalon_slave_chosen_master_rot_left, tri_state_bridge_0_avalon_slave_grant_vector);
      end if;
    end if;

  end process;

  p1_select_n_to_the_cfi_flash_0 <= NOT ((internal_cpu_data_master_granted_cfi_flash_0_s1 OR internal_cpu_instruction_master_granted_cfi_flash_0_s1));
  --tri_state_bridge_0_avalon_slave_firsttransfer first transaction, which is an e_assign
  tri_state_bridge_0_avalon_slave_firsttransfer <= A_WE_StdLogic((std_logic'(tri_state_bridge_0_avalon_slave_begins_xfer) = '1'), tri_state_bridge_0_avalon_slave_unreg_firsttransfer, tri_state_bridge_0_avalon_slave_reg_firsttransfer);
  --tri_state_bridge_0_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  tri_state_bridge_0_avalon_slave_unreg_firsttransfer <= NOT ((tri_state_bridge_0_avalon_slave_slavearbiterlockenable AND tri_state_bridge_0_avalon_slave_any_continuerequest));
  --tri_state_bridge_0_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_0_avalon_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_0_avalon_slave_begins_xfer) = '1' then 
        tri_state_bridge_0_avalon_slave_reg_firsttransfer <= tri_state_bridge_0_avalon_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --tri_state_bridge_0_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tri_state_bridge_0_avalon_slave_beginbursttransfer_internal <= tri_state_bridge_0_avalon_slave_begins_xfer;
  --tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  tri_state_bridge_0_avalon_slave_arbitration_holdoff_internal <= tri_state_bridge_0_avalon_slave_begins_xfer AND tri_state_bridge_0_avalon_slave_firsttransfer;
  --~read_n_to_the_cfi_flash_0 of type read to ~p1_read_n_to_the_cfi_flash_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      read_n_to_the_cfi_flash_0 <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      read_n_to_the_cfi_flash_0 <= p1_read_n_to_the_cfi_flash_0;
    end if;

  end process;

  --~p1_read_n_to_the_cfi_flash_0 assignment, which is an e_mux
  p1_read_n_to_the_cfi_flash_0 <= NOT (((((((internal_cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cfi_flash_0_s1 AND cpu_instruction_master_read)))) AND NOT tri_state_bridge_0_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (cfi_flash_0_s1_wait_counter))<std_logic_vector'("00000000000000000000000000010000"))))));
  --~write_n_to_the_cfi_flash_0 of type write to ~p1_write_n_to_the_cfi_flash_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_cfi_flash_0 <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      write_n_to_the_cfi_flash_0 <= p1_write_n_to_the_cfi_flash_0;
    end if;

  end process;

  --~p1_write_n_to_the_cfi_flash_0 assignment, which is an e_mux
  p1_write_n_to_the_cfi_flash_0 <= NOT (((((((internal_cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_write)) AND NOT tri_state_bridge_0_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (cfi_flash_0_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000100"))))) AND to_std_logic((((std_logic_vector'("000000000000000000000000000") & (cfi_flash_0_s1_wait_counter))<std_logic_vector'("00000000000000000000000000010100"))))) AND cfi_flash_0_s1_pretend_byte_enable));
  --address_to_the_cfi_flash_0 of type address to p1_address_to_the_cfi_flash_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      address_to_the_cfi_flash_0 <= std_logic_vector'("0000000000000000000000");
    elsif clk'event and clk = '1' then
      address_to_the_cfi_flash_0 <= p1_address_to_the_cfi_flash_0;
    end if;

  end process;

  --p1_address_to_the_cfi_flash_0 mux, which is an e_mux
  p1_address_to_the_cfi_flash_0 <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cfi_flash_0_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_data_master_dbs_address(1 DOWNTO 0))), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_instruction_master_dbs_address(1 DOWNTO 0)))), 22);
  --d1_tri_state_bridge_0_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tri_state_bridge_0_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_tri_state_bridge_0_avalon_slave_end_xfer <= tri_state_bridge_0_avalon_slave_end_xfer;
    end if;

  end process;

  --cfi_flash_0_s1_waits_for_read in a cycle, which is an e_mux
  cfi_flash_0_s1_waits_for_read <= cfi_flash_0_s1_in_a_read_cycle AND wait_for_cfi_flash_0_s1_counter;
  --cfi_flash_0_s1_in_a_read_cycle assignment, which is an e_assign
  cfi_flash_0_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cfi_flash_0_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cfi_flash_0_s1_in_a_read_cycle;
  --cfi_flash_0_s1_waits_for_write in a cycle, which is an e_mux
  cfi_flash_0_s1_waits_for_write <= cfi_flash_0_s1_in_a_write_cycle AND wait_for_cfi_flash_0_s1_counter;
  --cfi_flash_0_s1_in_a_write_cycle assignment, which is an e_assign
  cfi_flash_0_s1_in_a_write_cycle <= internal_cpu_data_master_granted_cfi_flash_0_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cfi_flash_0_s1_in_a_write_cycle;
  internal_cfi_flash_0_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("000000000000000000000000000") & (cfi_flash_0_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cfi_flash_0_s1_wait_counter <= std_logic_vector'("00000");
    elsif clk'event and clk = '1' then
      cfi_flash_0_s1_wait_counter <= cfi_flash_0_s1_counter_load_value;
    end if;

  end process;

  cfi_flash_0_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((cfi_flash_0_s1_in_a_write_cycle AND tri_state_bridge_0_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000010110"), A_WE_StdLogicVector((std_logic'(((cfi_flash_0_s1_in_a_read_cycle AND tri_state_bridge_0_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000010010"), A_WE_StdLogicVector((std_logic'((NOT internal_cfi_flash_0_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("0000000000000000000000000000") & (cfi_flash_0_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 5);
  wait_for_cfi_flash_0_s1_counter <= tri_state_bridge_0_avalon_slave_begins_xfer OR NOT internal_cfi_flash_0_s1_wait_counter_eq_0;
  --cfi_flash_0_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  cfi_flash_0_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cfi_flash_0_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_byteenable_cfi_flash_0_s1))), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  (cpu_data_master_byteenable_cfi_flash_0_s1_segment_3, cpu_data_master_byteenable_cfi_flash_0_s1_segment_2, cpu_data_master_byteenable_cfi_flash_0_s1_segment_1, cpu_data_master_byteenable_cfi_flash_0_s1_segment_0) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_cfi_flash_0_s1 <= A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_cfi_flash_0_s1_segment_0, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_byteenable_cfi_flash_0_s1_segment_1, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_byteenable_cfi_flash_0_s1_segment_2, cpu_data_master_byteenable_cfi_flash_0_s1_segment_3)));
  --vhdl renameroo for output signals
  cfi_flash_0_s1_wait_counter_eq_0 <= internal_cfi_flash_0_s1_wait_counter_eq_0;
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_cfi_flash_0_s1 <= internal_cpu_data_master_byteenable_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_cfi_flash_0_s1 <= internal_cpu_data_master_granted_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cfi_flash_0_s1 <= internal_cpu_data_master_qualified_request_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cfi_flash_0_s1 <= internal_cpu_data_master_requests_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cfi_flash_0_s1 <= internal_cpu_instruction_master_granted_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cfi_flash_0_s1 <= internal_cpu_instruction_master_qualified_request_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cfi_flash_0_s1 <= internal_cpu_instruction_master_requests_cfi_flash_0_s1;
  --vhdl renameroo for output signals
  incoming_tri_state_bridge_0_data <= internal_incoming_tri_state_bridge_0_data;
--synthesis translate_off
    --incoming_tri_state_bridge_0_data_bit_0_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_0_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(0))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(0) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_0_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(0));
    --incoming_tri_state_bridge_0_data_bit_1_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_1_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(1))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(1) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_1_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(1));
    --incoming_tri_state_bridge_0_data_bit_2_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_2_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(2))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(2) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_2_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(2));
    --incoming_tri_state_bridge_0_data_bit_3_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_3_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(3))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(3) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_3_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(3));
    --incoming_tri_state_bridge_0_data_bit_4_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_4_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(4))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(4) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_4_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(4));
    --incoming_tri_state_bridge_0_data_bit_5_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_5_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(5))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(5) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_5_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(5));
    --incoming_tri_state_bridge_0_data_bit_6_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_6_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(6))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(6) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_6_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(6));
    --incoming_tri_state_bridge_0_data_bit_7_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_0_data_bit_7_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_tri_state_bridge_0_data(7))), '1','0');
    --Crush incoming_tri_state_bridge_0_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0(7) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_0_data_bit_7_is_x) = '1'), std_logic'('0'), internal_incoming_tri_state_bridge_0_data(7));
    --cfi_flash_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line11 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cfi_flash_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cfi_flash_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line11, now);
          write(write_line11, string'(": "));
          write(write_line11, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line11.all);
          deallocate (write_line11);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line12 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cfi_flash_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cfi_flash_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line12, now);
          write(write_line12, string'(": "));
          write(write_line12, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line12.all);
          deallocate (write_line12);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on
--synthesis read_comments_as_HDL on
--    
--    incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 <= internal_incoming_tri_state_bridge_0_data;
--synthesis read_comments_as_HDL off

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tri_state_bridge_0_bridge_arbitrator is 
end entity tri_state_bridge_0_bridge_arbitrator;


architecture europa of tri_state_bridge_0_bridge_arbitrator is

begin


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios_system_reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity nios_system_reset_clk_domain_synch_module;


architecture europa of nios_system_reset_clk_domain_synch_module is
                signal data_in_d1 :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of data_in_d1 : signal is "{-from ""*""} CUT=ON ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";
attribute ALTERA_ATTRIBUTE of data_out : signal is "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      data_in_d1 <= data_in;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk'event and clk = '1' then
      data_out <= data_in_d1;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios_system is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_LCD
                 signal LCD_E_from_the_LCD : OUT STD_LOGIC;
                 signal LCD_RS_from_the_LCD : OUT STD_LOGIC;
                 signal LCD_RW_from_the_LCD : OUT STD_LOGIC;
                 signal LCD_data_to_and_from_the_LCD : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_LEDG
                 signal out_port_from_the_LEDG : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_LEDR
                 signal out_port_from_the_LEDR : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);

              -- the_NIOS_B
                 signal out_port_from_the_NIOS_B : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_NIOS_G
                 signal out_port_from_the_NIOS_G : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_NIOS_R
                 signal out_port_from_the_NIOS_R : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_SEG7_ADDR
                 signal out_port_from_the_SEG7_ADDR : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

              -- the_SEG7_DATA
                 signal out_port_from_the_SEG7_DATA : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

              -- the_SW
                 signal in_port_to_the_SW : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_fifo_req
                 signal out_port_from_the_fifo_req : OUT STD_LOGIC;

              -- the_spi_0
                 signal MISO_to_the_spi_0 : IN STD_LOGIC;
                 signal MOSI_from_the_spi_0 : OUT STD_LOGIC;
                 signal SCLK_from_the_spi_0 : OUT STD_LOGIC;
                 signal SS_n_from_the_spi_0 : OUT STD_LOGIC;

              -- the_tri_state_bridge_0_avalon_slave
                 signal address_to_the_cfi_flash_0 : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal read_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                 signal select_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                 signal tri_state_bridge_0_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal write_n_to_the_cfi_flash_0 : OUT STD_LOGIC
              );
end entity nios_system;


architecture europa of nios_system is
component LCD_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal LCD_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LCD_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LCD_control_slave_begintransfer : OUT STD_LOGIC;
                    signal LCD_control_slave_read : OUT STD_LOGIC;
                    signal LCD_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LCD_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal LCD_control_slave_write : OUT STD_LOGIC;
                    signal LCD_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_LCD_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_LCD_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LCD_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_LCD_control_slave : OUT STD_LOGIC;
                    signal d1_LCD_control_slave_end_xfer : OUT STD_LOGIC
                 );
end component LCD_control_slave_arbitrator;

component LCD is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal LCD_E : OUT STD_LOGIC;
                    signal LCD_RS : OUT STD_LOGIC;
                    signal LCD_RW : OUT STD_LOGIC;
                    signal LCD_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component LCD;

component LEDG_s1_arbitrator is 
           port (
                 -- inputs:
                    signal LEDG_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LEDG_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LEDG_s1_chipselect : OUT STD_LOGIC;
                    signal LEDG_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LEDG_s1_reset_n : OUT STD_LOGIC;
                    signal LEDG_s1_write_n : OUT STD_LOGIC;
                    signal LEDG_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_LEDG_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_LEDG_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LEDG_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_LEDG_s1 : OUT STD_LOGIC;
                    signal d1_LEDG_s1_end_xfer : OUT STD_LOGIC
                 );
end component LEDG_s1_arbitrator;

component LEDG is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component LEDG;

component LEDR_s1_arbitrator is 
           port (
                 -- inputs:
                    signal LEDR_s1_readdata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LEDR_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LEDR_s1_chipselect : OUT STD_LOGIC;
                    signal LEDR_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal LEDR_s1_reset_n : OUT STD_LOGIC;
                    signal LEDR_s1_write_n : OUT STD_LOGIC;
                    signal LEDR_s1_writedata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal cpu_data_master_granted_LEDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_LEDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LEDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_LEDR_s1 : OUT STD_LOGIC;
                    signal d1_LEDR_s1_end_xfer : OUT STD_LOGIC
                 );
end component LEDR_s1_arbitrator;

component LEDR is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
                 );
end component LEDR;

component NIOS_B_s1_arbitrator is 
           port (
                 -- inputs:
                    signal NIOS_B_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal NIOS_B_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal NIOS_B_s1_chipselect : OUT STD_LOGIC;
                    signal NIOS_B_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal NIOS_B_s1_reset_n : OUT STD_LOGIC;
                    signal NIOS_B_s1_write_n : OUT STD_LOGIC;
                    signal NIOS_B_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_NIOS_B_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_B_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_B_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_B_s1 : OUT STD_LOGIC;
                    signal d1_NIOS_B_s1_end_xfer : OUT STD_LOGIC
                 );
end component NIOS_B_s1_arbitrator;

component NIOS_B is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component NIOS_B;

component NIOS_G_s1_arbitrator is 
           port (
                 -- inputs:
                    signal NIOS_G_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal NIOS_G_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal NIOS_G_s1_chipselect : OUT STD_LOGIC;
                    signal NIOS_G_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal NIOS_G_s1_reset_n : OUT STD_LOGIC;
                    signal NIOS_G_s1_write_n : OUT STD_LOGIC;
                    signal NIOS_G_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_NIOS_G_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_G_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_G_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_G_s1 : OUT STD_LOGIC;
                    signal d1_NIOS_G_s1_end_xfer : OUT STD_LOGIC
                 );
end component NIOS_G_s1_arbitrator;

component NIOS_G is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component NIOS_G;

component NIOS_R_s1_arbitrator is 
           port (
                 -- inputs:
                    signal NIOS_R_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal NIOS_R_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal NIOS_R_s1_chipselect : OUT STD_LOGIC;
                    signal NIOS_R_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal NIOS_R_s1_reset_n : OUT STD_LOGIC;
                    signal NIOS_R_s1_write_n : OUT STD_LOGIC;
                    signal NIOS_R_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_NIOS_R_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_R_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_R_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_R_s1 : OUT STD_LOGIC;
                    signal d1_NIOS_R_s1_end_xfer : OUT STD_LOGIC
                 );
end component NIOS_R_s1_arbitrator;

component NIOS_R is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component NIOS_R;

component SEG7_ADDR_s1_arbitrator is 
           port (
                 -- inputs:
                    signal SEG7_ADDR_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SEG7_ADDR_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal SEG7_ADDR_s1_chipselect : OUT STD_LOGIC;
                    signal SEG7_ADDR_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal SEG7_ADDR_s1_reset_n : OUT STD_LOGIC;
                    signal SEG7_ADDR_s1_write_n : OUT STD_LOGIC;
                    signal SEG7_ADDR_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_granted_SEG7_ADDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_SEG7_ADDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SEG7_ADDR_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_SEG7_ADDR_s1 : OUT STD_LOGIC;
                    signal d1_SEG7_ADDR_s1_end_xfer : OUT STD_LOGIC
                 );
end component SEG7_ADDR_s1_arbitrator;

component SEG7_ADDR is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component SEG7_ADDR;

component SEG7_DATA_s1_arbitrator is 
           port (
                 -- inputs:
                    signal SEG7_DATA_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SEG7_DATA_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal SEG7_DATA_s1_chipselect : OUT STD_LOGIC;
                    signal SEG7_DATA_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal SEG7_DATA_s1_reset_n : OUT STD_LOGIC;
                    signal SEG7_DATA_s1_write_n : OUT STD_LOGIC;
                    signal SEG7_DATA_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_granted_SEG7_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_SEG7_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SEG7_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_SEG7_DATA_s1 : OUT STD_LOGIC;
                    signal d1_SEG7_DATA_s1_end_xfer : OUT STD_LOGIC
                 );
end component SEG7_DATA_s1_arbitrator;

component SEG7_DATA is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component SEG7_DATA;

component SW_s1_arbitrator is 
           port (
                 -- inputs:
                    signal SW_s1_irq : IN STD_LOGIC;
                    signal SW_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SW_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal SW_s1_chipselect : OUT STD_LOGIC;
                    signal SW_s1_irq_from_sa : OUT STD_LOGIC;
                    signal SW_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal SW_s1_reset_n : OUT STD_LOGIC;
                    signal SW_s1_write_n : OUT STD_LOGIC;
                    signal SW_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_granted_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SW_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_SW_s1 : OUT STD_LOGIC;
                    signal d1_SW_s1_end_xfer : OUT STD_LOGIC
                 );
end component SW_s1_arbitrator;

component SW is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SW;

component cpu_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_jtag_debug_module_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal LCD_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LCD_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                    signal LEDG_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LEDR_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal NIOS_B_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal NIOS_G_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal NIOS_R_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal SEG7_ADDR_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal SEG7_DATA_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal SW_s1_irq_from_sa : IN STD_LOGIC;
                    signal SW_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cfi_flash_0_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_byteenable_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_LCD_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_LEDG_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_LEDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_NIOS_B_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_NIOS_G_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_NIOS_R_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_SEG7_ADDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_SEG7_DATA_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_granted_fifo_req_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_spi_0_spi_control_port : IN STD_LOGIC;
                    signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_LCD_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_LEDG_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_LEDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_B_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_G_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_NIOS_R_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_SEG7_ADDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_SEG7_DATA_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_fifo_req_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_spi_0_spi_control_port : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LCD_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LEDG_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_LEDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_B_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_G_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_NIOS_R_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SEG7_ADDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SEG7_DATA_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_fifo_req_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_spi_0_spi_control_port : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_LCD_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_LEDG_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_LEDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_B_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_G_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_NIOS_R_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_SEG7_ADDR_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_SEG7_DATA_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_SW_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_requests_fifo_req_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_spi_0_spi_control_port : IN STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_LCD_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_LEDG_s1_end_xfer : IN STD_LOGIC;
                    signal d1_LEDR_s1_end_xfer : IN STD_LOGIC;
                    signal d1_NIOS_B_s1_end_xfer : IN STD_LOGIC;
                    signal d1_NIOS_G_s1_end_xfer : IN STD_LOGIC;
                    signal d1_NIOS_R_s1_end_xfer : IN STD_LOGIC;
                    signal d1_SEG7_ADDR_s1_end_xfer : IN STD_LOGIC;
                    signal d1_SEG7_DATA_s1_end_xfer : IN STD_LOGIC;
                    signal d1_SW_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_fifo_req_s1_end_xfer : IN STD_LOGIC;
                    signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_spi_0_spi_control_port_end_xfer : IN STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_0_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal fifo_req_s1_readdata_from_sa : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal spi_0_spi_control_port_irq_from_sa : IN STD_LOGIC;
                    signal spi_0_spi_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal cfi_flash_0_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_granted_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_cfi_flash_0_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_0_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_0_data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdatavalid : IN STD_LOGIC;
                    signal d_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_readdatavalid : IN STD_LOGIC;
                    signal i_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal d_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu;

component fifo_req_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal fifo_req_s1_readdata : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_fifo_req_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_fifo_req_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_fifo_req_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_fifo_req_s1 : OUT STD_LOGIC;
                    signal d1_fifo_req_s1_end_xfer : OUT STD_LOGIC;
                    signal fifo_req_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal fifo_req_s1_chipselect : OUT STD_LOGIC;
                    signal fifo_req_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal fifo_req_s1_reset_n : OUT STD_LOGIC;
                    signal fifo_req_s1_write_n : OUT STD_LOGIC;
                    signal fifo_req_s1_writedata : OUT STD_LOGIC
                 );
end component fifo_req_s1_arbitrator;

component fifo_req is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal out_port : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component fifo_req;

component jtag_uart_0_avalon_jtag_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_irq : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_address : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component jtag_uart_0_avalon_jtag_slave_arbitrator;

component jtag_uart_0 is 
           port (
                 -- inputs:
                    signal av_address : IN STD_LOGIC;
                    signal av_chipselect : IN STD_LOGIC;
                    signal av_read_n : IN STD_LOGIC;
                    signal av_write_n : IN STD_LOGIC;
                    signal av_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal rst_n : IN STD_LOGIC;

                 -- outputs:
                    signal av_irq : OUT STD_LOGIC;
                    signal av_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal av_waitrequest : OUT STD_LOGIC;
                    signal dataavailable : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component jtag_uart_0;

component onchip_memory2_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_address : OUT STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal onchip_memory2_0_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_memory2_0_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_clken : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_memory2_0_s1_write : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_memory2_0_s1_arbitrator;

component onchip_memory2_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (13 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_memory2_0;

component spi_0_spi_control_port_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal spi_0_spi_control_port_dataavailable : IN STD_LOGIC;
                    signal spi_0_spi_control_port_endofpacket : IN STD_LOGIC;
                    signal spi_0_spi_control_port_irq : IN STD_LOGIC;
                    signal spi_0_spi_control_port_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal spi_0_spi_control_port_readyfordata : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_spi_0_spi_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_spi_0_spi_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_spi_0_spi_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_requests_spi_0_spi_control_port : OUT STD_LOGIC;
                    signal d1_spi_0_spi_control_port_end_xfer : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal spi_0_spi_control_port_chipselect : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_dataavailable_from_sa : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_endofpacket_from_sa : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_irq_from_sa : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_read_n : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal spi_0_spi_control_port_readyfordata_from_sa : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_reset_n : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_write_n : OUT STD_LOGIC;
                    signal spi_0_spi_control_port_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component spi_0_spi_control_port_arbitrator;

component spi_0 is 
           port (
                 -- inputs:
                    signal MISO : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal data_from_cpu : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal mem_addr : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal spi_select : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal MOSI : OUT STD_LOGIC;
                    signal SCLK : OUT STD_LOGIC;
                    signal SS_n : OUT STD_LOGIC;
                    signal data_to_cpu : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal dataavailable : OUT STD_LOGIC;
                    signal endofpacket : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component spi_0;

component sysid_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                    signal sysid_control_slave_address : OUT STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid_control_slave_arbitrator;

component sysid is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid;

component tri_state_bridge_0_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal address_to_the_cfi_flash_0 : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal cfi_flash_0_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal cpu_data_master_byteenable_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cfi_flash_0_s1 : OUT STD_LOGIC;
                    signal d1_tri_state_bridge_0_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal incoming_tri_state_bridge_0_data : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal read_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                    signal select_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                    signal tri_state_bridge_0_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal write_n_to_the_cfi_flash_0 : OUT STD_LOGIC
                 );
end component tri_state_bridge_0_avalon_slave_arbitrator;

component tri_state_bridge_0 is 
end component tri_state_bridge_0;

component tri_state_bridge_0_bridge_arbitrator is 
end component tri_state_bridge_0_bridge_arbitrator;

component nios_system_reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component nios_system_reset_clk_domain_synch_module;

                signal LCD_control_slave_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LCD_control_slave_begintransfer :  STD_LOGIC;
                signal LCD_control_slave_read :  STD_LOGIC;
                signal LCD_control_slave_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LCD_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LCD_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal LCD_control_slave_write :  STD_LOGIC;
                signal LCD_control_slave_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDG_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LEDG_s1_chipselect :  STD_LOGIC;
                signal LEDG_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDG_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDG_s1_reset_n :  STD_LOGIC;
                signal LEDG_s1_write_n :  STD_LOGIC;
                signal LEDG_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDR_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LEDR_s1_chipselect :  STD_LOGIC;
                signal LEDR_s1_readdata :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal LEDR_s1_readdata_from_sa :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal LEDR_s1_reset_n :  STD_LOGIC;
                signal LEDR_s1_write_n :  STD_LOGIC;
                signal LEDR_s1_writedata :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal NIOS_B_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal NIOS_B_s1_chipselect :  STD_LOGIC;
                signal NIOS_B_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_B_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_B_s1_reset_n :  STD_LOGIC;
                signal NIOS_B_s1_write_n :  STD_LOGIC;
                signal NIOS_B_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_G_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal NIOS_G_s1_chipselect :  STD_LOGIC;
                signal NIOS_G_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_G_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_G_s1_reset_n :  STD_LOGIC;
                signal NIOS_G_s1_write_n :  STD_LOGIC;
                signal NIOS_G_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_R_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal NIOS_R_s1_chipselect :  STD_LOGIC;
                signal NIOS_R_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_R_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal NIOS_R_s1_reset_n :  STD_LOGIC;
                signal NIOS_R_s1_write_n :  STD_LOGIC;
                signal NIOS_R_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SEG7_ADDR_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SEG7_ADDR_s1_chipselect :  STD_LOGIC;
                signal SEG7_ADDR_s1_readdata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SEG7_ADDR_s1_readdata_from_sa :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SEG7_ADDR_s1_reset_n :  STD_LOGIC;
                signal SEG7_ADDR_s1_write_n :  STD_LOGIC;
                signal SEG7_ADDR_s1_writedata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SEG7_DATA_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SEG7_DATA_s1_chipselect :  STD_LOGIC;
                signal SEG7_DATA_s1_readdata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SEG7_DATA_s1_readdata_from_sa :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SEG7_DATA_s1_reset_n :  STD_LOGIC;
                signal SEG7_DATA_s1_write_n :  STD_LOGIC;
                signal SEG7_DATA_s1_writedata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal SW_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SW_s1_chipselect :  STD_LOGIC;
                signal SW_s1_irq :  STD_LOGIC;
                signal SW_s1_irq_from_sa :  STD_LOGIC;
                signal SW_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SW_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SW_s1_reset_n :  STD_LOGIC;
                signal SW_s1_write_n :  STD_LOGIC;
                signal SW_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cfi_flash_0_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal clk_reset_n :  STD_LOGIC;
                signal cpu_data_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_byteenable_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_write_8 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_data_master_debugaccess :  STD_LOGIC;
                signal cpu_data_master_granted_LCD_control_slave :  STD_LOGIC;
                signal cpu_data_master_granted_LEDG_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_LEDR_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_NIOS_B_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_NIOS_G_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_NIOS_R_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_SEG7_ADDR_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_SEG7_DATA_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_granted_fifo_req_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_spi_0_spi_control_port :  STD_LOGIC;
                signal cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_qualified_request_LCD_control_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_LEDG_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_LEDR_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_NIOS_B_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_NIOS_G_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_NIOS_R_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_SEG7_ADDR_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_SEG7_DATA_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_qualified_request_fifo_req_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_spi_0_spi_control_port :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_read :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_LCD_control_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_LEDG_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_LEDR_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_NIOS_B_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_NIOS_G_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_NIOS_R_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_SEG7_ADDR_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_SEG7_DATA_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_fifo_req_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_spi_0_spi_control_port :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_readdatavalid :  STD_LOGIC;
                signal cpu_data_master_requests_LCD_control_slave :  STD_LOGIC;
                signal cpu_data_master_requests_LEDG_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_LEDR_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_NIOS_B_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_NIOS_G_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_NIOS_R_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_SEG7_ADDR_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_SEG7_DATA_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_SW_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_requests_fifo_req_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_spi_0_spi_control_port :  STD_LOGIC;
                signal cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_waitrequest :  STD_LOGIC;
                signal cpu_data_master_write :  STD_LOGIC;
                signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_granted_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_qualified_request_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal cpu_instruction_master_requests_cfi_flash_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_LCD_control_slave_end_xfer :  STD_LOGIC;
                signal d1_LEDG_s1_end_xfer :  STD_LOGIC;
                signal d1_LEDR_s1_end_xfer :  STD_LOGIC;
                signal d1_NIOS_B_s1_end_xfer :  STD_LOGIC;
                signal d1_NIOS_G_s1_end_xfer :  STD_LOGIC;
                signal d1_NIOS_R_s1_end_xfer :  STD_LOGIC;
                signal d1_SEG7_ADDR_s1_end_xfer :  STD_LOGIC;
                signal d1_SEG7_DATA_s1_end_xfer :  STD_LOGIC;
                signal d1_SW_s1_end_xfer :  STD_LOGIC;
                signal d1_cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_fifo_req_s1_end_xfer :  STD_LOGIC;
                signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal d1_onchip_memory2_0_s1_end_xfer :  STD_LOGIC;
                signal d1_spi_0_spi_control_port_end_xfer :  STD_LOGIC;
                signal d1_sysid_control_slave_end_xfer :  STD_LOGIC;
                signal d1_tri_state_bridge_0_avalon_slave_end_xfer :  STD_LOGIC;
                signal fifo_req_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal fifo_req_s1_chipselect :  STD_LOGIC;
                signal fifo_req_s1_readdata :  STD_LOGIC;
                signal fifo_req_s1_readdata_from_sa :  STD_LOGIC;
                signal fifo_req_s1_reset_n :  STD_LOGIC;
                signal fifo_req_s1_write_n :  STD_LOGIC;
                signal fifo_req_s1_writedata :  STD_LOGIC;
                signal incoming_tri_state_bridge_0_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_LCD_E_from_the_LCD :  STD_LOGIC;
                signal internal_LCD_RS_from_the_LCD :  STD_LOGIC;
                signal internal_LCD_RW_from_the_LCD :  STD_LOGIC;
                signal internal_MOSI_from_the_spi_0 :  STD_LOGIC;
                signal internal_SCLK_from_the_spi_0 :  STD_LOGIC;
                signal internal_SS_n_from_the_spi_0 :  STD_LOGIC;
                signal internal_address_to_the_cfi_flash_0 :  STD_LOGIC_VECTOR (21 DOWNTO 0);
                signal internal_out_port_from_the_LEDG :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_LEDR :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal internal_out_port_from_the_NIOS_B :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_NIOS_G :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_NIOS_R :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_SEG7_ADDR :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_out_port_from_the_SEG7_DATA :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_out_port_from_the_fifo_req :  STD_LOGIC;
                signal internal_read_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal internal_select_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal internal_write_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_address :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_chipselect :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_dataavailable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_irq :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_irq_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_read_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_readyfordata :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_reset_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waitrequest :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_write_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal module_input :  STD_LOGIC;
                signal onchip_memory2_0_s1_address :  STD_LOGIC_VECTOR (13 DOWNTO 0);
                signal onchip_memory2_0_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_memory2_0_s1_chipselect :  STD_LOGIC;
                signal onchip_memory2_0_s1_clken :  STD_LOGIC;
                signal onchip_memory2_0_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory2_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory2_0_s1_write :  STD_LOGIC;
                signal onchip_memory2_0_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal reset_n_sources :  STD_LOGIC;
                signal spi_0_spi_control_port_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal spi_0_spi_control_port_chipselect :  STD_LOGIC;
                signal spi_0_spi_control_port_dataavailable :  STD_LOGIC;
                signal spi_0_spi_control_port_dataavailable_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_endofpacket :  STD_LOGIC;
                signal spi_0_spi_control_port_endofpacket_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_irq :  STD_LOGIC;
                signal spi_0_spi_control_port_irq_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_read_n :  STD_LOGIC;
                signal spi_0_spi_control_port_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal spi_0_spi_control_port_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal spi_0_spi_control_port_readyfordata :  STD_LOGIC;
                signal spi_0_spi_control_port_readyfordata_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_reset_n :  STD_LOGIC;
                signal spi_0_spi_control_port_write_n :  STD_LOGIC;
                signal spi_0_spi_control_port_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sysid_control_slave_address :  STD_LOGIC;
                signal sysid_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sysid_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --the_LCD_control_slave, which is an e_instance
  the_LCD_control_slave : LCD_control_slave_arbitrator
    port map(
      LCD_control_slave_address => LCD_control_slave_address,
      LCD_control_slave_begintransfer => LCD_control_slave_begintransfer,
      LCD_control_slave_read => LCD_control_slave_read,
      LCD_control_slave_readdata_from_sa => LCD_control_slave_readdata_from_sa,
      LCD_control_slave_wait_counter_eq_0 => LCD_control_slave_wait_counter_eq_0,
      LCD_control_slave_write => LCD_control_slave_write,
      LCD_control_slave_writedata => LCD_control_slave_writedata,
      cpu_data_master_granted_LCD_control_slave => cpu_data_master_granted_LCD_control_slave,
      cpu_data_master_qualified_request_LCD_control_slave => cpu_data_master_qualified_request_LCD_control_slave,
      cpu_data_master_read_data_valid_LCD_control_slave => cpu_data_master_read_data_valid_LCD_control_slave,
      cpu_data_master_requests_LCD_control_slave => cpu_data_master_requests_LCD_control_slave,
      d1_LCD_control_slave_end_xfer => d1_LCD_control_slave_end_xfer,
      LCD_control_slave_readdata => LCD_control_slave_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LCD, which is an e_ptf_instance
  the_LCD : LCD
    port map(
      LCD_E => internal_LCD_E_from_the_LCD,
      LCD_RS => internal_LCD_RS_from_the_LCD,
      LCD_RW => internal_LCD_RW_from_the_LCD,
      LCD_data => LCD_data_to_and_from_the_LCD,
      readdata => LCD_control_slave_readdata,
      address => LCD_control_slave_address,
      begintransfer => LCD_control_slave_begintransfer,
      read => LCD_control_slave_read,
      write => LCD_control_slave_write,
      writedata => LCD_control_slave_writedata
    );


  --the_LEDG_s1, which is an e_instance
  the_LEDG_s1 : LEDG_s1_arbitrator
    port map(
      LEDG_s1_address => LEDG_s1_address,
      LEDG_s1_chipselect => LEDG_s1_chipselect,
      LEDG_s1_readdata_from_sa => LEDG_s1_readdata_from_sa,
      LEDG_s1_reset_n => LEDG_s1_reset_n,
      LEDG_s1_write_n => LEDG_s1_write_n,
      LEDG_s1_writedata => LEDG_s1_writedata,
      cpu_data_master_granted_LEDG_s1 => cpu_data_master_granted_LEDG_s1,
      cpu_data_master_qualified_request_LEDG_s1 => cpu_data_master_qualified_request_LEDG_s1,
      cpu_data_master_read_data_valid_LEDG_s1 => cpu_data_master_read_data_valid_LEDG_s1,
      cpu_data_master_requests_LEDG_s1 => cpu_data_master_requests_LEDG_s1,
      d1_LEDG_s1_end_xfer => d1_LEDG_s1_end_xfer,
      LEDG_s1_readdata => LEDG_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LEDG, which is an e_ptf_instance
  the_LEDG : LEDG
    port map(
      out_port => internal_out_port_from_the_LEDG,
      readdata => LEDG_s1_readdata,
      address => LEDG_s1_address,
      chipselect => LEDG_s1_chipselect,
      clk => clk,
      reset_n => LEDG_s1_reset_n,
      write_n => LEDG_s1_write_n,
      writedata => LEDG_s1_writedata
    );


  --the_LEDR_s1, which is an e_instance
  the_LEDR_s1 : LEDR_s1_arbitrator
    port map(
      LEDR_s1_address => LEDR_s1_address,
      LEDR_s1_chipselect => LEDR_s1_chipselect,
      LEDR_s1_readdata_from_sa => LEDR_s1_readdata_from_sa,
      LEDR_s1_reset_n => LEDR_s1_reset_n,
      LEDR_s1_write_n => LEDR_s1_write_n,
      LEDR_s1_writedata => LEDR_s1_writedata,
      cpu_data_master_granted_LEDR_s1 => cpu_data_master_granted_LEDR_s1,
      cpu_data_master_qualified_request_LEDR_s1 => cpu_data_master_qualified_request_LEDR_s1,
      cpu_data_master_read_data_valid_LEDR_s1 => cpu_data_master_read_data_valid_LEDR_s1,
      cpu_data_master_requests_LEDR_s1 => cpu_data_master_requests_LEDR_s1,
      d1_LEDR_s1_end_xfer => d1_LEDR_s1_end_xfer,
      LEDR_s1_readdata => LEDR_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LEDR, which is an e_ptf_instance
  the_LEDR : LEDR
    port map(
      out_port => internal_out_port_from_the_LEDR,
      readdata => LEDR_s1_readdata,
      address => LEDR_s1_address,
      chipselect => LEDR_s1_chipselect,
      clk => clk,
      reset_n => LEDR_s1_reset_n,
      write_n => LEDR_s1_write_n,
      writedata => LEDR_s1_writedata
    );


  --the_NIOS_B_s1, which is an e_instance
  the_NIOS_B_s1 : NIOS_B_s1_arbitrator
    port map(
      NIOS_B_s1_address => NIOS_B_s1_address,
      NIOS_B_s1_chipselect => NIOS_B_s1_chipselect,
      NIOS_B_s1_readdata_from_sa => NIOS_B_s1_readdata_from_sa,
      NIOS_B_s1_reset_n => NIOS_B_s1_reset_n,
      NIOS_B_s1_write_n => NIOS_B_s1_write_n,
      NIOS_B_s1_writedata => NIOS_B_s1_writedata,
      cpu_data_master_granted_NIOS_B_s1 => cpu_data_master_granted_NIOS_B_s1,
      cpu_data_master_qualified_request_NIOS_B_s1 => cpu_data_master_qualified_request_NIOS_B_s1,
      cpu_data_master_read_data_valid_NIOS_B_s1 => cpu_data_master_read_data_valid_NIOS_B_s1,
      cpu_data_master_requests_NIOS_B_s1 => cpu_data_master_requests_NIOS_B_s1,
      d1_NIOS_B_s1_end_xfer => d1_NIOS_B_s1_end_xfer,
      NIOS_B_s1_readdata => NIOS_B_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_NIOS_B, which is an e_ptf_instance
  the_NIOS_B : NIOS_B
    port map(
      out_port => internal_out_port_from_the_NIOS_B,
      readdata => NIOS_B_s1_readdata,
      address => NIOS_B_s1_address,
      chipselect => NIOS_B_s1_chipselect,
      clk => clk,
      reset_n => NIOS_B_s1_reset_n,
      write_n => NIOS_B_s1_write_n,
      writedata => NIOS_B_s1_writedata
    );


  --the_NIOS_G_s1, which is an e_instance
  the_NIOS_G_s1 : NIOS_G_s1_arbitrator
    port map(
      NIOS_G_s1_address => NIOS_G_s1_address,
      NIOS_G_s1_chipselect => NIOS_G_s1_chipselect,
      NIOS_G_s1_readdata_from_sa => NIOS_G_s1_readdata_from_sa,
      NIOS_G_s1_reset_n => NIOS_G_s1_reset_n,
      NIOS_G_s1_write_n => NIOS_G_s1_write_n,
      NIOS_G_s1_writedata => NIOS_G_s1_writedata,
      cpu_data_master_granted_NIOS_G_s1 => cpu_data_master_granted_NIOS_G_s1,
      cpu_data_master_qualified_request_NIOS_G_s1 => cpu_data_master_qualified_request_NIOS_G_s1,
      cpu_data_master_read_data_valid_NIOS_G_s1 => cpu_data_master_read_data_valid_NIOS_G_s1,
      cpu_data_master_requests_NIOS_G_s1 => cpu_data_master_requests_NIOS_G_s1,
      d1_NIOS_G_s1_end_xfer => d1_NIOS_G_s1_end_xfer,
      NIOS_G_s1_readdata => NIOS_G_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_NIOS_G, which is an e_ptf_instance
  the_NIOS_G : NIOS_G
    port map(
      out_port => internal_out_port_from_the_NIOS_G,
      readdata => NIOS_G_s1_readdata,
      address => NIOS_G_s1_address,
      chipselect => NIOS_G_s1_chipselect,
      clk => clk,
      reset_n => NIOS_G_s1_reset_n,
      write_n => NIOS_G_s1_write_n,
      writedata => NIOS_G_s1_writedata
    );


  --the_NIOS_R_s1, which is an e_instance
  the_NIOS_R_s1 : NIOS_R_s1_arbitrator
    port map(
      NIOS_R_s1_address => NIOS_R_s1_address,
      NIOS_R_s1_chipselect => NIOS_R_s1_chipselect,
      NIOS_R_s1_readdata_from_sa => NIOS_R_s1_readdata_from_sa,
      NIOS_R_s1_reset_n => NIOS_R_s1_reset_n,
      NIOS_R_s1_write_n => NIOS_R_s1_write_n,
      NIOS_R_s1_writedata => NIOS_R_s1_writedata,
      cpu_data_master_granted_NIOS_R_s1 => cpu_data_master_granted_NIOS_R_s1,
      cpu_data_master_qualified_request_NIOS_R_s1 => cpu_data_master_qualified_request_NIOS_R_s1,
      cpu_data_master_read_data_valid_NIOS_R_s1 => cpu_data_master_read_data_valid_NIOS_R_s1,
      cpu_data_master_requests_NIOS_R_s1 => cpu_data_master_requests_NIOS_R_s1,
      d1_NIOS_R_s1_end_xfer => d1_NIOS_R_s1_end_xfer,
      NIOS_R_s1_readdata => NIOS_R_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_NIOS_R, which is an e_ptf_instance
  the_NIOS_R : NIOS_R
    port map(
      out_port => internal_out_port_from_the_NIOS_R,
      readdata => NIOS_R_s1_readdata,
      address => NIOS_R_s1_address,
      chipselect => NIOS_R_s1_chipselect,
      clk => clk,
      reset_n => NIOS_R_s1_reset_n,
      write_n => NIOS_R_s1_write_n,
      writedata => NIOS_R_s1_writedata
    );


  --the_SEG7_ADDR_s1, which is an e_instance
  the_SEG7_ADDR_s1 : SEG7_ADDR_s1_arbitrator
    port map(
      SEG7_ADDR_s1_address => SEG7_ADDR_s1_address,
      SEG7_ADDR_s1_chipselect => SEG7_ADDR_s1_chipselect,
      SEG7_ADDR_s1_readdata_from_sa => SEG7_ADDR_s1_readdata_from_sa,
      SEG7_ADDR_s1_reset_n => SEG7_ADDR_s1_reset_n,
      SEG7_ADDR_s1_write_n => SEG7_ADDR_s1_write_n,
      SEG7_ADDR_s1_writedata => SEG7_ADDR_s1_writedata,
      cpu_data_master_granted_SEG7_ADDR_s1 => cpu_data_master_granted_SEG7_ADDR_s1,
      cpu_data_master_qualified_request_SEG7_ADDR_s1 => cpu_data_master_qualified_request_SEG7_ADDR_s1,
      cpu_data_master_read_data_valid_SEG7_ADDR_s1 => cpu_data_master_read_data_valid_SEG7_ADDR_s1,
      cpu_data_master_requests_SEG7_ADDR_s1 => cpu_data_master_requests_SEG7_ADDR_s1,
      d1_SEG7_ADDR_s1_end_xfer => d1_SEG7_ADDR_s1_end_xfer,
      SEG7_ADDR_s1_readdata => SEG7_ADDR_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_SEG7_ADDR, which is an e_ptf_instance
  the_SEG7_ADDR : SEG7_ADDR
    port map(
      out_port => internal_out_port_from_the_SEG7_ADDR,
      readdata => SEG7_ADDR_s1_readdata,
      address => SEG7_ADDR_s1_address,
      chipselect => SEG7_ADDR_s1_chipselect,
      clk => clk,
      reset_n => SEG7_ADDR_s1_reset_n,
      write_n => SEG7_ADDR_s1_write_n,
      writedata => SEG7_ADDR_s1_writedata
    );


  --the_SEG7_DATA_s1, which is an e_instance
  the_SEG7_DATA_s1 : SEG7_DATA_s1_arbitrator
    port map(
      SEG7_DATA_s1_address => SEG7_DATA_s1_address,
      SEG7_DATA_s1_chipselect => SEG7_DATA_s1_chipselect,
      SEG7_DATA_s1_readdata_from_sa => SEG7_DATA_s1_readdata_from_sa,
      SEG7_DATA_s1_reset_n => SEG7_DATA_s1_reset_n,
      SEG7_DATA_s1_write_n => SEG7_DATA_s1_write_n,
      SEG7_DATA_s1_writedata => SEG7_DATA_s1_writedata,
      cpu_data_master_granted_SEG7_DATA_s1 => cpu_data_master_granted_SEG7_DATA_s1,
      cpu_data_master_qualified_request_SEG7_DATA_s1 => cpu_data_master_qualified_request_SEG7_DATA_s1,
      cpu_data_master_read_data_valid_SEG7_DATA_s1 => cpu_data_master_read_data_valid_SEG7_DATA_s1,
      cpu_data_master_requests_SEG7_DATA_s1 => cpu_data_master_requests_SEG7_DATA_s1,
      d1_SEG7_DATA_s1_end_xfer => d1_SEG7_DATA_s1_end_xfer,
      SEG7_DATA_s1_readdata => SEG7_DATA_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_SEG7_DATA, which is an e_ptf_instance
  the_SEG7_DATA : SEG7_DATA
    port map(
      out_port => internal_out_port_from_the_SEG7_DATA,
      readdata => SEG7_DATA_s1_readdata,
      address => SEG7_DATA_s1_address,
      chipselect => SEG7_DATA_s1_chipselect,
      clk => clk,
      reset_n => SEG7_DATA_s1_reset_n,
      write_n => SEG7_DATA_s1_write_n,
      writedata => SEG7_DATA_s1_writedata
    );


  --the_SW_s1, which is an e_instance
  the_SW_s1 : SW_s1_arbitrator
    port map(
      SW_s1_address => SW_s1_address,
      SW_s1_chipselect => SW_s1_chipselect,
      SW_s1_irq_from_sa => SW_s1_irq_from_sa,
      SW_s1_readdata_from_sa => SW_s1_readdata_from_sa,
      SW_s1_reset_n => SW_s1_reset_n,
      SW_s1_write_n => SW_s1_write_n,
      SW_s1_writedata => SW_s1_writedata,
      cpu_data_master_granted_SW_s1 => cpu_data_master_granted_SW_s1,
      cpu_data_master_qualified_request_SW_s1 => cpu_data_master_qualified_request_SW_s1,
      cpu_data_master_read_data_valid_SW_s1 => cpu_data_master_read_data_valid_SW_s1,
      cpu_data_master_requests_SW_s1 => cpu_data_master_requests_SW_s1,
      d1_SW_s1_end_xfer => d1_SW_s1_end_xfer,
      SW_s1_irq => SW_s1_irq,
      SW_s1_readdata => SW_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_SW, which is an e_ptf_instance
  the_SW : SW
    port map(
      irq => SW_s1_irq,
      readdata => SW_s1_readdata,
      address => SW_s1_address,
      chipselect => SW_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_SW,
      reset_n => SW_s1_reset_n,
      write_n => SW_s1_write_n,
      writedata => SW_s1_writedata
    );


  --the_cpu_jtag_debug_module, which is an e_instance
  the_cpu_jtag_debug_module : cpu_jtag_debug_module_arbitrator
    port map(
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_address => cpu_jtag_debug_module_address,
      cpu_jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      cpu_jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      cpu_jtag_debug_module_chipselect => cpu_jtag_debug_module_chipselect,
      cpu_jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      cpu_jtag_debug_module_reset_n => cpu_jtag_debug_module_reset_n,
      cpu_jtag_debug_module_resetrequest_from_sa => cpu_jtag_debug_module_resetrequest_from_sa,
      cpu_jtag_debug_module_write => cpu_jtag_debug_module_write,
      cpu_jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      cpu_jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  --the_cpu_data_master, which is an e_instance
  the_cpu_data_master : cpu_data_master_arbitrator
    port map(
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_readdatavalid => cpu_data_master_readdatavalid,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      LCD_control_slave_readdata_from_sa => LCD_control_slave_readdata_from_sa,
      LCD_control_slave_wait_counter_eq_0 => LCD_control_slave_wait_counter_eq_0,
      LEDG_s1_readdata_from_sa => LEDG_s1_readdata_from_sa,
      LEDR_s1_readdata_from_sa => LEDR_s1_readdata_from_sa,
      NIOS_B_s1_readdata_from_sa => NIOS_B_s1_readdata_from_sa,
      NIOS_G_s1_readdata_from_sa => NIOS_G_s1_readdata_from_sa,
      NIOS_R_s1_readdata_from_sa => NIOS_R_s1_readdata_from_sa,
      SEG7_ADDR_s1_readdata_from_sa => SEG7_ADDR_s1_readdata_from_sa,
      SEG7_DATA_s1_readdata_from_sa => SEG7_DATA_s1_readdata_from_sa,
      SW_s1_irq_from_sa => SW_s1_irq_from_sa,
      SW_s1_readdata_from_sa => SW_s1_readdata_from_sa,
      cfi_flash_0_s1_wait_counter_eq_0 => cfi_flash_0_s1_wait_counter_eq_0,
      clk => clk,
      cpu_data_master_address => cpu_data_master_address,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_byteenable_cfi_flash_0_s1 => cpu_data_master_byteenable_cfi_flash_0_s1,
      cpu_data_master_granted_LCD_control_slave => cpu_data_master_granted_LCD_control_slave,
      cpu_data_master_granted_LEDG_s1 => cpu_data_master_granted_LEDG_s1,
      cpu_data_master_granted_LEDR_s1 => cpu_data_master_granted_LEDR_s1,
      cpu_data_master_granted_NIOS_B_s1 => cpu_data_master_granted_NIOS_B_s1,
      cpu_data_master_granted_NIOS_G_s1 => cpu_data_master_granted_NIOS_G_s1,
      cpu_data_master_granted_NIOS_R_s1 => cpu_data_master_granted_NIOS_R_s1,
      cpu_data_master_granted_SEG7_ADDR_s1 => cpu_data_master_granted_SEG7_ADDR_s1,
      cpu_data_master_granted_SEG7_DATA_s1 => cpu_data_master_granted_SEG7_DATA_s1,
      cpu_data_master_granted_SW_s1 => cpu_data_master_granted_SW_s1,
      cpu_data_master_granted_cfi_flash_0_s1 => cpu_data_master_granted_cfi_flash_0_s1,
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_granted_fifo_req_s1 => cpu_data_master_granted_fifo_req_s1,
      cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_granted_onchip_memory2_0_s1 => cpu_data_master_granted_onchip_memory2_0_s1,
      cpu_data_master_granted_spi_0_spi_control_port => cpu_data_master_granted_spi_0_spi_control_port,
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_qualified_request_LCD_control_slave => cpu_data_master_qualified_request_LCD_control_slave,
      cpu_data_master_qualified_request_LEDG_s1 => cpu_data_master_qualified_request_LEDG_s1,
      cpu_data_master_qualified_request_LEDR_s1 => cpu_data_master_qualified_request_LEDR_s1,
      cpu_data_master_qualified_request_NIOS_B_s1 => cpu_data_master_qualified_request_NIOS_B_s1,
      cpu_data_master_qualified_request_NIOS_G_s1 => cpu_data_master_qualified_request_NIOS_G_s1,
      cpu_data_master_qualified_request_NIOS_R_s1 => cpu_data_master_qualified_request_NIOS_R_s1,
      cpu_data_master_qualified_request_SEG7_ADDR_s1 => cpu_data_master_qualified_request_SEG7_ADDR_s1,
      cpu_data_master_qualified_request_SEG7_DATA_s1 => cpu_data_master_qualified_request_SEG7_DATA_s1,
      cpu_data_master_qualified_request_SW_s1 => cpu_data_master_qualified_request_SW_s1,
      cpu_data_master_qualified_request_cfi_flash_0_s1 => cpu_data_master_qualified_request_cfi_flash_0_s1,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_fifo_req_s1 => cpu_data_master_qualified_request_fifo_req_s1,
      cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_qualified_request_onchip_memory2_0_s1 => cpu_data_master_qualified_request_onchip_memory2_0_s1,
      cpu_data_master_qualified_request_spi_0_spi_control_port => cpu_data_master_qualified_request_spi_0_spi_control_port,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_read_data_valid_LCD_control_slave => cpu_data_master_read_data_valid_LCD_control_slave,
      cpu_data_master_read_data_valid_LEDG_s1 => cpu_data_master_read_data_valid_LEDG_s1,
      cpu_data_master_read_data_valid_LEDR_s1 => cpu_data_master_read_data_valid_LEDR_s1,
      cpu_data_master_read_data_valid_NIOS_B_s1 => cpu_data_master_read_data_valid_NIOS_B_s1,
      cpu_data_master_read_data_valid_NIOS_G_s1 => cpu_data_master_read_data_valid_NIOS_G_s1,
      cpu_data_master_read_data_valid_NIOS_R_s1 => cpu_data_master_read_data_valid_NIOS_R_s1,
      cpu_data_master_read_data_valid_SEG7_ADDR_s1 => cpu_data_master_read_data_valid_SEG7_ADDR_s1,
      cpu_data_master_read_data_valid_SEG7_DATA_s1 => cpu_data_master_read_data_valid_SEG7_DATA_s1,
      cpu_data_master_read_data_valid_SW_s1 => cpu_data_master_read_data_valid_SW_s1,
      cpu_data_master_read_data_valid_cfi_flash_0_s1 => cpu_data_master_read_data_valid_cfi_flash_0_s1,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_fifo_req_s1 => cpu_data_master_read_data_valid_fifo_req_s1,
      cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_read_data_valid_onchip_memory2_0_s1 => cpu_data_master_read_data_valid_onchip_memory2_0_s1,
      cpu_data_master_read_data_valid_spi_0_spi_control_port => cpu_data_master_read_data_valid_spi_0_spi_control_port,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_requests_LCD_control_slave => cpu_data_master_requests_LCD_control_slave,
      cpu_data_master_requests_LEDG_s1 => cpu_data_master_requests_LEDG_s1,
      cpu_data_master_requests_LEDR_s1 => cpu_data_master_requests_LEDR_s1,
      cpu_data_master_requests_NIOS_B_s1 => cpu_data_master_requests_NIOS_B_s1,
      cpu_data_master_requests_NIOS_G_s1 => cpu_data_master_requests_NIOS_G_s1,
      cpu_data_master_requests_NIOS_R_s1 => cpu_data_master_requests_NIOS_R_s1,
      cpu_data_master_requests_SEG7_ADDR_s1 => cpu_data_master_requests_SEG7_ADDR_s1,
      cpu_data_master_requests_SEG7_DATA_s1 => cpu_data_master_requests_SEG7_DATA_s1,
      cpu_data_master_requests_SW_s1 => cpu_data_master_requests_SW_s1,
      cpu_data_master_requests_cfi_flash_0_s1 => cpu_data_master_requests_cfi_flash_0_s1,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_data_master_requests_fifo_req_s1 => cpu_data_master_requests_fifo_req_s1,
      cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_requests_onchip_memory2_0_s1 => cpu_data_master_requests_onchip_memory2_0_s1,
      cpu_data_master_requests_spi_0_spi_control_port => cpu_data_master_requests_spi_0_spi_control_port,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_LCD_control_slave_end_xfer => d1_LCD_control_slave_end_xfer,
      d1_LEDG_s1_end_xfer => d1_LEDG_s1_end_xfer,
      d1_LEDR_s1_end_xfer => d1_LEDR_s1_end_xfer,
      d1_NIOS_B_s1_end_xfer => d1_NIOS_B_s1_end_xfer,
      d1_NIOS_G_s1_end_xfer => d1_NIOS_G_s1_end_xfer,
      d1_NIOS_R_s1_end_xfer => d1_NIOS_R_s1_end_xfer,
      d1_SEG7_ADDR_s1_end_xfer => d1_SEG7_ADDR_s1_end_xfer,
      d1_SEG7_DATA_s1_end_xfer => d1_SEG7_DATA_s1_end_xfer,
      d1_SW_s1_end_xfer => d1_SW_s1_end_xfer,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_fifo_req_s1_end_xfer => d1_fifo_req_s1_end_xfer,
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer => d1_jtag_uart_0_avalon_jtag_slave_end_xfer,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      d1_spi_0_spi_control_port_end_xfer => d1_spi_0_spi_control_port_end_xfer,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      d1_tri_state_bridge_0_avalon_slave_end_xfer => d1_tri_state_bridge_0_avalon_slave_end_xfer,
      fifo_req_s1_readdata_from_sa => fifo_req_s1_readdata_from_sa,
      incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_0_data_with_Xs_converted_to_0,
      jtag_uart_0_avalon_jtag_slave_irq_from_sa => jtag_uart_0_avalon_jtag_slave_irq_from_sa,
      jtag_uart_0_avalon_jtag_slave_readdata_from_sa => jtag_uart_0_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      reset_n => clk_reset_n,
      spi_0_spi_control_port_irq_from_sa => spi_0_spi_control_port_irq_from_sa,
      spi_0_spi_control_port_readdata_from_sa => spi_0_spi_control_port_readdata_from_sa,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa
    );


  --the_cpu_instruction_master, which is an e_instance
  the_cpu_instruction_master : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_readdatavalid => cpu_instruction_master_readdatavalid,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      cfi_flash_0_s1_wait_counter_eq_0 => cfi_flash_0_s1_wait_counter_eq_0,
      clk => clk,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_instruction_master_granted_cfi_flash_0_s1 => cpu_instruction_master_granted_cfi_flash_0_s1,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_granted_onchip_memory2_0_s1 => cpu_instruction_master_granted_onchip_memory2_0_s1,
      cpu_instruction_master_qualified_request_cfi_flash_0_s1 => cpu_instruction_master_qualified_request_cfi_flash_0_s1,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_onchip_memory2_0_s1 => cpu_instruction_master_qualified_request_onchip_memory2_0_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_cfi_flash_0_s1 => cpu_instruction_master_read_data_valid_cfi_flash_0_s1,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 => cpu_instruction_master_read_data_valid_onchip_memory2_0_s1,
      cpu_instruction_master_requests_cfi_flash_0_s1 => cpu_instruction_master_requests_cfi_flash_0_s1,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_requests_onchip_memory2_0_s1 => cpu_instruction_master_requests_onchip_memory2_0_s1,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      d1_tri_state_bridge_0_avalon_slave_end_xfer => d1_tri_state_bridge_0_avalon_slave_end_xfer,
      incoming_tri_state_bridge_0_data => incoming_tri_state_bridge_0_data,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      reset_n => clk_reset_n
    );


  --the_cpu, which is an e_ptf_instance
  the_cpu : cpu
    port map(
      d_address => cpu_data_master_address,
      d_byteenable => cpu_data_master_byteenable,
      d_read => cpu_data_master_read,
      d_write => cpu_data_master_write,
      d_writedata => cpu_data_master_writedata,
      i_address => cpu_instruction_master_address,
      i_read => cpu_instruction_master_read,
      jtag_debug_module_debugaccess_to_roms => cpu_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      clk => clk,
      d_irq => cpu_data_master_irq,
      d_readdata => cpu_data_master_readdata,
      d_readdatavalid => cpu_data_master_readdatavalid,
      d_waitrequest => cpu_data_master_waitrequest,
      i_readdata => cpu_instruction_master_readdata,
      i_readdatavalid => cpu_instruction_master_readdatavalid,
      i_waitrequest => cpu_instruction_master_waitrequest,
      jtag_debug_module_address => cpu_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      jtag_debug_module_select => cpu_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      reset_n => cpu_jtag_debug_module_reset_n
    );


  --the_fifo_req_s1, which is an e_instance
  the_fifo_req_s1 : fifo_req_s1_arbitrator
    port map(
      cpu_data_master_granted_fifo_req_s1 => cpu_data_master_granted_fifo_req_s1,
      cpu_data_master_qualified_request_fifo_req_s1 => cpu_data_master_qualified_request_fifo_req_s1,
      cpu_data_master_read_data_valid_fifo_req_s1 => cpu_data_master_read_data_valid_fifo_req_s1,
      cpu_data_master_requests_fifo_req_s1 => cpu_data_master_requests_fifo_req_s1,
      d1_fifo_req_s1_end_xfer => d1_fifo_req_s1_end_xfer,
      fifo_req_s1_address => fifo_req_s1_address,
      fifo_req_s1_chipselect => fifo_req_s1_chipselect,
      fifo_req_s1_readdata_from_sa => fifo_req_s1_readdata_from_sa,
      fifo_req_s1_reset_n => fifo_req_s1_reset_n,
      fifo_req_s1_write_n => fifo_req_s1_write_n,
      fifo_req_s1_writedata => fifo_req_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      fifo_req_s1_readdata => fifo_req_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_fifo_req, which is an e_ptf_instance
  the_fifo_req : fifo_req
    port map(
      out_port => internal_out_port_from_the_fifo_req,
      readdata => fifo_req_s1_readdata,
      address => fifo_req_s1_address,
      chipselect => fifo_req_s1_chipselect,
      clk => clk,
      reset_n => fifo_req_s1_reset_n,
      write_n => fifo_req_s1_write_n,
      writedata => fifo_req_s1_writedata
    );


  --the_jtag_uart_0_avalon_jtag_slave, which is an e_instance
  the_jtag_uart_0_avalon_jtag_slave : jtag_uart_0_avalon_jtag_slave_arbitrator
    port map(
      cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave,
      cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_0_avalon_jtag_slave,
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer => d1_jtag_uart_0_avalon_jtag_slave_end_xfer,
      jtag_uart_0_avalon_jtag_slave_address => jtag_uart_0_avalon_jtag_slave_address,
      jtag_uart_0_avalon_jtag_slave_chipselect => jtag_uart_0_avalon_jtag_slave_chipselect,
      jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa => jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa,
      jtag_uart_0_avalon_jtag_slave_irq_from_sa => jtag_uart_0_avalon_jtag_slave_irq_from_sa,
      jtag_uart_0_avalon_jtag_slave_read_n => jtag_uart_0_avalon_jtag_slave_read_n,
      jtag_uart_0_avalon_jtag_slave_readdata_from_sa => jtag_uart_0_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa => jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa,
      jtag_uart_0_avalon_jtag_slave_reset_n => jtag_uart_0_avalon_jtag_slave_reset_n,
      jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa,
      jtag_uart_0_avalon_jtag_slave_write_n => jtag_uart_0_avalon_jtag_slave_write_n,
      jtag_uart_0_avalon_jtag_slave_writedata => jtag_uart_0_avalon_jtag_slave_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      jtag_uart_0_avalon_jtag_slave_dataavailable => jtag_uart_0_avalon_jtag_slave_dataavailable,
      jtag_uart_0_avalon_jtag_slave_irq => jtag_uart_0_avalon_jtag_slave_irq,
      jtag_uart_0_avalon_jtag_slave_readdata => jtag_uart_0_avalon_jtag_slave_readdata,
      jtag_uart_0_avalon_jtag_slave_readyfordata => jtag_uart_0_avalon_jtag_slave_readyfordata,
      jtag_uart_0_avalon_jtag_slave_waitrequest => jtag_uart_0_avalon_jtag_slave_waitrequest,
      reset_n => clk_reset_n
    );


  --the_jtag_uart_0, which is an e_ptf_instance
  the_jtag_uart_0 : jtag_uart_0
    port map(
      av_irq => jtag_uart_0_avalon_jtag_slave_irq,
      av_readdata => jtag_uart_0_avalon_jtag_slave_readdata,
      av_waitrequest => jtag_uart_0_avalon_jtag_slave_waitrequest,
      dataavailable => jtag_uart_0_avalon_jtag_slave_dataavailable,
      readyfordata => jtag_uart_0_avalon_jtag_slave_readyfordata,
      av_address => jtag_uart_0_avalon_jtag_slave_address,
      av_chipselect => jtag_uart_0_avalon_jtag_slave_chipselect,
      av_read_n => jtag_uart_0_avalon_jtag_slave_read_n,
      av_write_n => jtag_uart_0_avalon_jtag_slave_write_n,
      av_writedata => jtag_uart_0_avalon_jtag_slave_writedata,
      clk => clk,
      rst_n => jtag_uart_0_avalon_jtag_slave_reset_n
    );


  --the_onchip_memory2_0_s1, which is an e_instance
  the_onchip_memory2_0_s1 : onchip_memory2_0_s1_arbitrator
    port map(
      cpu_data_master_granted_onchip_memory2_0_s1 => cpu_data_master_granted_onchip_memory2_0_s1,
      cpu_data_master_qualified_request_onchip_memory2_0_s1 => cpu_data_master_qualified_request_onchip_memory2_0_s1,
      cpu_data_master_read_data_valid_onchip_memory2_0_s1 => cpu_data_master_read_data_valid_onchip_memory2_0_s1,
      cpu_data_master_requests_onchip_memory2_0_s1 => cpu_data_master_requests_onchip_memory2_0_s1,
      cpu_instruction_master_granted_onchip_memory2_0_s1 => cpu_instruction_master_granted_onchip_memory2_0_s1,
      cpu_instruction_master_qualified_request_onchip_memory2_0_s1 => cpu_instruction_master_qualified_request_onchip_memory2_0_s1,
      cpu_instruction_master_read_data_valid_onchip_memory2_0_s1 => cpu_instruction_master_read_data_valid_onchip_memory2_0_s1,
      cpu_instruction_master_requests_onchip_memory2_0_s1 => cpu_instruction_master_requests_onchip_memory2_0_s1,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      onchip_memory2_0_s1_address => onchip_memory2_0_s1_address,
      onchip_memory2_0_s1_byteenable => onchip_memory2_0_s1_byteenable,
      onchip_memory2_0_s1_chipselect => onchip_memory2_0_s1_chipselect,
      onchip_memory2_0_s1_clken => onchip_memory2_0_s1_clken,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      onchip_memory2_0_s1_write => onchip_memory2_0_s1_write,
      onchip_memory2_0_s1_writedata => onchip_memory2_0_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      onchip_memory2_0_s1_readdata => onchip_memory2_0_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_onchip_memory2_0, which is an e_ptf_instance
  the_onchip_memory2_0 : onchip_memory2_0
    port map(
      readdata => onchip_memory2_0_s1_readdata,
      address => onchip_memory2_0_s1_address,
      byteenable => onchip_memory2_0_s1_byteenable,
      chipselect => onchip_memory2_0_s1_chipselect,
      clk => clk,
      clken => onchip_memory2_0_s1_clken,
      write => onchip_memory2_0_s1_write,
      writedata => onchip_memory2_0_s1_writedata
    );


  --the_spi_0_spi_control_port, which is an e_instance
  the_spi_0_spi_control_port : spi_0_spi_control_port_arbitrator
    port map(
      cpu_data_master_granted_spi_0_spi_control_port => cpu_data_master_granted_spi_0_spi_control_port,
      cpu_data_master_qualified_request_spi_0_spi_control_port => cpu_data_master_qualified_request_spi_0_spi_control_port,
      cpu_data_master_read_data_valid_spi_0_spi_control_port => cpu_data_master_read_data_valid_spi_0_spi_control_port,
      cpu_data_master_requests_spi_0_spi_control_port => cpu_data_master_requests_spi_0_spi_control_port,
      d1_spi_0_spi_control_port_end_xfer => d1_spi_0_spi_control_port_end_xfer,
      spi_0_spi_control_port_address => spi_0_spi_control_port_address,
      spi_0_spi_control_port_chipselect => spi_0_spi_control_port_chipselect,
      spi_0_spi_control_port_dataavailable_from_sa => spi_0_spi_control_port_dataavailable_from_sa,
      spi_0_spi_control_port_endofpacket_from_sa => spi_0_spi_control_port_endofpacket_from_sa,
      spi_0_spi_control_port_irq_from_sa => spi_0_spi_control_port_irq_from_sa,
      spi_0_spi_control_port_read_n => spi_0_spi_control_port_read_n,
      spi_0_spi_control_port_readdata_from_sa => spi_0_spi_control_port_readdata_from_sa,
      spi_0_spi_control_port_readyfordata_from_sa => spi_0_spi_control_port_readyfordata_from_sa,
      spi_0_spi_control_port_reset_n => spi_0_spi_control_port_reset_n,
      spi_0_spi_control_port_write_n => spi_0_spi_control_port_write_n,
      spi_0_spi_control_port_writedata => spi_0_spi_control_port_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      spi_0_spi_control_port_dataavailable => spi_0_spi_control_port_dataavailable,
      spi_0_spi_control_port_endofpacket => spi_0_spi_control_port_endofpacket,
      spi_0_spi_control_port_irq => spi_0_spi_control_port_irq,
      spi_0_spi_control_port_readdata => spi_0_spi_control_port_readdata,
      spi_0_spi_control_port_readyfordata => spi_0_spi_control_port_readyfordata
    );


  --the_spi_0, which is an e_ptf_instance
  the_spi_0 : spi_0
    port map(
      MOSI => internal_MOSI_from_the_spi_0,
      SCLK => internal_SCLK_from_the_spi_0,
      SS_n => internal_SS_n_from_the_spi_0,
      data_to_cpu => spi_0_spi_control_port_readdata,
      dataavailable => spi_0_spi_control_port_dataavailable,
      endofpacket => spi_0_spi_control_port_endofpacket,
      irq => spi_0_spi_control_port_irq,
      readyfordata => spi_0_spi_control_port_readyfordata,
      MISO => MISO_to_the_spi_0,
      clk => clk,
      data_from_cpu => spi_0_spi_control_port_writedata,
      mem_addr => spi_0_spi_control_port_address,
      read_n => spi_0_spi_control_port_read_n,
      reset_n => spi_0_spi_control_port_reset_n,
      spi_select => spi_0_spi_control_port_chipselect,
      write_n => spi_0_spi_control_port_write_n
    );


  --the_sysid_control_slave, which is an e_instance
  the_sysid_control_slave : sysid_control_slave_arbitrator
    port map(
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      sysid_control_slave_address => sysid_control_slave_address,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata => sysid_control_slave_readdata
    );


  --the_sysid, which is an e_ptf_instance
  the_sysid : sysid
    port map(
      readdata => sysid_control_slave_readdata,
      address => sysid_control_slave_address
    );


  --the_tri_state_bridge_0_avalon_slave, which is an e_instance
  the_tri_state_bridge_0_avalon_slave : tri_state_bridge_0_avalon_slave_arbitrator
    port map(
      address_to_the_cfi_flash_0 => internal_address_to_the_cfi_flash_0,
      cfi_flash_0_s1_wait_counter_eq_0 => cfi_flash_0_s1_wait_counter_eq_0,
      cpu_data_master_byteenable_cfi_flash_0_s1 => cpu_data_master_byteenable_cfi_flash_0_s1,
      cpu_data_master_granted_cfi_flash_0_s1 => cpu_data_master_granted_cfi_flash_0_s1,
      cpu_data_master_qualified_request_cfi_flash_0_s1 => cpu_data_master_qualified_request_cfi_flash_0_s1,
      cpu_data_master_read_data_valid_cfi_flash_0_s1 => cpu_data_master_read_data_valid_cfi_flash_0_s1,
      cpu_data_master_requests_cfi_flash_0_s1 => cpu_data_master_requests_cfi_flash_0_s1,
      cpu_instruction_master_granted_cfi_flash_0_s1 => cpu_instruction_master_granted_cfi_flash_0_s1,
      cpu_instruction_master_qualified_request_cfi_flash_0_s1 => cpu_instruction_master_qualified_request_cfi_flash_0_s1,
      cpu_instruction_master_read_data_valid_cfi_flash_0_s1 => cpu_instruction_master_read_data_valid_cfi_flash_0_s1,
      cpu_instruction_master_requests_cfi_flash_0_s1 => cpu_instruction_master_requests_cfi_flash_0_s1,
      d1_tri_state_bridge_0_avalon_slave_end_xfer => d1_tri_state_bridge_0_avalon_slave_end_xfer,
      incoming_tri_state_bridge_0_data => incoming_tri_state_bridge_0_data,
      incoming_tri_state_bridge_0_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_0_data_with_Xs_converted_to_0,
      read_n_to_the_cfi_flash_0 => internal_read_n_to_the_cfi_flash_0,
      select_n_to_the_cfi_flash_0 => internal_select_n_to_the_cfi_flash_0,
      tri_state_bridge_0_data => tri_state_bridge_0_data,
      write_n_to_the_cfi_flash_0 => internal_write_n_to_the_cfi_flash_0,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_latency_counter => cpu_data_master_latency_counter,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      reset_n => clk_reset_n
    );


  --reset is asserted asynchronously and deasserted synchronously
  nios_system_reset_clk_domain_synch : nios_system_reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk => clk,
      data_in => module_input,
      reset_n => reset_n_sources
    );

  module_input <= std_logic'('1');

  --reset sources mux, which is an e_mux
  reset_n_sources <= Vector_To_Std_Logic(NOT (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT reset_n))) OR std_logic_vector'("00000000000000000000000000000000")) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa)))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa))))));
  --vhdl renameroo for output signals
  LCD_E_from_the_LCD <= internal_LCD_E_from_the_LCD;
  --vhdl renameroo for output signals
  LCD_RS_from_the_LCD <= internal_LCD_RS_from_the_LCD;
  --vhdl renameroo for output signals
  LCD_RW_from_the_LCD <= internal_LCD_RW_from_the_LCD;
  --vhdl renameroo for output signals
  MOSI_from_the_spi_0 <= internal_MOSI_from_the_spi_0;
  --vhdl renameroo for output signals
  SCLK_from_the_spi_0 <= internal_SCLK_from_the_spi_0;
  --vhdl renameroo for output signals
  SS_n_from_the_spi_0 <= internal_SS_n_from_the_spi_0;
  --vhdl renameroo for output signals
  address_to_the_cfi_flash_0 <= internal_address_to_the_cfi_flash_0;
  --vhdl renameroo for output signals
  out_port_from_the_LEDG <= internal_out_port_from_the_LEDG;
  --vhdl renameroo for output signals
  out_port_from_the_LEDR <= internal_out_port_from_the_LEDR;
  --vhdl renameroo for output signals
  out_port_from_the_NIOS_B <= internal_out_port_from_the_NIOS_B;
  --vhdl renameroo for output signals
  out_port_from_the_NIOS_G <= internal_out_port_from_the_NIOS_G;
  --vhdl renameroo for output signals
  out_port_from_the_NIOS_R <= internal_out_port_from_the_NIOS_R;
  --vhdl renameroo for output signals
  out_port_from_the_SEG7_ADDR <= internal_out_port_from_the_SEG7_ADDR;
  --vhdl renameroo for output signals
  out_port_from_the_SEG7_DATA <= internal_out_port_from_the_SEG7_DATA;
  --vhdl renameroo for output signals
  out_port_from_the_fifo_req <= internal_out_port_from_the_fifo_req;
  --vhdl renameroo for output signals
  read_n_to_the_cfi_flash_0 <= internal_read_n_to_the_cfi_flash_0;
  --vhdl renameroo for output signals
  select_n_to_the_cfi_flash_0 <= internal_select_n_to_the_cfi_flash_0;
  --vhdl renameroo for output signals
  write_n_to_the_cfi_flash_0 <= internal_write_n_to_the_cfi_flash_0;

end europa;


--synthesis translate_off

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cfi_flash_0_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity cfi_flash_0_lane0_module;


architecture europa of cfi_flash_0_lane0_module is
              signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 4194303 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (21 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;

    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (21 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "cfi_flash_0.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 4194304) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera;
--use altera.altera_europa_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity cfi_flash_0_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity cfi_flash_0_lane0_module;
--
--
--architecture europa of cfi_flash_0_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal rdaddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
--        signal wren : IN STD_LOGIC;
--        signal wrclock : IN STD_LOGIC;
--        signal wraddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 4194303 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (21 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      read_address <= rdaddress;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "cfi_flash_0.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 22,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q;
--end europa;
--
--synthesis read_comments_as_HDL off


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cfi_flash_0 is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity cfi_flash_0;


architecture europa of cfi_flash_0 is
--synthesis translate_off
component cfi_flash_0_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component cfi_flash_0_lane0_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal module_input1 :  STD_LOGIC;
                signal module_input2 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --s1, which is an e_ptf_slave
--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    --cfi_flash_0_lane0, which is an e_ram
    cfi_flash_0_lane0 : cfi_flash_0_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input1,
        wraddress => address,
        wrclock => write_n,
        wren => module_input2
      );

    module_input1 <= std_logic'('1');
    module_input2 <= NOT select_n;

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), q_0, A_REP(std_logic'('Z'), 8));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component nios_system is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_LCD
                    signal LCD_E_from_the_LCD : OUT STD_LOGIC;
                    signal LCD_RS_from_the_LCD : OUT STD_LOGIC;
                    signal LCD_RW_from_the_LCD : OUT STD_LOGIC;
                    signal LCD_data_to_and_from_the_LCD : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_LEDG
                    signal out_port_from_the_LEDG : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_LEDR
                    signal out_port_from_the_LEDR : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- the_NIOS_B
                    signal out_port_from_the_NIOS_B : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_NIOS_G
                    signal out_port_from_the_NIOS_G : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_NIOS_R
                    signal out_port_from_the_NIOS_R : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_SEG7_ADDR
                    signal out_port_from_the_SEG7_ADDR : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- the_SEG7_DATA
                    signal out_port_from_the_SEG7_DATA : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- the_SW
                    signal in_port_to_the_SW : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_fifo_req
                    signal out_port_from_the_fifo_req : OUT STD_LOGIC;

                 -- the_spi_0
                    signal MISO_to_the_spi_0 : IN STD_LOGIC;
                    signal MOSI_from_the_spi_0 : OUT STD_LOGIC;
                    signal SCLK_from_the_spi_0 : OUT STD_LOGIC;
                    signal SS_n_from_the_spi_0 : OUT STD_LOGIC;

                 -- the_tri_state_bridge_0_avalon_slave
                    signal address_to_the_cfi_flash_0 : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal read_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                    signal select_n_to_the_cfi_flash_0 : OUT STD_LOGIC;
                    signal tri_state_bridge_0_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal write_n_to_the_cfi_flash_0 : OUT STD_LOGIC
                 );
end component nios_system;

component cfi_flash_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component cfi_flash_0;

                signal LCD_E_from_the_LCD :  STD_LOGIC;
                signal LCD_RS_from_the_LCD :  STD_LOGIC;
                signal LCD_RW_from_the_LCD :  STD_LOGIC;
                signal LCD_data_to_and_from_the_LCD :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal MISO_to_the_spi_0 :  STD_LOGIC;
                signal MOSI_from_the_spi_0 :  STD_LOGIC;
                signal SCLK_from_the_spi_0 :  STD_LOGIC;
                signal SS_n_from_the_spi_0 :  STD_LOGIC;
                signal address_to_the_cfi_flash_0 :  STD_LOGIC_VECTOR (21 DOWNTO 0);
                signal clk :  STD_LOGIC;
                signal in_port_to_the_SW :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal out_port_from_the_LEDG :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_LEDR :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal out_port_from_the_NIOS_B :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_NIOS_G :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_NIOS_R :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_SEG7_ADDR :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal out_port_from_the_SEG7_DATA :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal out_port_from_the_fifo_req :  STD_LOGIC;
                signal read_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal reset_n :  STD_LOGIC;
                signal select_n_to_the_cfi_flash_0 :  STD_LOGIC;
                signal spi_0_spi_control_port_dataavailable_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_endofpacket_from_sa :  STD_LOGIC;
                signal spi_0_spi_control_port_readyfordata_from_sa :  STD_LOGIC;
                signal tri_state_bridge_0_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal write_n_to_the_cfi_flash_0 :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  --Set us up the Dut
  DUT : nios_system
    port map(
      LCD_E_from_the_LCD => LCD_E_from_the_LCD,
      LCD_RS_from_the_LCD => LCD_RS_from_the_LCD,
      LCD_RW_from_the_LCD => LCD_RW_from_the_LCD,
      LCD_data_to_and_from_the_LCD => LCD_data_to_and_from_the_LCD,
      MOSI_from_the_spi_0 => MOSI_from_the_spi_0,
      SCLK_from_the_spi_0 => SCLK_from_the_spi_0,
      SS_n_from_the_spi_0 => SS_n_from_the_spi_0,
      address_to_the_cfi_flash_0 => address_to_the_cfi_flash_0,
      out_port_from_the_LEDG => out_port_from_the_LEDG,
      out_port_from_the_LEDR => out_port_from_the_LEDR,
      out_port_from_the_NIOS_B => out_port_from_the_NIOS_B,
      out_port_from_the_NIOS_G => out_port_from_the_NIOS_G,
      out_port_from_the_NIOS_R => out_port_from_the_NIOS_R,
      out_port_from_the_SEG7_ADDR => out_port_from_the_SEG7_ADDR,
      out_port_from_the_SEG7_DATA => out_port_from_the_SEG7_DATA,
      out_port_from_the_fifo_req => out_port_from_the_fifo_req,
      read_n_to_the_cfi_flash_0 => read_n_to_the_cfi_flash_0,
      select_n_to_the_cfi_flash_0 => select_n_to_the_cfi_flash_0,
      tri_state_bridge_0_data => tri_state_bridge_0_data,
      write_n_to_the_cfi_flash_0 => write_n_to_the_cfi_flash_0,
      MISO_to_the_spi_0 => MISO_to_the_spi_0,
      clk => clk,
      in_port_to_the_SW => in_port_to_the_SW,
      reset_n => reset_n
    );


  --the_cfi_flash_0, which is an e_ptf_instance
  the_cfi_flash_0 : cfi_flash_0
    port map(
      data => tri_state_bridge_0_data,
      address => address_to_the_cfi_flash_0,
      read_n => read_n_to_the_cfi_flash_0,
      select_n => select_n_to_the_cfi_flash_0,
      write_n => write_n_to_the_cfi_flash_0
    );


  process
  begin
    clk <= '0';
    loop
       wait for 5 ns;
       clk <= not clk;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 100 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
